/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/radv/config.Y */

#include "proto/radv/radv.h"

/* Defines from ../../proto/radv/config.Y */

#define RADV_CFG ((struct radv_config *) this_proto)
#define RADV_IFACE ((struct radv_iface_config *) this_ipatt)
#define RADV_PREFIX this_radv_prefix
#define RADV_RDNSS (&this_radv_rdnss)
#define RADV_DNSSL (&this_radv_dnssl)

static struct radv_prefix_config *this_radv_prefix;
static struct radv_rdnss_config this_radv_rdnss;
static struct radv_dnssl_config this_radv_dnssl;
static list radv_dns_list;	/* Used by radv_rdnss and radv_dnssl */
static u8 radv_mult_val;	/* Used by radv_mult for second return value */


/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 613 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    PORT = 285,
    LOG = 286,
    SYSLOG = 287,
    ALL = 288,
    DEBUG = 289,
    TRACE = 290,
    INFO = 291,
    REMOTE = 292,
    WARNING = 293,
    ERROR = 294,
    AUTH = 295,
    FATAL = 296,
    BUG = 297,
    STDERR = 298,
    SOFT = 299,
    TIMEFORMAT = 300,
    ISO = 301,
    OLD = 302,
    SHORT = 303,
    LONG = 304,
    BASE = 305,
    NAME = 306,
    CONFIRM = 307,
    UNDO = 308,
    CHECK = 309,
    TIMEOUT = 310,
    LATENCY = 311,
    LIMIT = 312,
    WATCHDOG = 313,
    CONFIGURE = 314,
    DOWN = 315,
    KERNEL = 316,
    PERSIST = 317,
    SCAN = 318,
    TIME = 319,
    LEARN = 320,
    DEVICE = 321,
    ROUTES = 322,
    GRACEFUL = 323,
    RESTART = 324,
    KRT_SOURCE = 325,
    KRT_METRIC = 326,
    TABLE = 327,
    KRT_PREFSRC = 328,
    KRT_REALM = 329,
    ROUTER = 330,
    ID = 331,
    PROTOCOL = 332,
    TEMPLATE = 333,
    PREFERENCE = 334,
    DISABLED = 335,
    DIRECT = 336,
    INTERFACE = 337,
    IMPORT = 338,
    EXPORT = 339,
    FILTER = 340,
    NONE = 341,
    STATES = 342,
    FILTERS = 343,
    RECEIVE = 344,
    ACTION = 345,
    WARN = 346,
    BLOCK = 347,
    DISABLE = 348,
    KEEP = 349,
    FILTERED = 350,
    PASSWORD = 351,
    FROM = 352,
    PASSIVE = 353,
    TO = 354,
    EVENTS = 355,
    PACKETS = 356,
    PROTOCOLS = 357,
    INTERFACES = 358,
    PRIMARY = 359,
    STATS = 360,
    COUNT = 361,
    FOR = 362,
    COMMANDS = 363,
    PREEXPORT = 364,
    NOEXPORT = 365,
    GENERATE = 366,
    ROA = 367,
    LISTEN = 368,
    BGP = 369,
    V6ONLY = 370,
    DUAL = 371,
    ADDRESS = 372,
    PASSWORDS = 373,
    DESCRIPTION = 374,
    SORTED = 375,
    RELOAD = 376,
    IN = 377,
    OUT = 378,
    MRTDUMP = 379,
    MESSAGES = 380,
    RESTRICT = 381,
    MEMORY = 382,
    IGP_METRIC = 383,
    CLASS = 384,
    DSCP = 385,
    WAIT = 386,
    MAX = 387,
    FLUSH = 388,
    AS = 389,
    SHOW = 390,
    STATUS = 391,
    SUMMARY = 392,
    ROUTE = 393,
    SYMBOLS = 394,
    ADD = 395,
    DELETE = 396,
    DUMP = 397,
    RESOURCES = 398,
    SOCKETS = 399,
    NEIGHBORS = 400,
    ATTRIBUTES = 401,
    EVAL = 402,
    ECHO = 403,
    ENABLE = 404,
    FUNCTION = 405,
    PRINT = 406,
    PRINTN = 407,
    UNSET = 408,
    RETURN = 409,
    ACCEPT = 410,
    REJECT = 411,
    QUITBIRD = 412,
    INT = 413,
    BOOL = 414,
    IP = 415,
    PREFIX = 416,
    PAIR = 417,
    QUAD = 418,
    EC = 419,
    SET = 420,
    STRING = 421,
    BGPMASK = 422,
    BGPPATH = 423,
    CLIST = 424,
    ECLIST = 425,
    IF = 426,
    THEN = 427,
    ELSE = 428,
    CASE = 429,
    TRUE = 430,
    FALSE = 431,
    RT = 432,
    RO = 433,
    UNKNOWN = 434,
    GENERIC = 435,
    GW = 436,
    NET = 437,
    MASK = 438,
    PROTO = 439,
    SOURCE = 440,
    SCOPE = 441,
    CAST = 442,
    DEST = 443,
    IFNAME = 444,
    IFINDEX = 445,
    LEN = 446,
    DEFINED = 447,
    CONTAINS = 448,
    RESET = 449,
    PREPEND = 450,
    FIRST = 451,
    LAST = 452,
    MATCH = 453,
    ROA_CHECK = 454,
    EMPTY = 455,
    WHERE = 456,
    BFD = 457,
    MIN = 458,
    IDLE = 459,
    RX = 460,
    TX = 461,
    INTERVAL = 462,
    MULTIPLIER = 463,
    MULTIHOP = 464,
    NEIGHBOR = 465,
    DEV = 466,
    LOCAL = 467,
    SESSIONS = 468,
    HOLD = 469,
    CONNECT = 470,
    RETRY = 471,
    KEEPALIVE = 472,
    STARTUP = 473,
    VIA = 474,
    NEXT = 475,
    HOP = 476,
    SELF = 477,
    DEFAULT = 478,
    PATH = 479,
    METRIC = 480,
    START = 481,
    DELAY = 482,
    FORGET = 483,
    AFTER = 484,
    BGP_PATH = 485,
    BGP_LOCAL_PREF = 486,
    BGP_MED = 487,
    BGP_ORIGIN = 488,
    BGP_NEXT_HOP = 489,
    BGP_ATOMIC_AGGR = 490,
    BGP_AGGREGATOR = 491,
    BGP_COMMUNITY = 492,
    BGP_EXT_COMMUNITY = 493,
    RR = 494,
    RS = 495,
    CLIENT = 496,
    CLUSTER = 497,
    AS4 = 498,
    ADVERTISE = 499,
    IPV4 = 500,
    CAPABILITIES = 501,
    PREFER = 502,
    OLDER = 503,
    MISSING = 504,
    LLADDR = 505,
    DROP = 506,
    IGNORE = 507,
    REFRESH = 508,
    INTERPRET = 509,
    COMMUNITIES = 510,
    BGP_ORIGINATOR_ID = 511,
    BGP_CLUSTER_LIST = 512,
    IGP = 513,
    GATEWAY = 514,
    RECURSIVE = 515,
    MED = 516,
    TTL = 517,
    SECURITY = 518,
    DETERMINISTIC = 519,
    SECONDARY = 520,
    ALLOW = 521,
    PATHS = 522,
    AWARE = 523,
    LINK = 524,
    OSPF = 525,
    AREA = 526,
    OSPF_METRIC1 = 527,
    OSPF_METRIC2 = 528,
    OSPF_TAG = 529,
    OSPF_ROUTER_ID = 530,
    RFC1583COMPAT = 531,
    STUB = 532,
    TICK = 533,
    COST = 534,
    COST2 = 535,
    RETRANSMIT = 536,
    HELLO = 537,
    TRANSMIT = 538,
    PRIORITY = 539,
    DEAD = 540,
    TYPE = 541,
    BROADCAST = 542,
    BCAST = 543,
    NONBROADCAST = 544,
    NBMA = 545,
    POINTOPOINT = 546,
    PTP = 547,
    POINTOMULTIPOINT = 548,
    PTMP = 549,
    SIMPLE = 550,
    AUTHENTICATION = 551,
    STRICT = 552,
    CRYPTOGRAPHIC = 553,
    ELIGIBLE = 554,
    POLL = 555,
    NETWORKS = 556,
    HIDDEN = 557,
    VIRTUAL = 558,
    ONLY = 559,
    BUFFER = 560,
    LARGE = 561,
    NORMAL = 562,
    STUBNET = 563,
    TAG = 564,
    EXTERNAL = 565,
    LSADB = 566,
    ECMP = 567,
    WEIGHT = 568,
    NSSA = 569,
    TRANSLATOR = 570,
    STABILITY = 571,
    GLOBAL = 572,
    LSID = 573,
    INSTANCE = 574,
    REAL = 575,
    NETMASK = 576,
    LENGTH = 577,
    MERGE = 578,
    LSA = 579,
    SUPPRESSION = 580,
    TOPOLOGY = 581,
    STATE = 582,
    PIPE = 583,
    PEER = 584,
    MODE = 585,
    OPAQUE = 586,
    TRANSPARENT = 587,
    RADV = 588,
    RA = 589,
    MANAGED = 590,
    OTHER = 591,
    CONFIG = 592,
    MTU = 593,
    REACHABLE = 594,
    RETRANS = 595,
    TIMER = 596,
    CURRENT = 597,
    VALID = 598,
    PREFERRED = 599,
    MULT = 600,
    LIFETIME = 601,
    SKIP = 602,
    ONLINK = 603,
    AUTONOMOUS = 604,
    RDNSS = 605,
    DNSSL = 606,
    NS = 607,
    DOMAIN = 608,
    TRIGGER = 609,
    SENSITIVE = 610,
    LOW = 611,
    MEDIUM = 612,
    HIGH = 613,
    RIP = 614,
    INFINITY = 615,
    PERIOD = 616,
    GARBAGE = 617,
    MULTICAST = 618,
    QUIET = 619,
    NOLISTEN = 620,
    VERSION1 = 621,
    PLAINTEXT = 622,
    MD5 = 623,
    HONOR = 624,
    NEVER = 625,
    ALWAYS = 626,
    RIP_METRIC = 627,
    RIP_TAG = 628,
    STATIC = 629,
    PROHIBIT = 630,
    MULTIPATH = 631,
    BLACKHOLE = 632,
    UNREACHABLE = 633
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 542 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1059 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1076 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2981

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  400
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  294
/* YYNRULES -- Number of rules.  */
#define YYNRULES  930
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1751

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   633

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     391,   392,    28,    26,   396,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   393,   390,
      23,    22,    24,   397,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   398,     2,   399,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   394,     2,   395,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   388,   389
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   738,   738,   739,   742,   744,   752,   761,   762,   763,
     770,   771,   772,   780,   781,   782,   783,   784,   785,   791,
     792,   799,   800,   804,   811,   812,   816,   820,   827,   835,
     836,   843,   844,   850,   859,   860,   864,   869,   870,   874,
     875,   879,   880,   884,   885,   886,   887,   888,   889,   890,
     891,   892,   898,   899,   909,   910,   911,   912,   915,   916,
     917,   918,   919,   920,   924,   930,   931,   932,   933,   941,
     944,   951,   954,   957,   960,   964,   965,   969,   970,   971,
     979,   984,   985,   989,   996,   997,  1003,  1008,  1012,  1026,
    1040,  1041,  1045,  1046,  1047,  1058,  1060,  1062,  1066,  1067,
    1068,  1069,  1074,  1080,  1081,  1085,  1093,  1097,  1099,  1105,
    1106,  1113,  1114,  1118,  1124,  1128,  1134,  1144,  1146,  1150,
    1151,  1152,  1153,  1154,  1155,  1156,  1157,  1158,  1159,  1160,
    1161,  1165,  1166,  1167,  1168,  1172,  1173,  1174,  1175,  1176,
    1180,  1186,  1190,  1198,  1199,  1207,  1215,  1216,  1217,  1221,
    1222,  1226,  1231,  1232,  1236,  1238,  1246,  1250,  1251,  1257,
    1264,  1265,  1266,  1270,  1278,  1284,  1285,  1286,  1290,  1291,
    1295,  1296,  1297,  1298,  1299,  1300,  1306,  1307,  1308,  1312,
    1313,  1317,  1318,  1324,  1325,  1328,  1330,  1334,  1335,  1339,
    1357,  1358,  1359,  1360,  1361,  1362,  1370,  1373,  1376,  1379,
    1383,  1384,  1387,  1390,  1394,  1398,  1403,  1409,  1416,  1421,
    1426,  1431,  1435,  1439,  1443,  1452,  1460,  1464,  1471,  1472,
    1473,  1478,  1482,  1489,  1496,  1500,  1508,  1509,  1510,  1515,
    1519,  1522,  1523,  1524,  1525,  1526,  1527,  1528,  1533,  1538,
    1546,  1553,  1560,  1568,  1570,  1572,  1574,  1576,  1578,  1580,
    1582,  1585,  1589,  1595,  1596,  1597,  1601,  1602,  1608,  1610,
    1612,  1614,  1616,  1618,  1622,  1626,  1629,  1633,  1634,  1635,
    1639,  1640,  1641,  1649,  1649,  1659,  1663,  1664,  1665,  1666,
    1667,  1668,  1669,  1670,  1671,  1672,  1673,  1674,  1675,  1696,
    1707,  1708,  1715,  1716,  1723,  1732,  1736,  1740,  1764,  1765,
    1769,  1782,  1782,  1798,  1799,  1802,  1803,  1807,  1810,  1819,
    1832,  1833,  1834,  1835,  1836,  1840,  1848,  1849,  1850,  1851,
    1852,  1856,  1859,  1860,  1861,  1865,  1868,  1877,  1880,  1881,
    1882,  1883,  1887,  1888,  1889,  1893,  1894,  1895,  1896,  1900,
    1901,  1902,  1903,  1907,  1908,  1912,  1913,  1917,  1924,  1925,
    1926,  1927,  1934,  1935,  1938,  1939,  1946,  1958,  1959,  1963,
    1964,  1968,  1969,  1970,  1971,  1972,  1976,  1977,  1978,  1982,
    1983,  1984,  1985,  1986,  1987,  1988,  1989,  1990,  1991,  1992,
    1996,  1997,  2007,  2011,  2034,  2048,  2049,  2050,  2051,  2052,
    2053,  2054,  2055,  2056,  2057,  2061,  2062,  2063,  2064,  2065,
    2066,  2067,  2068,  2069,  2070,  2071,  2072,  2073,  2074,  2075,
    2076,  2078,  2079,  2080,  2082,  2084,  2086,  2088,  2089,  2090,
    2091,  2092,  2102,  2103,  2104,  2105,  2106,  2107,  2108,  2110,
    2111,  2116,  2139,  2140,  2141,  2142,  2143,  2144,  2148,  2151,
    2152,  2153,  2161,  2168,  2177,  2178,  2182,  2188,  2198,  2207,
    2213,  2218,  2225,  2230,  2236,  2237,  2238,  2246,  2247,  2248,
    2249,  2250,  2256,  2268,  2269,  2270,  2271,  2274,  2276,  2280,
    2284,  2295,  2296,  2297,  2298,  2299,  2300,  2303,  2305,  2308,
    2310,  2313,  2316,  2321,  2322,  2323,  2327,  2328,  2332,  2333,
    2336,  2355,  2361,  2385,  2387,  2388,  2392,  2393,  2394,  2395,
    2396,  2397,  2403,  2404,  2405,  2406,  2407,  2408,  2409,  2410,
    2411,  2412,  2413,  2414,  2415,  2416,  2417,  2418,  2419,  2420,
    2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,
    2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2445,
    2446,  2447,  2448,  2449,  2450,  2451,  2452,  2453,  2454,  2455,
    2456,  2457,  2458,  2459,  2470,  2480,  2481,  2485,  2486,  2487,
    2488,  2489,  2490,  2491,  2492,  2493,  2496,  2511,  2514,  2516,
    2520,  2521,  2522,  2523,  2524,  2525,  2526,  2527,  2528,  2529,
    2529,  2530,  2530,  2531,  2532,  2533,  2537,  2538,  2542,  2550,
    2552,  2556,  2557,  2558,  2562,  2563,  2566,  2568,  2571,  2572,
    2573,  2574,  2575,  2576,  2577,  2578,  2579,  2580,  2581,  2584,
    2604,  2605,  2606,  2607,  2608,  2609,  2610,  2611,  2612,  2613,
    2614,  2615,  2616,  2617,  2618,  2619,  2620,  2621,  2622,  2623,
    2624,  2625,  2626,  2627,  2628,  2629,  2630,  2631,  2632,  2633,
    2634,  2635,  2636,  2637,  2638,  2639,  2640,  2641,  2642,  2645,
    2647,  2650,  2652,  2661,  2663,  2664,  2667,  2669,  2673,  2674,
    2677,  2687,  2708,  2710,  2714,  2714,  2717,  2719,  2722,  2724,
    2728,  2732,  2733,  2738,  2741,  2744,  2749,  2752,  2757,  2760,
    2764,  2768,  2771,  2772,  2773,  2774,  2775,  2776,  2777,  2778,
    2784,  2791,  2792,  2793,  2798,  2799,  2805,  2815,  2816,  2817,
    2818,  2818,  2819,  2819,  2820,  2827,  2829,  2833,  2837,  2855,
    2856,  2857,  2858,  2859,  2860,  2861,  2862,  2863,  2864,  2869,
    2870,  2871,  2871,  2872,  2872,  2873,  2874,  2878,  2879,  2880,
    2883,  2901,  2903,  2906,  2908,  2912,  2915,  2928,  2929,  2930,
    2931,  2936,  2944,  2952,  2954,  2957,  2959,  2963,  2967,  2977,
    2982,  2983,  2984,  2988,  3000,  3002,  3006,  3007,  3011,  3024,
    3029,  3030,  3031,  3035,  3047,  3049,  3053,  3054,  3059,  3060,
    3064,  3065,  3071,  3078,  3079,  3080,  3081,  3082,  3083,  3084,
    3085,  3086,  3087,  3088,  3089,  3090,  3094,  3095,  3096,  3101,
    3102,  3103,  3104,  3105,  3108,  3109,  3110,  3111,  3112,  3113,
    3114,  3117,  3119,  3122,  3124,  3128,  3140,  3147,  3154,  3155,
    3156,  3157,  3158,  3161,  3170,  3178,  3185,  3186,  3190,  3195,
    3201,  3204,  3209,  3210,  3211,  3212,  3213,  3216,  3223,  3223,
    3223,  3223,  3223,  3223,  3223,  3223,  3223,  3223,  3223,  3223,
    3223,  3223,  3223,  3223,  3224,  3224,  3224,  3224,  3224,  3224,
    3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,
    3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,
    3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,
    3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,  3224,
    3224,  3225,  3225,  3225,  3225,  3225,  3225,  3225,  3225,  3225,
    3225,  3226,  3226,  3226,  3226,  3227,  3227,  3227,  3228,  3228,
    3228,  3228,  3228,  3229,  3229,  3230,  3231,  3232,  3233,  3234,
    3235,  3236,  3237,  3238,  3239,  3240,  3240,  3240,  3240,  3240,
    3240
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "LATENCY",
  "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN",
  "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE",
  "KRT_METRIC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID",
  "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE",
  "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE",
  "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "LINK", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RADV", "RA", "MANAGED", "OTHER", "CONFIG", "MTU",
  "REACHABLE", "RETRANS", "TIMER", "CURRENT", "VALID", "PREFERRED", "MULT",
  "LIFETIME", "SKIP", "ONLINK", "AUTONOMOUS", "RDNSS", "DNSSL", "NS",
  "DOMAIN", "TRIGGER", "SENSITIVE", "LOW", "MEDIUM", "HIGH", "RIP",
  "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text", "text_or_none", "log_config", "syslog_name",
  "log_file", "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base", "debug_unix",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args",
  "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_item",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "radv_proto_start",
  "radv_proto_item", "$@6", "$@7", "radv_proto_opts", "radv_proto",
  "radv_iface_start", "radv_iface_item", "$@8", "$@9", "radv_preference",
  "radv_iface_finish", "radv_iface_opts", "radv_iface_opt_list",
  "radv_iface", "radv_prefix_start", "radv_prefix_item",
  "radv_prefix_finish", "radv_prefix_opts", "radv_prefix_opt_list",
  "radv_prefix", "radv_rdnss_node", "radv_rdnss_start", "radv_rdnss_item",
  "radv_rdnss_finish", "radv_rdnss_opts", "radv_rdnss", "radv_dnssl_node",
  "radv_dnssl_start", "radv_dnssl_item", "radv_dnssl_finish",
  "radv_dnssl_opts", "radv_dnssl", "radv_mult", "radv_sensitive",
  "rip_cfg_start", "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item",
  "rip_iface_opts", "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   617,   618,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
      59,    40,    41,    58,   123,   125,    44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1523

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1523)))

#define YYTABLE_NINF -445

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-445)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      99,  2797,   145,   637,   531,  1027,   162,   531,   531,   623,
     531,   178,    92,   670,   121,   135,   930,  1617,   111,   531,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
     284,   760,   283,   713,   371,   256,   381,   258, -1523, -1523,
     386,   388,   330,   359,  1617,   484, -1523, -1523, -1523, -1523,
   -1523, -1523,   405,   405, -1523, -1523, -1523, -1523,   140, -1523,
    2058, -1523,   405,  2586, -1523, -1523, -1523,   405, -1523,   405,
    2322,   405,  2364,   405,  2525,   405, -1523,   405,  2135,   405,
    2510, -1523, -1523,  2084,  2543, -1523, -1523, -1523,   196, -1523,
     492,   536,   570,   492,   541, -1523,   619,   627,   531,   531,
     636,   260, -1523,   572,   838,   175, -1523,   767,   772, -1523,
   -1523,   440,   485,   666,   673,   673,   774,   779,   786,   788,
     793,   799,   821,   840,    49, -1523, -1523, -1523,   734,   450,
   -1523,   634,   117,    20,  1617, -1523,   463,   469,   479, -1523,
   -1523,   482,   489,   496,   873,   253, -1523, -1523, -1523, -1523,
   -1523,  2061, -1523,  2723, -1523, -1523,  1648,   879,   895,   881,
   -1523, -1523,   865, -1523, -1523,    60,   164,   196,   139, -1523,
   -1523, -1523, -1523,   605,   543,   139,   139,   800,   815,   449,
   -1523,   933, -1523,   260,   559,  2884, -1523,   882,   952,   599,
     609, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   612,   196,   991,   928,   139,   228, -1523,   890,
     569,   949,   811,   260, -1523,   629,   641,   639,   648,    83,
     766,   985,   677,  1053,   835,   811,   228,  1012,   823,   106,
     971,   228,    31,   673,   366,  1035,   -25,  1037,   888,   883,
     642,   889,   893,   678,   876,   877,   228,   887,   871,   869,
     146,    14,   913,   880,   886,   228,   938, -1523,   761,   759,
     736,   228,  1082,   139,   228,  1084,   858, -1523, -1523,   787,
     775, -1523,   789,  1097,   568, -1523,   792,   790,   791,   139,
    1113, -1523,   811,   796,   -32,   139,   139,  1116,   -18, -1523,
     805,   806, -1523,   804,   807,   906,   673,  1117, -1523,   812,
     567,   813,  1126,   228,  1137,   228,  1135,  1134, -1523,   825,
     837,   839,  1155,  1211, -1523,   842,   843, -1523, -1523,  1031,
    1232,   541, -1523, -1523,  1237,   139,  1238, -1523, -1523,  1239,
    1241, -1523, -1523, -1523,   428,  1242,  1233,  1252, -1523, -1523,
     978,  1254, -1523,  1256,   856, -1523, -1523,  2685,  1207,   666,
   -1523,   666,   666, -1523,   357,   497,  1257,  1258, -1523, -1523,
      25,  1119,  1120, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,    49, -1523,    49,  1617,    49,    49,  1251, -1523,  1253,
    1121,  1240,  1058,  1243,    20,    20,  1245,  1244,  1617,  1617,
    1617,  1617,  1617,  1260, -1523, -1523,  1262, -1523,   884,    47,
   -1523, -1523, -1523, -1523,   848, -1523,  1268, -1523, -1523, -1523,
     323,    10, -1523,   417, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
    1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,  1617,
    1617,  1617,  1617,   372, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,   626, -1523, -1523,  1284, -1523,  1617,   811,
   -1523, -1523,  1648,   898, -1523, -1523, -1523, -1523, -1523, -1523,
     139,  1617, -1523, -1523, -1523, -1523,   139,   993,   997, -1523,
     857, -1523, -1523,   139, -1523, -1523, -1523, -1523, -1523, -1523,
     901,  1586, -1523,   148,   904, -1523,   909,  1278, -1523, -1523,
   -1523,   -33, -1523, -1523, -1523, -1523,   736, -1523, -1523, -1523,
   -1523,   141,  2118, -1523,  1195,  1617, -1523, -1523,   141, -1523,
     141, -1523, -1523, -1523, -1523, -1523, -1523,  1227,  1229,   228,
     171, -1523,   915,  1259,   920,   924,   139,   116,  1052,   228,
     673,   929, -1523,   932,  1288,   128,   139,  1175,   139,  1248,
    1250,   139,  1263,   156,   139,   139,   228,  1267,   936,  1264,
     939,   228,   947,   228,   235,   228,   991,   228,   953,   959,
     228,   228,   228,   965,  1183, -1523, -1523, -1523, -1523,   228,
   -1523,  1276,   139,   228, -1523, -1523, -1523,  1313,   966,   972,
   -1523, -1523, -1523,   974,   139, -1523,   975, -1523,  1265, -1523,
   -1523, -1523,   976,   977,   979,   139,   983,   984,   987, -1523,
   -1523,   558, -1523,   228, -1523,   991, -1523, -1523,   942, -1523,
     673, -1523,  1141, -1523, -1523, -1523,   139, -1523,   139, -1523,
     228,   228, -1523, -1523, -1523,   139, -1523,   673, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,   674, -1523, -1523,  1372,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,   676, -1523, -1523,
   -1523, -1523,  1375, -1523, -1523, -1523,  1366, -1523, -1523,  1371,
     673, -1523, -1523,  1368,  1369, -1523,  2118, -1523, -1523, -1523,
   -1523,   673, -1523, -1523, -1523,  1373, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1388,  1374,  1374,   954,   666,
    1374,   666,  1374, -1523, -1523,   139,   673, -1523,  1378,  1382,
   -1523, -1523,    16, -1523, -1523, -1523, -1523,    73, -1523,  1007,
   -1523,  1377, -1523, -1523, -1523, -1523,   100,   288,   345,   824,
     576,   343, -1523,  1617, -1523,  1617, -1523,  1400,  1024,  1025,
     897,   375,   414, -1523, -1523, -1523,  1408,  1412, -1523,  2309,
    2309,  2309,  2683,  2683,  2309,  2309,  2309,  2309,   658,   658,
    1244,  1244, -1523,  1040, -1523, -1523, -1523, -1523,  1648, -1523,
    1968, -1523,   682, -1523, -1523,   956,  1413, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,  1044, -1523,  1045, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
     142,  1047,  1059, -1523, -1523,   139, -1523, -1523,   673, -1523,
   -1523, -1523,  1271,  1586, -1523,   673, -1523, -1523,  1411, -1523,
    1043, -1523,  1346, -1523, -1523, -1523, -1523,   228,  2884, -1523,
   -1523,  2186,   139,   139,  1064,   139,  1069,  1070, -1523,   228,
   -1523, -1523,  1071,  1076,  1078,  1080,   228,  1087,  1089, -1523,
   -1523,  1462, -1523,   139,   139, -1523,  1096,   139,  1098,   139,
     139,  1099,   139,  1100,  1102,  1107,  1108,  1109,   139, -1523,
     736, -1523,  1112, -1523,  1115,  1124,  1125,  1136,  1138,  1139,
    1140, -1523, -1523,  1143,  1145,  1149, -1523,   158, -1523,   139,
   -1523, -1523,  1033,  1150, -1523, -1523,  2431, -1523,  1151,  -117,
   -1523,  1090,  1152, -1523, -1523, -1523,  1153, -1523, -1523, -1523,
     139,   339,   486,  1106,  1154,  1162, -1523,  1288, -1523,   673,
    1182,  1141, -1523, -1523, -1523, -1523, -1523,    25, -1523, -1523,
   -1523,  1031, -1523, -1523,   428, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,  1506,  1508, -1523, -1523,
     736, -1523, -1523,   736,  1501, -1523,   736,  1374,  1524,  1374,
    1534, -1523, -1523,  1409,  1410, -1523,  1617, -1523,  1526,  1617,
    1617,  1617, -1523,  1617, -1523,  1617,   624,  1095,  1617,  1147,
    1617, -1523, -1523,  1617, -1523, -1523,  1161,   734, -1523,  1617,
   -1523, -1523, -1523, -1523, -1523, -1523,  1043, -1523, -1523, -1523,
    1586,   533, -1523, -1523, -1523,  1179,  1180, -1523,  1428, -1523,
     957, -1523,   724, -1523, -1523, -1523, -1523,   673, -1523, -1523,
    1184,  1177,  1185, -1523,  1186, -1523, -1523,  1187, -1523, -1523,
   -1523, -1523,  1189, -1523, -1523, -1523,   186, -1523, -1523, -1523,
    1190, -1523,  1191,  1193, -1523,  1194, -1523, -1523, -1523, -1523,
   -1523,  1197,  1199, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523,  1200, -1523, -1523,   228,   378,
     201, -1523,  1306,   673, -1523, -1523,   215, -1523,  1201, -1523,
    1266, -1523, -1523,   673, -1523, -1523,   673, -1523, -1523,  1202,
   -1523, -1523, -1523, -1523,  1265, -1523,  1203,  1574,  1574,  1574,
    1574, -1523, -1523, -1523, -1523,  1288,   139,  1182, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523,  1594, -1523,  1595, -1523,
    1585,  1587, -1523, -1523,  1196,  1538,  1650,  1694,   649,  1617,
   -1523, -1523,  2884,  1220,  1217,  2884,   897,  1599,  1722, -1523,
       7, -1523,  1593, -1523, -1523,  1225,  1617, -1523, -1523, -1523,
    1617,  1617,  1226,   124,  2061,  1234,  1505, -1523,  1586, -1523,
    1608,   673, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1231, -1523,   104, -1523, -1523,   139, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   139,   139,   228,   139, -1523,  1235,   736, -1523,
   -1523,  1246,  1247,   139, -1523, -1523,   139,  1255, -1523, -1523,
   -1523,  1261, -1523,    44,    58, -1523, -1523,   477, -1523,   558,
   -1523,  1236,  1249,  1274,  1275, -1523, -1523, -1523, -1523,   572,
     572, -1523, -1523, -1523, -1523,  1617,  1763,  1620,  1591,  1273,
   -1523,  1617,  1121,  1617, -1523,  1994,  2354,   720, -1523, -1523,
    1606,   680, -1523,  2884,  1287,  1279, -1523,  1486, -1523,  1043,
    1231, -1523, -1523,  1619,   811,  1422,  1280,  1043,  1277, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
    1286, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,    71,   139,  1376,   411, -1523,  1294, -1523,   558,   558,
     558,   558,  1644,  1649,  1806, -1523,  1295,  1293,    27, -1523,
    2021,  1296,  2046,  2107, -1523,   750, -1523,  1617,  1617,   785,
    1505, -1523,  1636, -1523,   243, -1523, -1523,   673,  1433, -1523,
    1266, -1523, -1523,    33,   -12,    68,   863, -1523, -1523,   981,
   -1523, -1523, -1523,   139,   139,   139, -1523, -1523,   487, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523,  1617, -1523,  1617, -1523, -1523, -1523, -1523,
    1297,   533,  1470, -1523,    15,  2071,  2096,  1299,  1318,  1319,
    1321,  1324, -1523,  1334,   228,   872,  1510,   139,   139, -1523,
    1335, -1523,   228, -1523, -1523,  2541, -1523, -1523, -1523,   269,
     228,   139,   228, -1523,  1338, -1523,   139,   139,   139,  1491,
     165,    -4, -1523, -1523,  1345,  2528, -1523,  1379,  1380,   228,
     228,   228, -1523,  1348,   326,   -30, -1523, -1523, -1523,  1424,
   -1523,  1344,  1349,  1362,  1358,   750,   176, -1523, -1523, -1523,
     848, -1523, -1523,  1755, -1523, -1523, -1523,   446, -1523, -1523,
    1617,  1617,  1617,  1617, -1523, -1523, -1523,  1552,  1558,  1561,
   -1523, -1523, -1523, -1523,  1500,   139,  1387,   228,  1466,   153,
    1509,   228,  1449,   228,   139,   139,   139,  1555,   139,   202,
    1111,  1464,   211,  1498,   139,  1475,  1502, -1523, -1523,  1415,
   -1523,   139,  1416, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
     139,   139, -1523, -1523, -1523, -1523, -1523,  1457,   673,  -158,
       2,  1458,   228,  1460,  1734,  1459,  1578,  1589,  1590, -1523,
    1429,   139,   139, -1523, -1523, -1523, -1523,   204,   673, -1523,
    1431,   204,  1802, -1523,  1434, -1523,  1617, -1523, -1523, -1523,
   -1523, -1523,  1831,    98,   176,   103,  1856,  1882,  1909,  1934,
     139,   139,   139,   228, -1523, -1523, -1523,   118,   139,   139,
   -1523,   510, -1523,  1489, -1523, -1523, -1523, -1523,   139, -1523,
     139, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
     228, -1523, -1523, -1523,   228, -1523,   139,   228, -1523, -1523,
   -1523, -1523, -1523,  1618, -1523,   139,  1626,   661,   139,   139,
   -1523,   228,   139,   139,  1758,   228,    44,   228,    58, -1523,
    1471,  1471,   139, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,  1453, -1523,  1617, -1523, -1523, -1523,  1456,  1461,
    1472,  1479, -1523, -1523, -1523, -1523,    70, -1523, -1523, -1523,
   -1523, -1523,  1532, -1523,   228, -1523, -1523, -1523, -1523, -1523,
   -1523,   139, -1523,   139, -1523, -1523, -1523, -1523,  1471, -1523,
   -1523, -1523, -1523,   139, -1523, -1523, -1523, -1523,   228, -1523,
   -1523, -1523, -1523,  1831, -1523, -1523, -1523, -1523, -1523,  1539,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,  1480,
   -1523
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   382,     0,     0,
     844,   845,   846,   847,   848,   849,   850,   851,   852,   853,
     854,   855,   856,   857,   858,   859,   860,   861,   862,   863,
     864,   865,   866,   867,   868,   869,   870,   871,   872,   873,
     874,   875,   876,   877,   878,   879,   880,   881,   882,   883,
     884,   885,   886,   887,   888,   889,   890,     3,     1,     2,
       0,     0,     0,     0,     0,     0,     0,     0,   111,   112,
       0,     0,     0,     0,   382,     0,   828,   829,   830,   831,
     832,   833,   113,   113,   834,   835,   836,   837,   109,   838,
       0,   840,   113,   117,   841,   842,   843,   113,   894,   113,
     117,   113,   117,   113,   117,   113,   898,   113,   117,   113,
     117,     5,   839,   117,   117,   267,   269,   268,     0,    76,
      75,     0,     0,    75,    77,    74,     0,     0,     0,     0,
       0,     0,   266,   238,   271,     0,   222,     0,     0,   205,
     230,     0,   201,   201,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   365,   369,   378,   375,   309,   384,
     372,     0,     0,   368,   382,   414,     0,     0,     0,   370,
     371,     0,     0,     0,   382,     0,   373,   374,   379,   412,
     413,     0,   411,     0,   254,   253,     0,   256,     0,     0,
      30,    29,    35,    38,    36,     0,    18,     0,     0,    57,
      56,    55,    54,     0,     0,     0,     0,     0,   103,     0,
     273,     0,    96,     0,     0,   275,   301,   114,     0,     0,
       0,   107,    80,    86,   159,   492,   462,   554,   690,   696,
     772,   807,     0,     0,     0,     0,     0,    18,   163,     0,
       0,     0,     0,     0,   893,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,   493,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,   895,     0,     0,
       0,    18,     0,     0,    18,     0,     0,   896,   557,     0,
       0,   565,     0,     0,     0,   897,     0,     0,     0,     0,
       0,   805,     0,     0,     0,     0,     0,     0,     0,   899,
       0,     0,   184,   188,     0,     0,     0,     0,   900,     0,
       0,     0,     0,    18,     0,    18,     0,     0,   891,     0,
       0,     0,     0,    32,   892,     0,     0,   166,   165,     0,
       0,    77,    71,    72,     0,    78,     0,   260,   258,     0,
       0,   261,   177,   176,     0,     0,     0,     0,   270,   272,
     271,     0,   202,     0,   226,   197,   196,     0,     0,   201,
     200,   201,   201,   681,   201,   201,     0,     0,    19,    20,
       0,     0,     0,   249,   245,   250,   246,   243,   244,   247,
     248,   365,   384,   365,   382,   365,   365,     0,   357,     0,
     382,     0,     0,     0,   368,   368,     0,   409,   382,   382,
     382,   382,   382,     0,   328,   329,     0,   331,     0,     0,
     310,   313,   311,   315,   382,   312,   337,   335,   336,   343,
       0,   348,   352,     0,   913,   908,   909,   910,   911,   385,
     912,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     915,   918,   917,   914,   916,   919,   920,   921,   924,   922,
     923,   925,   926,   927,   928,   929,   930,   415,   416,   251,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,     0,    43,    44,    45,    46,    47,    48,
      49,    50,    51,     0,    41,   257,     0,   259,   382,     0,
      37,    39,     0,     0,     7,     9,    14,    16,    15,    17,
       0,   382,    13,    65,   143,   144,    58,     0,     0,    64,
       0,    67,    68,     0,   104,   105,    92,    93,    94,   155,
       0,   290,   106,     0,     0,    53,     0,     0,   115,   901,
     905,     0,   160,   120,   142,   128,     0,   118,   119,   145,
     133,     0,   290,   134,     0,   382,   122,   132,     0,   123,
       0,   130,   121,   161,   162,   467,   496,     0,     0,    18,
      18,   508,     0,     0,     0,     0,     0,    18,     0,    18,
       0,     0,   509,     0,    21,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,    18,     0,    18,     0,    18,     0,     0,
      18,    18,    18,     0,     0,   497,   555,   566,   558,    18,
     563,   560,     0,    18,   556,   568,   691,     0,     0,     0,
     692,   705,   773,     0,     0,   145,     0,   189,   185,   788,
     786,   787,     0,     0,     0,     0,     0,     0,     0,   774,
     781,   190,   808,    18,   813,     0,   809,   823,     0,   822,
       0,   826,     0,   824,   825,   812,     0,    81,     0,    83,
      18,    18,   903,   904,   902,     0,    31,     0,   907,   906,
     171,   170,   172,   174,   175,   173,     0,   168,   264,     0,
      73,    79,    69,   262,   263,   181,   182,     0,   179,   265,
     239,   242,     0,   198,   203,   221,     0,   228,   227,     0,
       0,   204,   211,     0,     0,   219,   290,   213,   212,   216,
     217,     0,   218,   220,   206,     0,   210,   229,   237,   231,
     234,   235,   233,   236,   232,     0,   672,   672,     0,   201,
     672,   201,   672,   673,   827,     0,     0,    23,     0,     0,
     361,   362,     0,   363,   364,   359,   347,   442,   445,     0,
     422,     0,   423,   366,   367,   360,     0,     0,     0,     0,
       0,     0,   330,   382,   395,   382,   324,   322,     0,     0,
     321,     0,     0,   376,   349,   350,     0,     0,   377,   407,
     405,   403,   400,   401,   402,   404,   406,   408,   396,   397,
     398,   399,   417,     0,   418,   420,   421,   255,     0,   252,
       0,    34,     0,    33,    66,     0,     0,    60,    61,    62,
      63,    10,    11,    12,     0,   145,     0,    90,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
       0,     0,     0,   274,   294,     0,   100,   101,     0,    95,
      97,    52,     0,   290,   116,     0,   110,   129,   149,   152,
     164,   141,   135,   125,   295,   296,   131,    18,   297,   126,
     124,   117,     0,     0,     0,     0,     0,     0,   502,    18,
     537,   539,     0,     0,     0,     0,    18,     0,     0,   553,
     510,     0,   493,     0,     0,   500,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   504,
       0,   505,     0,   535,     0,     0,     0,     0,     0,     0,
       0,   516,   517,     0,     0,     0,   541,     0,   559,     0,
     564,   562,     0,     0,   694,   695,   117,   776,     0,   803,
     785,     0,     0,   780,   775,   777,     0,   783,   784,   782,
       0,     0,     0,     0,     0,     0,   819,    21,   821,     0,
     816,   820,    89,    82,    84,    85,    87,    25,    24,    88,
     167,     0,    70,   178,     0,   199,   225,   224,   223,   208,
     215,   209,   207,   214,   491,   671,     0,     0,   680,   689,
       0,   687,   684,     0,     0,   682,     0,   672,     0,   672,
       0,    26,    27,     0,     0,   358,   382,   431,     0,   382,
     382,   382,   410,   382,   429,   382,     0,     0,   382,   382,
     382,   314,   309,   382,   338,   344,     0,     0,   353,   382,
      42,     6,    40,     8,    59,   102,   156,    91,   289,   288,
     290,   382,    99,    98,   299,   292,     0,   302,     0,   150,
       0,   145,     0,   140,   127,   470,   470,     0,   469,   463,
       0,     0,     0,   552,     0,   548,   547,     0,   538,   542,
     543,   544,     0,   534,   525,    22,     0,   494,   495,   498,
       0,   506,     0,     0,   529,     0,   512,   511,   524,   523,
     518,     0,     0,   536,   521,   513,   514,   515,   540,   550,
     520,   519,   551,   522,   545,     0,   561,   661,    18,     0,
      18,   579,     0,     0,   581,   571,    18,   567,     0,   585,
     662,   693,   708,     0,   700,   702,     0,   707,   697,     0,
     779,   801,   806,   183,   185,   778,     0,     0,     0,     0,
       0,   187,   810,   811,   818,    21,     0,   817,   169,   180,
     675,   674,   688,   683,   685,   686,     0,   676,     0,   678,
       0,     0,   443,   424,     0,     0,     0,     0,     0,   382,
     380,   323,   321,     0,     0,   327,     0,     0,     0,   291,
       0,   435,     0,   436,   437,     0,   382,   433,   434,   432,
     382,   382,     0,   382,     0,     0,   382,   305,     0,   298,
       0,   146,   147,   151,   153,   138,   136,   137,   139,   145,
     464,   479,   465,   483,   466,   468,     0,   530,   549,   532,
     533,   501,   499,   528,   527,   507,   526,   503,   546,   145,
     584,   572,     0,     0,    18,     0,   570,     0,     0,   588,
     583,   587,     0,     0,   577,   569,     0,   595,   145,   698,
     736,   745,   699,     0,     0,   704,   706,   794,   186,   190,
      28,     0,     0,     0,     0,   814,   815,   677,   679,   238,
     238,   428,   426,   427,   425,   382,     0,   325,   382,     0,
     419,   382,   382,   382,   382,     0,     0,     0,   300,   306,
       0,     0,   455,   438,   440,     0,   293,     0,   148,   154,
     479,   477,   482,     0,     0,   486,     0,   664,   668,   574,
     575,   573,   576,   649,   609,   589,   649,   578,   663,   596,
     733,   743,   742,   749,   748,   756,   701,   758,   759,   766,
     703,     0,     0,     0,     0,   804,     0,   195,   190,   190,
     190,   190,     0,     0,     0,   381,     0,     0,     0,   351,
       0,     0,     0,     0,   449,   382,   354,   382,   382,     0,
     382,   454,     0,   481,     0,   484,   485,     0,   488,   531,
     662,   666,   670,     0,     0,     0,   598,   731,   730,     0,
     747,   754,   764,     0,     0,     0,   797,   795,    18,   789,
     790,   791,   792,   793,   796,   802,   191,   192,   193,   194,
     240,   241,   430,   382,   334,   382,   332,   448,   383,   452,
       0,   382,   446,   307,     0,     0,     0,     0,     0,     0,
       0,     0,   441,     0,    18,     0,     0,     0,     0,   480,
       0,   487,    18,   490,   665,     0,   580,   652,   650,   653,
      18,     0,    18,   586,     0,   582,     0,     0,     0,     0,
       0,     0,   594,   608,     0,     0,   735,     0,     0,    18,
      18,    18,   746,     0,   750,   760,   157,   158,   798,     0,
     799,     0,     0,     0,     0,   382,   382,   316,   320,   318,
     382,   456,   319,   341,   339,   340,   345,     0,   451,   450,
     382,   382,   382,   382,   457,   108,   476,     0,     0,     0,
     471,   475,   478,   489,     0,     0,     0,    18,     0,     0,
       0,    18,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   669,   648,     0,
     654,     0,     0,   592,   593,   591,   590,   602,   600,   599,
       0,     0,   603,   605,   606,   607,   597,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,   721,   723,   734,
       0,     0,     0,   737,   738,   739,   744,     0,     0,   753,
       0,     0,     0,   763,     0,   800,   382,   333,   453,   308,
     447,   356,   321,     0,   382,     0,     0,     0,     0,     0,
       0,     0,     0,    18,   614,   656,   646,     0,     0,     0,
     641,    18,   647,     0,   630,   610,   613,   611,     0,   628,
       0,   615,   617,   618,   619,   620,   621,   622,   623,   624,
      18,   635,   636,   637,    18,   612,     0,    18,   667,   655,
     651,   601,   604,     0,   720,     0,     0,     0,     0,     0,
     712,    18,     0,     0,     0,    18,     0,    18,     0,   732,
     770,   770,     0,   768,   752,   751,   757,   755,   762,   761,
     767,   765,     0,   317,   382,   342,   355,   346,     0,     0,
       0,     0,   472,   473,   474,   631,     0,   639,   638,   640,
     642,   643,     0,   644,    18,   627,   616,   626,   629,   632,
     625,     0,   711,     0,   727,   728,   729,   719,   770,   714,
     713,   715,   716,     0,   725,   722,   726,   724,    18,   740,
     741,   769,   326,     0,   461,   459,   460,   458,   634,   658,
     657,   645,   633,   710,   709,   718,   717,   771,   659,     0,
     660
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1523, -1523, -1523, -1523,  -155,  -209,   -62,  -271,  -830,  -139,
    -721, -1523,  -110,   -77, -1523, -1523, -1523, -1523, -1523,  1326,
    1022, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   638,  1511, -1523, -1523, -1523, -1523, -1523, -1523,
    -299, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1365,  -101,  1602, -1523,   127,  -289, -1523, -1523, -1523,
   -1523,   803,  -561,   593, -1523, -1523,   342, -1523, -1523, -1523,
   -1523,   144, -1523,   885,   -85, -1523,   892, -1233,   719,  -646,
   -1523,  -743, -1523, -1523, -1523, -1523,  -135, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,  -196, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523,   802,  1495, -1523, -1523, -1523, -1523,  -823,   817,
     669,  1347,  1163,  1513, -1523,  1016, -1523, -1523, -1324, -1523,
     402,  -181,  1101,   298, -1024,   874, -1387,  -991,  1728, -1275,
    1114,   310, -1523, -1523,  -180,  1118, -1523, -1523, -1523, -1523,
     532,   671, -1523, -1523, -1051, -1523,    77,   708,   -17, -1523,
   -1523,   544,   900,   621, -1147, -1523, -1523, -1523, -1523,   851,
   -1523, -1523,   608, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,  1017, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523,   603, -1523, -1523, -1523, -1523, -1523, -1523, -1523,   550,
   -1523, -1523, -1523, -1523, -1523,  -148, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523, -1523, -1523, -1523,   379,   360, -1523,
   -1523, -1523, -1523,   285,   358, -1523, -1523, -1523, -1523,   281,
     361, -1522, -1523, -1523, -1523, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1523,   973, -1523, -1523, -1523, -1523, -1523,
   -1523, -1523, -1523, -1048
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    87,   532,   541,   533,   400,   912,   988,
     989,   767,  1281,   204,   697,    88,   520,   205,   523,   513,
     514,    89,   213,   214,    90,    91,    20,    21,    22,    23,
      24,    25,   134,   366,    92,   349,    93,   355,   350,    94,
     550,    95,   553,   870,    96,   545,    97,    98,   561,    99,
     100,   229,   255,   576,  1073,   883,   565,   101,   878,  1223,
    1070,   879,  1319,  1320,   845,   846,  1406,   102,   103,   569,
     256,   360,   706,   707,   375,   717,   718,   331,   961,   332,
     333,   973,    26,    27,    28,    29,   396,    30,    31,    32,
     387,   745,    33,   384,   730,    34,   388,   377,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,   197,   516,    48,    49,    50,    51,    52,    53,    54,
      55,    56,   128,   381,   104,   551,   105,   860,   861,   862,
    1066,   885,   886,   577,   873,   864,   106,   556,  1212,  1213,
    1432,   186,   446,  1503,   797,   798,   447,  1194,   799,   448,
     449,  1506,   450,  1507,   187,   452,   453,  1434,   416,   188,
     417,   426,   189,   190,   191,  1215,   192,   487,  1192,  1216,
    1314,  1315,   778,   779,  1217,   107,  1080,   891,   108,  1229,
    1450,  1384,  1322,  1230,  1232,  1325,  1388,  1453,  1234,    57,
     109,   605,   110,   111,   112,   309,   310,   311,   952,  1138,
    1257,  1262,  1260,  1261,  1394,  1464,  1139,  1396,  1474,  1140,
    1549,  1393,  1458,  1459,  1552,  1696,  1749,  1740,  1249,  1267,
    1328,  1390,  1455,  1392,  1250,  1006,    58,    59,    60,    61,
      62,    63,    64,    65,   758,   113,   114,   115,  1149,  1273,
    1274,   956,   116,  1268,  1580,  1666,  1668,  1717,  1476,  1475,
    1398,  1269,  1271,  1483,  1400,  1399,  1342,  1272,  1345,  1401,
    1590,  1676,  1484,  1346,  1349,  1402,  1594,  1680,  1485,  1350,
    1674,  1729,   117,   118,   662,  1414,  1356,  1277,  1152,   655,
     656,   119,   120,   340,   980,   981,   341,    66,   121,    67,
     122,   123,   124,   488
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     193,   637,   604,   607,   445,   451,   224,   542,   880,   298,
    1214,   308,   962,   316,  1191,   401,   402,   330,   397,   339,
    1002,  1496,   351,   356,   490,   491,   492,   493,   494,  1301,
    1497,  1498,  1499,  1042,  1425,   424,   804,   805,   495,   496,
     497,   498,   499,   500,   501,   502,   524,  1504,   503,  1065,
     525,   398,   399,   535,   765,   490,   491,   492,   493,   494,
     540,   540,   398,   399,   411,   659,  1309,   225,   412,   495,
     496,   497,   498,   499,   500,   501,   502,   413,  1347,   503,
    1655,   490,   491,   492,   493,   494,   398,   399,   398,   399,
     875,   567,  1657,  1563,   959,   495,   496,   497,   498,   499,
     500,   501,   502,     1,   521,   503,   628,  1494,   490,   491,
     492,   493,   494,  1497,  1498,  1499,  1042,   603,  1497,  1498,
    1499,  1042,   495,   496,   497,   498,   499,   500,   501,   502,
    -304,   524,   503,   524,  1323,   525,  1460,   525,   554,  -304,
    -304,  -304,  -304,  1200,   422,    68,   194,  1164,   640,  1730,
     526,   527,   528,   529,   524,   195,   524,   427,   525,  1505,
     525,  1058,  1214,  1473,   653,   135,  1311,   439,   582,   913,
     663,   664,  1601,   524,  1201,   581,   881,   525,   382,   524,
     524,   142,  -303,   525,   525,   568,   524,  1656,   594,   865,
     525,  -303,  -303,  -303,  -303,  1200,  1745,   674,   526,   527,
     528,   529,   609,   666,   595,   526,   527,   528,   529,   601,
     711,  1403,  1404,   610,  1202,   143,   524,   524,  1504,   524,
     525,   525,  1548,   525,   622,   587,  1201,   913,  1433,   626,
     524,   357,   530,   633,   525,   526,   527,   528,   529,   638,
     358,   418,   641,   524,   154,   657,   895,   525,   744,   526,
     527,   528,   529,  1373,   755,   598,   756,   757,   155,   760,
     762,   923,   526,   527,   528,   529,  1202,   877,   440,   441,
     442,   168,   443,   914,   866,   867,   868,  1151,  1461,  1071,
    1686,   687,  1561,   689,  1056,   629,  1203,  1204,  1205,  1206,
    1207,  1208,  1209,  1403,  1404,   372,   490,   491,   492,   493,
     494,  1462,  1564,   199,   373,  1565,  1210,  1368,  1641,  1211,
     495,   496,   497,   498,   499,   500,   501,   502,  1059,  1630,
     503,   834,   588,   383,  1214,  1430,  1324,  1591,   423,   908,
    1505,   914,   903,   904,  1592,  1285,   217,   939,  1203,  1204,
    1205,  1206,  1207,  1208,  1209,   219,   660,   661,  1433,  1222,
     206,   534,  1444,   490,   491,   492,   493,   494,  1210,  1658,
     599,  1211,   876,   667,   668,  1593,  1405,   495,   496,   497,
     498,   499,   500,   501,   502,   540,   390,   503,   200,   201,
    1214,   836,   627,  1463,   398,   399,   975,   563,   844,   924,
     440,   441,   442,  1042,   443,  1065,   207,   772,  1302,  1491,
     218,   759,   208,   777,   806,   220,  1500,   977,  1025,   978,
    1501,   786,   787,   788,   789,   790,   882,   425,   766,  1426,
     215,   602,   531,   882,   227,   882,   987,   800,  1456,   440,
     441,   442,  1042,   443,  1492,  1697,  1698,   216,  1343,   794,
     414,   902,   831,   795,  1214,  1214,   415,  1157,  1618,  1158,
     896,   916,  1348,   918,   522,   222,   921,  1445,  1446,   925,
     926,  1447,  1448,  1465,   546,  1738,   547,   548,   935,  1026,
     987,   221,   223,   809,   810,   811,   812,   813,   814,   815,
     816,   817,   818,   819,   820,   821,  1619,   950,   418,  1684,
     418,  1255,   418,   418,  1500,  1022,  1029,   936,   937,   958,
    1318,   830,   524,   226,   390,   196,   525,   531,   962,   531,
     966,   606,   129,   228,   835,  -304,   390,  1642,   915,  -304,
    1643,   526,   527,   528,   529,   524,   715,   894,   897,   525,
     531,   982,   531,   983,   231,   905,  1357,   907,   869,   362,
     986,   761,  1263,   822,   526,   527,   528,   529,  1124,   531,
     125,   126,  1200,  1214,   927,   531,   531,   549,   888,   932,
    1672,   934,   531,   938,   716,   940,   823,  -303,   943,   944,
     945,  -303,  1682,   363,   824,   127,  1241,   948,   391,   825,
     826,   951,  1550,  1201,   490,   491,   492,   493,   494,  1551,
     359,   998,   531,   531,  1159,   531,  1160,  1063,   495,   496,
     497,   498,   499,   500,   501,   502,   531,   365,   503,  1007,
    1021,   974,  1018,   570,  1020,  1416,  1417,  1418,  1419,   531,
     445,   445,   367,  1202,  1017,   536,  1019,   451,   984,   985,
     368,  1112,   490,   491,   492,   493,   494,   578,  1449,   371,
      69,   392,   125,   126,   444,   970,   495,   496,   497,   498,
     499,   500,   501,   502,   374,   376,   503,   490,   491,   492,
     493,   494,   537,   538,   389,   572,   573,   127,  1252,  1253,
      70,   495,   496,   497,   498,   499,   500,   501,   502,    71,
     971,   503,    72,  1587,  1030,   390,   501,   502,  1327,  1588,
     503,   398,   399,    73,  1351,  1203,  1204,  1205,  1206,  1207,
    1208,  1209,  1378,  1254,  1489,   889,    74,   890,  1165,  1409,
    1062,  1172,  1379,  1352,  1173,  1210,    75,  1175,  1211,   802,
      76,  1589,   803,    77,   972,    78,    79,  1702,   490,   491,
     492,   493,   494,    80,   677,  1034,  1068,  1081,  1082,  1035,
    1084,  1031,   495,   496,   497,   498,   499,   500,   501,   502,
    1353,   546,   503,   547,   548,   209,   138,   139,  1097,  1098,
      81,    82,  1100,   419,  1102,  1103,  1043,  1105,   361,  1200,
     385,   364,    83,  1111,   210,   386,  1036,   403,  1037,   200,
     201,   575,   404,   144,   145,  1410,  1411,  1412,  1413,   405,
    1079,   406,  1125,   146,  1126,    84,   407,   678,    85,   987,
    1201,   211,   408,   202,  1225,   444,  1233,   393,   147,   136,
     137,   140,   141,   807,   203,  1156,   808,   148,  1354,   149,
     150,   198,   394,   395,   409,  1074,  1226,  1227,  1228,   679,
     200,   201,   490,   491,   492,   493,   494,  1087,   680,  1604,
    1202,   420,  1605,   410,  1092,   421,   495,   496,   497,   498,
     499,   500,   501,   502,   428,  1148,   503,   378,   379,   725,
     429,   164,   212,   165,   166,   167,   168,   169,   170,  1176,
     430,  1178,  1355,   431,   171,   172,   796,   173,   531,   174,
     432,  1437,   380,   151,   614,   615,   164,   433,   165,   166,
     167,   168,   169,   170,   515,   841,   842,   843,   517,   171,
     172,   531,   173,   518,   174,   490,   491,   492,   493,   494,
     648,   649,  1203,  1204,  1205,  1206,  1207,  1208,  1209,   495,
     496,   497,   498,   499,   500,   501,   502,   519,  -303,   503,
     618,   619,  1210,   539,   570,  1211,  1438,  1439,   175,   726,
     369,   370,   543,   770,   176,   771,   544,   773,   774,   555,
     987,   152,   552,   681,   682,   683,   684,  1008,   571,  1334,
     398,   399,   976,   175,   490,   491,   492,   493,   494,   176,
     322,   558,  1033,  1009,   727,   398,   399,  1221,   495,   496,
     497,   498,   499,   500,   501,   502,   572,   573,   503,   728,
     557,  1440,   323,   559,  1259,   574,  1441,   378,   379,   177,
     178,   729,  1344,   560,  1270,  1466,   562,  1275,   156,   777,
     564,  1286,  1184,  1185,  1186,   566,  1187,   580,  1188,   583,
    1189,   827,   828,  1195,   177,   178,  1196,    86,  1714,  1715,
    1716,   584,  1198,   585,   179,   180,   434,   435,   436,   437,
    1010,   157,   586,   158,   159,  1295,   589,   129,  1282,  1283,
    1284,   181,   837,   838,   182,   153,   839,   840,   183,   179,
     180,   434,   435,   436,   437,   590,  1251,   591,  1256,   990,
     991,   993,   994,   592,  1264,   593,   181,  1052,   828,   182,
     596,  1326,   130,   183,   160,   161,   162,   163,  1517,  1518,
     131,   132,   133,  1362,  1363,   783,   784,  1329,  1330,   600,
    1332,   597,   575,   490,   491,   492,   493,   494,  1337,   700,
     608,  1338,   611,   612,  1376,   613,  1451,   495,   496,   497,
     498,   499,   500,   501,   502,   616,  1127,   503,   620,   701,
     702,   617,   624,   621,   164,   625,   165,   166,   167,   168,
     169,   170,   703,   704,  1431,   705,   623,   171,   172,   630,
     173,   635,   174,   636,   631,  1467,  1468,  1469,   632,  1470,
     164,   634,   165,   166,   167,   168,   169,   170,   639,   645,
    1471,   642,  1296,   171,   172,   796,   173,   644,   174,   643,
     647,  1128,   650,   646,   651,   652,   673,  1011,   654,  1305,
     658,   665,  1331,  1306,  1307,   669,   670,  1407,   671,  1313,
     675,   672,   676,   685,   490,   491,   492,   493,   494,   686,
     747,   175,   688,   690,   691,   692,  1032,   176,   495,   496,
     497,   498,   499,   500,   501,   502,   748,   693,   503,   694,
     695,   696,   698,   699,  1012,   708,  1013,   175,  1520,   184,
     710,   712,   713,   176,   714,   719,   185,  1386,  1486,  1487,
    1488,  1014,   720,  1502,  1457,   721,  1457,   723,  1472,   724,
     763,   764,   768,   769,   184,   775,   780,  1129,   776,   781,
     782,   185,   177,   178,   785,   801,   503,   792,  1364,   791,
     793,  1195,  1015,  1016,  1370,   777,  1372,   829,   833,  1041,
     749,   847,   540,  1521,   871,   750,   751,   874,   177,   178,
     872,   887,   892,   752,   893,   898,  1554,   179,   180,   899,
     900,  1557,  1558,  1559,   901,  1562,   906,  1344,   911,   909,
     917,  1130,   910,   919,   181,   920,   929,   182,   947,   931,
     753,   183,   953,   179,   180,  1477,  1478,   933,   922,  1479,
    1480,  1481,   928,   941,   949,  1131,  1490,  1132,  1053,   942,
     181,   930,  1133,   182,  1134,   946,   954,   183,  1135,  1136,
    1435,  1436,   955,  1313,   957,   960,   963,   964,   754,   965,
    1614,   979,   322,   967,   968,   992,  1482,   969,   995,  1625,
    1626,  1627,  1516,  1629,  1631,   996,   997,   999,  1000,  1645,
    1523,  1004,  1003,  1023,  1005,  1344,  1649,  1024,  1553,  1027,
    1555,  1692,  1693,  1694,  1028,  1651,  1652,  1038,  1195,  1632,
    1633,  1634,  1635,  1636,  1637,  1638,  1639,  1583,  1584,  1585,
    1039,  1040,  1502,  1046,  1502,  1739,  1670,  1671,  1137,  1270,
    1047,  1049,  1673,  1054,  1055,  1057,  1673,  1060,  1069,  1071,
     848,   849,   850,   851,   852,   853,   854,  1072,   855,   856,
     857,   858,   859,  1061,  1083,   540,   540,   540,   230,  1085,
    1086,  1088,  1699,  1700,  1701,  1616,  1089,   242,  1090,  1622,
    1091,  1624,   257,  1705,   258,  1706,   299,  1093,   312,  1094,
     317,  1095,   318,  1602,   334,  1153,  1099,  1190,  1101,  1104,
    1106,  1709,  1107,  1606,  1607,  1608,  1609,  1108,  1109,  1110,
    1712,  1161,  1113,  1718,  1719,  1114,  1166,  1721,  1722,  1170,
    1660,  1171,   184,  -444,  1115,  1116,  1174,  1731,   164,   185,
     165,   166,   167,   168,   169,   170,  1117,  1177,  1118,  1119,
    1120,   171,   172,  1121,   173,  1122,   174,  1179,   184,  1123,
    1141,  1150,  1154,  1155,  1162,   185,   490,   491,   492,   493,
     494,  1695,  1163,  1183,  1180,  1181,  1743,  1197,  1744,  1703,
     495,   496,   497,   498,   499,   500,   501,   502,  1746,  1218,
     503,  1220,  1219,  1236,  1235,  1237,  1238,  1239,  1707,  1240,
    1242,  1243,  1708,  1244,  1245,  1710,  1258,  1246,  1291,  1247,
    1248,  1265,  1276,  1279,  1280,   175,  1266,  1287,  1288,  1720,
    1289,   176,  1290,  1724,   164,  1726,   165,   166,   167,   168,
     169,   170,  1297,  1298,  1299,  1303,  1304,   171,   172,  1367,
     173,  1308,   174,  1317,  1312,  1321,  1358,  1366,  1377,  1333,
     164,  1382,   165,   166,   167,   168,   169,   170,  1385,  1359,
    1335,  1336,  1742,   171,   172,  1387,   173,  1420,   174,  1339,
    1408,  1443,  1421,  1452,  1495,  1341,   177,   178,   490,   491,
     492,   493,   494,  1064,  1360,  1361,  1747,  1733,  1369,  1381,
    1389,  1391,   495,   496,   497,   498,   499,   500,   501,   502,
    1397,   175,   503,  1380,  1415,  1424,  1423,   176,  1428,  1493,
    1510,   179,   180,   504,   505,   506,   507,   508,   509,   510,
     511,   512,   490,   491,   492,   493,   494,   175,   181,  1511,
    1512,   182,  1513,   176,  1514,   183,   495,   496,   497,   498,
     499,   500,   501,   502,  1515,  1522,   503,  1519,  1556,  1560,
     490,   491,   492,   493,   494,  1566,  1581,  1582,  1586,  1595,
    1596,  1597,   177,   178,   495,   496,   497,   498,   499,   500,
     501,   502,  1598,  1599,   503,   848,   849,   850,   851,   852,
     853,   854,  1603,   855,   856,   857,   858,   859,   177,   178,
    1610,   490,   491,   492,   493,   494,  1611,   179,   180,  1612,
    1613,  1615,  1617,  1621,  1623,   495,   496,   497,   498,   499,
     500,   501,   502,  1628,   181,   503,  1640,   182,  1644,  1646,
    1647,   183,  1653,   179,   180,  1648,  1650,  1659,  1661,  1662,
    1664,  1663,  1665,  1667,   490,   491,   492,   493,   494,  1669,
     181,  1677,  1347,   182,  1681,  1704,  1723,   183,   495,   496,
     497,   498,   499,   500,   501,   502,  1711,  1728,   503,   490,
     491,   492,   493,   494,  1713,  1732,  1734,  1741,   832,  1748,
    1050,  1735,   579,   495,   496,   497,   498,   499,   500,   501,
     502,  1340,  1736,   503,   490,   491,   492,   493,   494,  1737,
    1750,  1620,   709,  1278,  1224,   722,  1168,  1199,   495,   496,
     497,   498,   499,   500,   501,   502,  1169,  1316,   503,  1067,
     490,   491,   492,   493,   494,  -439,   184,  1600,   863,  1001,
     746,  1685,  1044,   185,   495,   496,   497,   498,   499,   500,
     501,   502,   438,  1193,   503,  1687,  1045,   490,   491,   492,
     493,   494,  1310,  1371,  1442,  1048,  1182,  1231,  1383,  1096,
    1292,   495,   496,   497,   498,   499,   500,   501,   502,  1395,
    1454,   503,   490,   491,   492,   493,   494,  1654,  1675,  1727,
    1679,  1725,  1678,     0,  1167,     0,   495,   496,   497,   498,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   490,   491,   492,   493,
     494,     0,   184,     0,     0,     0,     0,     0,     0,   185,
     495,   496,   497,   498,   499,   500,   501,   502,     0,     0,
     503,     0,   490,   491,   492,   493,   494,     0,   184,     0,
       0,     0,     0,     0,     0,   185,   495,   496,   497,   498,
     499,   500,   501,   502,     0,     0,   503,     0,     0,   490,
     491,   492,   493,   494,     0,     0,     0,     0,     0,     0,
       0,     0,  1293,   495,   496,   497,   498,   499,   500,   501,
     502,     0,     0,   503,   490,   491,   492,   493,   494,     0,
       0,     0,     0,     0,     0,     0,   454,     0,   495,   496,
     497,   498,   499,   500,   501,   502,     0,     0,   503,   490,
     491,   492,   493,   494,     0,     0,  1294,     0,     0,     0,
       0,     0,     0,   495,   496,   497,   498,   499,   500,   501,
     502,     0,     0,   503,   490,   491,   492,   493,   494,     0,
       0,     0,   454,     0,  1300,     0,     0,     0,   495,   496,
     497,   498,   499,   500,   501,   502,     0,     0,   503,   243,
     232,     0,     0,     0,     0,   233,     0,   884,     0,     0,
       0,     0,   455,   456,     0,   457,   458,     0,     0,     0,
     234,     0,     0,     0,     0,  1365,   342,   343,   344,     0,
     345,   346,     0,   347,     0,     0,     0,   244,     0,   459,
     245,     0,     0,     0,   246,   247,   319,     0,   249,   250,
     243,     0,     0,   235,   251,     0,     0,     0,   455,   456,
       0,   457,   458,     0,     0,     0,     0,     0,  1422,     0,
     460,   320,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   252,     0,     0,     0,   244,   253,
       0,   245,     0,  1683,     0,   246,   247,     0,   321,   249,
     250,   243,     0,     0,     0,   251,     0,     0,     0,     0,
       0,     0,   322,     0,     0,     0,   460,     0,  1688,     0,
       0,     0,     0,   461,   462,     0,   463,   464,   465,   466,
     467,   468,   469,     0,   323,   252,     0,     0,     0,   244,
     253,   236,   245,     0,  1689,     0,   246,   247,     0,  1075,
     249,   250,     0,     0,     0,     0,   251,   848,   849,   850,
     851,   852,   853,   854,     0,   855,   856,   857,   858,   859,
       0,  1690,   470,   471,   472,   473,   474,   475,   476,   477,
     478,     0,     0,     0,     0,     0,   252,  -445,  -445,  -445,
       0,   253,     0,     0,     0,     0,  1691,     0,   479,   480,
       0,  -445,  -445,  -445,  -445,   499,   500,   501,   502,   237,
       0,   503,     0,     0,   481,   482,   483,   484,   470,   471,
     472,   473,   474,   475,   476,   477,   478,     0,  1051,     0,
       0,     0,   490,   491,   492,   493,   494,   243,     0,     0,
       0,     0,   259,     0,   479,   480,   495,   496,   497,   498,
     499,   500,   501,   502,  1374,     0,   503,   260,     0,     0,
     481,   482,   483,   484,     0,     0,     0,   238,     0,     0,
       0,   261,   239,     0,     0,   244,  1076,  1077,   245,   243,
       0,  1427,   246,   247,   262,   263,   249,   250,     0,     0,
       0,     0,   251,     0,     0,     0,   264,     0,   240,   265,
       0,   266,     0,     0,     0,     0,  1429,     0,     0,     0,
       0,     0,   324,   241,   485,   486,     0,   244,     0,     0,
     245,     0,   252,     0,   246,   247,     0,   253,   249,   250,
       0,  1508,     0,     0,   251,     0,     0,     0,     0,     0,
       0,   267,     0,   268,     0,     0,   243,     0,     0,   348,
       0,     0,   269,     0,     0,     0,  1509,     0,     0,     0,
     485,   486,     0,     0,   252,     0,     0,     0,     0,   253,
       0,     0,     0,     0,     0,     0,   325,   326,   327,     0,
       0,     0,     0,     0,   244,   328,     0,   245,   270,     0,
       0,   246,   247,     0,  1142,   249,   250,     0,     0,     0,
     329,   251,     0,     0,     0,   271,     0,  1375,     0,     0,
       0,     0,   272,   273,     0,   274,     0,   275,   276,     0,
     277,   278,     0,   279,     0,   243,   280,   281,     0,   282,
       0,   252,     0,     0,     0,     0,   253,     0,     0,     0,
     243,     0,   283,   284,     0,   335,     0,   285,     0,   286,
     287,  1078,   288,     0,     0,     0,     0,   289,   243,     0,
       0,   290,   291,   244,   292,   293,   245,   294,   295,   296,
     246,   247,     0,  1143,   249,   250,  1524,     0,   244,     0,
     251,   245,     0,     0,     0,   246,   247,   352,     0,   249,
     250,     0,     0,     0,     0,   251,   244,     0,     0,   245,
       0,   243,     0,   246,   247,     0,     0,   249,   250,     0,
     252,     0,     0,   251,     0,   253,   300,     0,   322,     0,
       0,   301,   302,   303,     0,   252,     0,     0,   353,   336,
     253,     0,     0,     0,     0,     0,     0,     0,     0,   244,
     323,  1567,   245,   252,     0,     0,   246,   247,   253,   248,
     249,   250,     0,  1525,     0,     0,   251,   304,   731,     0,
       0,   490,   491,   492,   305,     0,     0,  1526,   306,     0,
    1568,     0,     0,   398,   399,   495,   496,   497,   498,   499,
     500,   501,   502,     0,     0,   503,   252,   297,     0,     0,
       0,   253,     0,     0,     0,     0,   489,     0,     0,   732,
       0,   490,   491,   492,   493,   494,     0,     0,     0,     0,
       0,     0,  1569,     0,     0,   495,   496,   497,   498,   499,
     500,   501,   502,     0,  1527,   503,     0,  1528,  1529,   307,
       0,     0,  1570,     0,     0,     0,     0,     0,   733,     0,
       0,     0,     0,   734,     0,     0,     0,     0,     0,   337,
     735,   736,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   737,  1144,  1145,     0,     0,  1146,     0,     0,     0,
     738,   739,   740,   741,     0,   742,   743,     0,  1571,     0,
       0,     0,     0,     0,  1530,     0,     0,  1531,     0,     0,
       0,  1532,     0,     0,     0,     0,  1147,     0,     0,  1533,
       0,  1534,     0,  1535,  1536,  1537,  1538,  1539,  1540,     0,
       0,     0,     4,     0,  1541,     0,     0,     0,  1542,  1543,
       0,     0,  1544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1545,   313,   314,     5,     6,     0,
       0,     0,  1546,     0,  1572,  1573,     0,     7,  1574,  1575,
       0,  1576,     0,     0,     0,     0,     0,     0,     0,  1577,
    1578,     0,   490,   491,   492,   493,   494,   575,     0,     0,
       0,     8,     0,     0,     0,   338,   495,   496,   497,   498,
     499,   500,   501,   502,     0,     0,   503,     0,     0,     0,
     315,     0,     0,  1579,     0,     0,     0,     0,     0,     9,
       0,     0,    10,     0,    11,     0,  1547,     0,   354,     0,
       0,    12,     0,    13,     0,     0,     0,     0,    14,    15,
      16,     0,     0,     0,     0,    17,    18,    19,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   254
};

static const yytype_int16 yycheck[] =
{
      17,   300,   273,   274,   185,   185,    83,   216,   569,   110,
    1061,   112,   658,   114,  1038,   154,   155,   118,   153,   120,
     741,     6,   123,   124,     8,     9,    10,    11,    12,    22,
      15,    16,    17,    18,     7,    15,    26,    27,    22,    23,
      24,    25,    26,    27,    28,    29,    15,  1434,    32,   872,
      19,    18,    19,   208,    29,     8,     9,    10,    11,    12,
     215,   216,    18,    19,    15,    97,  1213,    84,    19,    22,
      23,    24,    25,    26,    27,    28,    29,    28,    20,    32,
     238,     8,     9,    10,    11,    12,    18,    19,    18,    19,
     123,   246,    90,    97,   655,    22,    23,    24,    25,    26,
      27,    28,    29,     4,    44,    32,    92,  1431,     8,     9,
      10,    11,    12,    15,    16,    17,    18,   272,    15,    16,
      17,    18,    22,    23,    24,    25,    26,    27,    28,    29,
       6,    15,    32,    15,    30,    19,   148,    19,   223,    15,
      16,    17,    18,    19,    27,     0,    35,   977,   303,  1671,
      34,    35,    36,    37,    15,    44,    15,   174,    19,  1434,
      19,    19,  1213,  1396,   319,     3,  1214,   184,   253,    41,
     325,   326,  1496,    15,    50,   252,    35,    19,     3,    15,
      15,     3,     6,    19,    19,   247,    15,   345,   265,    41,
      19,    15,    16,    17,    18,    19,  1718,   336,    34,    35,
      36,    37,   227,   221,   266,    34,    35,    36,    37,   271,
     365,   140,   141,   238,    90,   123,    15,    15,  1605,    15,
      19,    19,  1455,    19,   286,   142,    50,    41,  1375,    83,
      15,    35,    68,   295,    19,    34,    35,    36,    37,   301,
      44,   164,   304,    15,   123,   322,    75,    19,   387,    34,
      35,    36,    37,  1304,   389,   149,   391,   392,   123,   394,
     395,   105,    34,    35,    36,    37,    90,   566,    15,    16,
      17,    18,    19,   145,   126,   127,   128,   394,   290,   396,
    1604,   343,   117,   345,   845,   271,   162,   163,   164,   165,
     166,   167,   168,   140,   141,    35,     8,     9,    10,    11,
      12,   313,   306,    19,    44,   309,   182,  1298,    97,   185,
      22,    23,    24,    25,    26,    27,    28,    29,   176,   117,
      32,   530,   239,   148,  1375,  1373,   222,   357,   211,   600,
    1605,   145,   216,   217,   364,  1165,    80,   626,   162,   163,
     164,   165,   166,   167,   168,    87,   378,   379,  1495,  1070,
      67,   207,   109,     8,     9,    10,    11,    12,   182,   357,
     254,   185,   395,   381,   382,   395,   295,    22,    23,    24,
      25,    26,    27,    28,    29,   530,    19,    32,    19,    20,
    1431,   536,   236,   395,    18,    19,   675,   243,   543,   233,
      15,    16,    17,    18,    19,  1218,   113,   414,   391,  1423,
      19,    44,   119,   420,   394,    19,   391,   678,   392,   680,
     395,   428,   429,   430,   431,   432,   571,   397,   393,   392,
      49,   390,   391,   578,    19,   580,   697,   444,   395,    15,
      16,    17,    18,    19,  1425,   317,   318,    66,   394,   392,
     391,   596,   519,   396,  1495,  1496,   397,   108,   295,   110,
     279,   606,   394,   608,   394,   125,   611,   214,   215,   614,
     615,   218,   219,   395,    15,   395,    17,    18,   233,   396,
     741,    83,   113,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   499,   500,   501,   502,   333,   642,   411,   391,
     413,   290,   415,   416,   391,   766,   396,   262,   263,   654,
    1221,   518,    15,    19,    19,   394,    19,   391,  1154,   391,
     665,   145,    20,   108,   531,   391,    19,   306,   390,   395,
     309,    34,    35,    36,    37,    15,    98,   589,   590,    19,
     391,   686,   391,   688,   394,   597,  1279,   599,   390,     3,
     695,    44,   327,   171,    34,    35,    36,    37,   390,   391,
      19,    20,    19,  1604,   616,   391,   391,   108,   575,   621,
     356,   623,   391,   625,   136,   627,   194,   391,   630,   631,
     632,   395,  1596,     3,   202,    44,   390,   639,    93,   207,
     208,   643,   313,    50,     8,     9,    10,    11,    12,   320,
     394,   730,   391,   391,   108,   391,   110,   868,    22,    23,
      24,    25,    26,    27,    28,    29,   391,    66,    32,   757,
     765,   673,   760,    44,   762,  1358,  1359,  1360,  1361,   391,
     801,   802,     3,    90,   759,    20,   761,   807,   690,   691,
       3,   930,     8,     9,    10,    11,    12,    68,   395,     3,
       3,   156,    19,    20,   391,    87,    22,    23,    24,    25,
      26,    27,    28,    29,   394,    83,    32,     8,     9,    10,
      11,    12,    57,    58,   224,    96,    97,    44,   290,   291,
      33,    22,    23,    24,    25,    26,    27,    28,    29,    42,
     122,    32,    45,   357,   396,    19,    28,    29,  1249,   363,
      32,    18,    19,    56,   217,   162,   163,   164,   165,   166,
     167,   168,    22,   325,   217,   578,    69,   580,   979,   298,
     865,  1010,    32,   236,  1013,   182,    79,  1016,   185,   396,
      83,   395,   399,    86,   166,    88,    89,   217,     8,     9,
      10,    11,    12,    96,   167,   392,   875,   892,   893,   396,
     895,   396,    22,    23,    24,    25,    26,    27,    28,    29,
     273,    15,    32,    17,    18,    42,   133,   134,   913,   914,
     123,   124,   917,    29,   919,   920,   391,   922,   130,    19,
       3,   133,   135,   928,    61,     3,   793,     3,   795,    19,
      20,   212,     3,   113,   114,   374,   375,   376,   377,     3,
     891,     3,   947,   123,   949,   158,     3,   230,   161,  1070,
      50,    88,     3,    43,    80,   391,  1077,   322,   138,     7,
       8,     9,    10,   396,    54,   970,   399,   147,   341,   149,
     150,    19,   337,   338,     3,   887,   102,   103,   104,   262,
      19,    20,     8,     9,    10,    11,    12,   899,   271,   393,
      90,   391,   396,     3,   906,   211,    22,    23,    24,    25,
      26,    27,    28,    29,   391,   956,    32,    19,    20,     3,
     391,    13,   149,    15,    16,    17,    18,    19,    20,  1017,
     391,  1019,   395,   391,    26,    27,    28,    29,   391,    31,
     391,    96,    44,   213,   242,   243,    13,   391,    15,    16,
      17,    18,    19,    20,    15,    38,    39,    40,     3,    26,
      27,   391,    29,    22,    31,     8,     9,    10,    11,    12,
     342,   343,   162,   163,   164,   165,   166,   167,   168,    22,
      23,    24,    25,    26,    27,    28,    29,    62,   395,    32,
     252,   253,   182,   390,    44,   185,   151,   152,    90,    83,
     138,   139,   142,   411,    96,   413,   131,   415,   416,   390,
    1221,   281,    19,   386,   387,   388,   389,     3,    68,  1258,
      18,    19,    20,    90,     8,     9,    10,    11,    12,    96,
     107,    19,   396,    19,   118,    18,    19,    20,    22,    23,
      24,    25,    26,    27,    28,    29,    96,    97,    32,   133,
     108,   206,   129,   394,  1133,   105,   211,    19,    20,   151,
     152,   145,  1273,   394,  1143,   142,   394,  1146,    78,  1026,
      19,  1166,  1029,  1030,  1031,    87,  1033,    68,  1035,   390,
     396,   395,   396,  1040,   151,   152,  1043,   390,   367,   368,
     369,   390,  1049,   394,   186,   187,   188,   189,   190,   191,
      86,   111,   394,   113,   114,   396,   280,    20,  1158,  1159,
    1160,   203,    59,    60,   206,   385,    59,    60,   210,   186,
     187,   188,   189,   190,   191,    80,  1128,   390,  1130,   395,
     396,   395,   396,    20,  1136,   240,   203,   395,   396,   206,
      68,  1236,    55,   210,   154,   155,   156,   157,   216,   217,
      63,    64,    65,  1289,  1290,   424,   425,  1252,  1253,   128,
    1255,   278,   212,     8,     9,    10,    11,    12,  1263,    78,
      75,  1266,    75,   225,   394,   232,  1387,    22,    23,    24,
      25,    26,    27,    28,    29,   236,    93,    32,   252,    98,
      99,   238,   261,   256,    13,   266,    15,    16,    17,    18,
      19,    20,   111,   112,   394,   114,   259,    26,    27,   236,
      29,   390,    31,   394,   274,   292,   293,   294,   272,   296,
      13,   223,    15,    16,    17,    18,    19,    20,    86,   394,
     307,    87,  1189,    26,    27,    28,    29,   390,    31,   321,
      83,   148,   390,   394,   394,   394,   280,   233,    75,  1206,
     394,    75,  1254,  1210,  1211,   390,   390,  1352,   394,  1216,
      83,   394,   390,   390,     8,     9,    10,    11,    12,    83,
       3,    90,    75,    78,    80,   390,   392,    96,    22,    23,
      24,    25,    26,    27,    28,    29,    19,   390,    32,   390,
      75,    20,   390,   390,   280,     3,   282,    90,  1447,   391,
       3,     3,     3,    96,     3,     3,   398,  1324,  1403,  1404,
    1405,   297,    19,  1434,  1393,     3,  1395,     3,   395,     3,
       3,     3,   143,   143,   391,    14,    26,   234,    15,   211,
      27,   398,   151,   152,    29,     7,    32,    15,  1295,    19,
     396,  1298,   328,   329,  1301,  1302,  1303,     3,   390,   392,
      83,   390,  1447,  1448,   390,    88,    89,    19,   151,   152,
     391,   106,    75,    96,    75,   390,  1461,   186,   187,    50,
     390,  1466,  1467,  1468,   390,  1470,   264,  1588,    30,   390,
     145,   288,   390,    75,   203,    75,   390,   206,   145,   390,
     123,   210,    19,   186,   187,   354,   355,   390,    75,   358,
     359,   360,    75,   390,    68,   312,  1408,   314,   392,   390,
     203,    87,   319,   206,   321,   390,   390,   210,   325,   326,
    1377,  1378,   390,  1380,   390,   390,   390,   390,   161,   390,
    1525,   230,   107,   390,   390,     3,   395,   390,     3,  1534,
    1535,  1536,  1444,  1538,  1539,    19,    15,    19,    19,  1544,
    1452,     3,    19,    15,    20,  1666,  1551,    15,  1460,   392,
    1462,  1610,  1611,  1612,    27,  1560,  1561,     7,  1425,   298,
     299,   300,   301,   302,   303,   304,   305,  1479,  1480,  1481,
     396,   396,  1603,    15,  1605,  1696,  1581,  1582,   395,  1568,
      18,   391,  1587,    20,   390,   390,  1591,   390,    27,   396,
     169,   170,   171,   172,   173,   174,   175,   101,   177,   178,
     179,   180,   181,   394,   390,  1610,  1611,  1612,    93,   390,
     390,   390,  1617,  1618,  1619,  1527,   390,   102,   390,  1531,
     390,  1533,   107,  1628,   109,  1630,   111,   390,   113,   390,
     115,    19,   117,  1500,   119,   395,   390,   392,   390,   390,
     390,  1646,   390,  1510,  1511,  1512,  1513,   390,   390,   390,
    1655,   395,   390,  1658,  1659,   390,   324,  1662,  1663,     3,
    1572,     3,   391,   392,   390,   390,    15,  1672,    13,   398,
      15,    16,    17,    18,    19,    20,   390,     3,   390,   390,
     390,    26,    27,   390,    29,   390,    31,     3,   391,   390,
     390,   390,   390,   390,   390,   398,     8,     9,    10,    11,
      12,  1613,   390,    27,   145,   145,  1711,   396,  1713,  1621,
      22,    23,    24,    25,    26,    27,    28,    29,  1723,   390,
      32,   143,   392,   396,   390,   390,   390,   390,  1640,   390,
     390,   390,  1644,   390,   390,  1647,   280,   390,   392,   390,
     390,   390,   390,   390,    20,    90,   330,     3,     3,  1661,
      15,    96,    15,  1665,    13,  1667,    15,    16,    17,    18,
      19,    20,   392,   396,    15,    22,   391,    26,    27,    28,
      29,   395,    31,    15,   390,   394,   390,     7,    22,   394,
      13,   145,    15,    16,    17,    18,    19,    20,    19,   390,
     394,   394,  1704,    26,    27,   223,    29,     3,    31,   394,
     274,    15,     3,   220,   184,   394,   151,   152,     8,     9,
      10,    11,    12,   392,   390,   390,  1728,  1684,   395,   390,
     390,   394,    22,    23,    24,    25,    26,    27,    28,    29,
     394,    90,    32,   396,   390,   392,   391,    96,   392,   392,
     391,   186,   187,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     8,     9,    10,    11,    12,    90,   203,   391,
     391,   206,   391,    96,   390,   210,    22,    23,    24,    25,
      26,    27,    28,    29,   390,   390,    32,   217,   390,   238,
       8,     9,    10,    11,    12,   390,   357,   357,   390,   315,
     396,   392,   151,   152,    22,    23,    24,    25,    26,    27,
      28,    29,   390,   395,    32,   169,   170,   171,   172,   173,
     174,   175,     7,   177,   178,   179,   180,   181,   151,   152,
     218,     8,     9,    10,    11,    12,   218,   186,   187,   218,
     280,   394,   316,   274,   335,    22,    23,    24,    25,    26,
      27,    28,    29,   238,   203,    32,   332,   206,   300,   324,
     298,   210,   345,   186,   187,   390,   390,   349,   348,    75,
     232,   352,   223,   223,     8,     9,    10,    11,    12,   390,
     203,   390,    20,   206,   390,   336,    68,   210,    22,    23,
      24,    25,    26,    27,    28,    29,   218,   366,    32,     8,
       9,    10,    11,    12,   218,   392,   390,   315,   522,   310,
     828,   390,   250,    22,    23,    24,    25,    26,    27,    28,
      29,  1268,   390,    32,     8,     9,    10,    11,    12,   390,
     390,  1529,   361,  1154,  1071,   380,   991,  1060,    22,    23,
      24,    25,    26,    27,    28,    29,   994,  1218,    32,   873,
       8,     9,    10,    11,    12,   390,   391,  1495,   551,   736,
     387,  1603,   801,   398,    22,    23,    24,    25,    26,    27,
      28,    29,   184,  1039,    32,  1605,   802,     8,     9,    10,
      11,    12,  1214,  1302,  1380,   807,  1026,  1076,  1320,   912,
     392,    22,    23,    24,    25,    26,    27,    28,    29,  1336,
    1390,    32,     8,     9,    10,    11,    12,  1568,  1588,  1668,
    1592,  1666,  1591,    -1,   981,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     8,     9,    10,    11,
      12,    -1,   391,    -1,    -1,    -1,    -1,    -1,    -1,   398,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,     8,     9,    10,    11,    12,    -1,   391,    -1,
      -1,    -1,    -1,    -1,    -1,   398,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   392,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     5,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,   392,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,     8,     9,    10,    11,    12,    -1,
      -1,    -1,     5,    -1,   392,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,    45,
      72,    -1,    -1,    -1,    -1,    77,    -1,    19,    -1,    -1,
      -1,    -1,    81,    82,    -1,    84,    85,    -1,    -1,    -1,
      92,    -1,    -1,    -1,    -1,   392,    72,    73,    74,    -1,
      76,    77,    -1,    79,    -1,    -1,    -1,    83,    -1,   108,
      86,    -1,    -1,    -1,    90,    91,    41,    -1,    94,    95,
      45,    -1,    -1,   125,   100,    -1,    -1,    -1,    81,    82,
      -1,    84,    85,    -1,    -1,    -1,    -1,    -1,   392,    -1,
     139,    66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   130,    -1,    -1,    -1,    83,   135,
      -1,    86,    -1,   392,    -1,    90,    91,    -1,    93,    94,
      95,    45,    -1,    -1,    -1,   100,    -1,    -1,    -1,    -1,
      -1,    -1,   107,    -1,    -1,    -1,   139,    -1,   392,    -1,
      -1,    -1,    -1,   192,   193,    -1,   195,   196,   197,   198,
     199,   200,   201,    -1,   129,   130,    -1,    -1,    -1,    83,
     135,   213,    86,    -1,   392,    -1,    90,    91,    -1,    93,
      94,    95,    -1,    -1,    -1,    -1,   100,   169,   170,   171,
     172,   173,   174,   175,    -1,   177,   178,   179,   180,   181,
      -1,   392,   241,   242,   243,   244,   245,   246,   247,   248,
     249,    -1,    -1,    -1,    -1,    -1,   130,     8,     9,    10,
      -1,   135,    -1,    -1,    -1,    -1,   392,    -1,   267,   268,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,   281,
      -1,    32,    -1,    -1,   283,   284,   285,   286,   241,   242,
     243,   244,   245,   246,   247,   248,   249,    -1,   390,    -1,
      -1,    -1,     8,     9,    10,    11,    12,    45,    -1,    -1,
      -1,    -1,    50,    -1,   267,   268,    22,    23,    24,    25,
      26,    27,    28,    29,   390,    -1,    32,    65,    -1,    -1,
     283,   284,   285,   286,    -1,    -1,    -1,   339,    -1,    -1,
      -1,    79,   344,    -1,    -1,    83,   220,   221,    86,    45,
      -1,   390,    90,    91,    92,    93,    94,    95,    -1,    -1,
      -1,    -1,   100,    -1,    -1,    -1,   104,    -1,   370,   107,
      -1,   109,    -1,    -1,    -1,    -1,   390,    -1,    -1,    -1,
      -1,    -1,   307,   385,   383,   384,    -1,    83,    -1,    -1,
      86,    -1,   130,    -1,    90,    91,    -1,   135,    94,    95,
      -1,   390,    -1,    -1,   100,    -1,    -1,    -1,    -1,    -1,
      -1,   149,    -1,   151,    -1,    -1,    45,    -1,    -1,   395,
      -1,    -1,   160,    -1,    -1,    -1,   390,    -1,    -1,    -1,
     383,   384,    -1,    -1,   130,    -1,    -1,    -1,    -1,   135,
      -1,    -1,    -1,    -1,    -1,    -1,   371,   372,   373,    -1,
      -1,    -1,    -1,    -1,    83,   380,    -1,    86,   196,    -1,
      -1,    90,    91,    -1,    93,    94,    95,    -1,    -1,    -1,
     395,   100,    -1,    -1,    -1,   213,    -1,   183,    -1,    -1,
      -1,    -1,   220,   221,    -1,   223,    -1,   225,   226,    -1,
     228,   229,    -1,   231,    -1,    45,   234,   235,    -1,   237,
      -1,   130,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,
      45,    -1,   250,   251,    -1,    65,    -1,   255,    -1,   257,
     258,   395,   260,    -1,    -1,    -1,    -1,   265,    45,    -1,
      -1,   269,   270,    83,   272,   273,    86,   275,   276,   277,
      90,    91,    -1,   172,    94,    95,    65,    -1,    83,    -1,
     100,    86,    -1,    -1,    -1,    90,    91,    74,    -1,    94,
      95,    -1,    -1,    -1,    -1,   100,    83,    -1,    -1,    86,
      -1,    45,    -1,    90,    91,    -1,    -1,    94,    95,    -1,
     130,    -1,    -1,   100,    -1,   135,   282,    -1,   107,    -1,
      -1,   287,   288,   289,    -1,   130,    -1,    -1,   115,   149,
     135,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,
     129,   143,    86,   130,    -1,    -1,    90,    91,   135,    93,
      94,    95,    -1,   142,    -1,    -1,   100,   323,     3,    -1,
      -1,     8,     9,    10,   330,    -1,    -1,   156,   334,    -1,
     172,    -1,    -1,    18,    19,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,   130,   395,    -1,    -1,
      -1,   135,    -1,    -1,    -1,    -1,     3,    -1,    -1,    44,
      -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,   214,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,   213,    32,    -1,   216,   217,   395,
      -1,    -1,   234,    -1,    -1,    -1,    -1,    -1,    83,    -1,
      -1,    -1,    -1,    88,    -1,    -1,    -1,    -1,    -1,   269,
      95,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   106,   361,   362,    -1,    -1,   365,    -1,    -1,    -1,
     115,   116,   117,   118,    -1,   120,   121,    -1,   280,    -1,
      -1,    -1,    -1,    -1,   273,    -1,    -1,   276,    -1,    -1,
      -1,   280,    -1,    -1,    -1,    -1,   395,    -1,    -1,   288,
      -1,   290,    -1,   292,   293,   294,   295,   296,   297,    -1,
      -1,    -1,    45,    -1,   303,    -1,    -1,    -1,   307,   308,
      -1,    -1,   311,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   323,   340,   341,    70,    71,    -1,
      -1,    -1,   331,    -1,   346,   347,    -1,    80,   350,   351,
      -1,   353,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   361,
     362,    -1,     8,     9,    10,    11,    12,   212,    -1,    -1,
      -1,   104,    -1,    -1,    -1,   395,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,
     395,    -1,    -1,   395,    -1,    -1,    -1,    -1,    -1,   132,
      -1,    -1,   135,    -1,   137,    -1,   395,    -1,   395,    -1,
      -1,   144,    -1,   146,    -1,    -1,    -1,    -1,   151,   152,
     153,    -1,    -1,    -1,    -1,   158,   159,   160,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   395
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   401,   402,    45,    70,    71,    80,   104,   132,
     135,   137,   144,   146,   151,   152,   153,   158,   159,   160,
     426,   427,   428,   429,   430,   431,   482,   483,   484,   485,
     487,   488,   489,   492,   495,   498,   499,   500,   501,   502,
     503,   504,   505,   506,   507,   508,   509,   510,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   589,   626,   627,
     628,   629,   630,   631,   632,   633,   687,   689,     0,     3,
      33,    42,    45,    56,    69,    79,    83,    86,    88,    89,
      96,   123,   124,   135,   158,   161,   390,   403,   415,   421,
     424,   425,   434,   436,   439,   441,   444,   446,   447,   449,
     450,   457,   467,   468,   524,   526,   536,   575,   578,   590,
     592,   593,   594,   635,   636,   637,   642,   672,   673,   681,
     682,   688,   690,   691,   692,    19,    20,    44,   522,    20,
      55,    63,    64,    65,   432,     3,   522,   522,   133,   134,
     522,   522,     3,   123,   113,   114,   123,   138,   147,   149,
     150,   213,   281,   385,   123,   123,    78,   111,   113,   114,
     154,   155,   156,   157,    13,    15,    16,    17,    18,    19,
      20,    26,    27,    29,    31,    90,    96,   151,   152,   186,
     187,   203,   206,   210,   391,   398,   541,   554,   559,   562,
     563,   564,   566,   568,    35,    44,   394,   511,   522,    19,
      19,    20,    43,    54,   413,   417,    67,   113,   119,    42,
      61,    88,   149,   422,   423,    49,    66,    80,    19,    87,
      19,    83,   125,   113,   413,   568,    19,    19,   108,   451,
     451,   394,    72,    77,    92,   125,   213,   281,   339,   344,
     370,   385,   451,    45,    83,    86,    90,    91,    93,    94,
      95,   100,   130,   135,   395,   452,   470,   451,   451,    50,
      65,    79,    92,    93,   104,   107,   109,   149,   151,   160,
     196,   213,   220,   221,   223,   225,   226,   228,   229,   231,
     234,   235,   237,   250,   251,   255,   257,   258,   260,   265,
     269,   270,   272,   273,   275,   276,   277,   395,   452,   451,
     282,   287,   288,   289,   323,   330,   334,   395,   452,   595,
     596,   597,   451,   340,   341,   395,   452,   451,   451,    41,
      66,    93,   107,   129,   307,   371,   372,   373,   380,   395,
     452,   477,   479,   480,   451,    65,   149,   269,   395,   452,
     683,   686,    72,    73,    74,    76,    77,    79,   395,   435,
     438,   452,    74,   115,   395,   437,   452,    35,    44,   394,
     471,   432,     3,     3,   432,    66,   433,     3,     3,   522,
     522,     3,    35,    44,   394,   474,    83,   497,    19,    20,
      44,   523,     3,   148,   493,     3,     3,   490,   496,   224,
      19,    93,   156,   322,   337,   338,   486,   486,    18,    19,
     407,   409,   409,     3,     3,     3,     3,     3,     3,     3,
       3,    15,    19,    28,   391,   397,   558,   560,   566,    29,
     391,   211,    27,   211,    15,   397,   561,   568,   391,   391,
     391,   391,   391,   391,   188,   189,   190,   191,   548,   568,
      15,    16,    17,    19,   391,   541,   542,   546,   549,   550,
     552,   554,   555,   556,     5,    81,    82,    84,    85,   108,
     139,   192,   193,   195,   196,   197,   198,   199,   200,   201,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   267,
     268,   283,   284,   285,   286,   383,   384,   567,   693,     3,
       8,     9,    10,    11,    12,    22,    23,    24,    25,    26,
      27,    28,    29,    32,    45,    46,    47,    48,    49,    50,
      51,    52,    53,   419,   420,    15,   512,     3,    22,    62,
     416,    44,   394,   418,    15,    19,    34,    35,    36,    37,
      68,   391,   404,   406,   471,   404,    20,    57,    58,   390,
     404,   405,   405,   142,   131,   445,    15,    17,    18,   108,
     440,   525,    19,   442,   474,   390,   537,   108,    19,   394,
     394,   448,   394,   471,    19,   456,    87,   404,   406,   469,
      44,    68,    96,    97,   105,   212,   453,   533,    68,   453,
      68,   413,   474,   390,   390,   394,   394,   142,   239,   280,
      80,   390,    20,   240,   413,   406,    68,   278,   149,   254,
     128,   406,   390,   404,   407,   591,   145,   407,    75,   227,
     238,    75,   225,   232,   242,   243,   236,   238,   252,   253,
     252,   256,   406,   259,   261,   266,    83,   236,    92,   271,
     236,   274,   272,   406,   223,   390,   394,   440,   406,    86,
     404,   406,    87,   321,   390,   394,   394,    83,   342,   343,
     390,   394,   394,   404,    75,   679,   680,   413,   394,    97,
     378,   379,   674,   404,   404,    75,   221,   381,   382,   390,
     390,   394,   394,   280,   409,    83,   390,   167,   230,   262,
     271,   386,   387,   388,   389,   390,    83,   406,    75,   406,
      78,    80,   390,   390,   390,    75,    20,   414,   390,   390,
      78,    98,    99,   111,   112,   114,   472,   473,     3,   433,
       3,   404,     3,     3,     3,    98,   136,   475,   476,     3,
      19,     3,   523,     3,     3,     3,    83,   118,   133,   145,
     494,     3,    44,    83,    88,    95,    96,   106,   115,   116,
     117,   118,   120,   121,   409,   491,   533,     3,    19,    83,
      88,    89,    96,   123,   161,   486,   486,   486,   634,    44,
     486,    44,   486,     3,     3,    29,   393,   411,   143,   143,
     560,   560,   568,   560,   560,    14,    15,   568,   572,   573,
      26,   211,    27,   561,   561,    29,   568,   568,   568,   568,
     568,    19,    15,   396,   392,   396,    28,   544,   545,   548,
     568,     7,   396,   399,    26,    27,   394,   396,   399,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   171,   194,   202,   207,   208,   395,   396,     3,
     568,   413,   419,   390,   405,   568,   404,    59,    60,    59,
      60,    38,    39,    40,   404,   464,   465,   390,   169,   170,
     171,   172,   173,   174,   175,   177,   178,   179,   180,   181,
     527,   528,   529,   531,   535,    41,   126,   127,   128,   390,
     443,   390,   391,   534,    19,   123,   395,   440,   458,   461,
     462,    35,   404,   455,    19,   531,   532,   106,   568,   455,
     455,   577,    75,    75,   406,    75,   279,   406,   390,    50,
     390,   390,   404,   216,   217,   406,   264,   406,   407,   390,
     390,    30,   408,    41,   145,   390,   404,   145,   404,    75,
      75,   404,    75,   105,   233,   404,   404,   406,    75,   390,
      87,   390,   406,   390,   406,   233,   262,   263,   406,   456,
     406,   390,   390,   406,   406,   406,   390,   145,   406,    68,
     404,   406,   598,    19,   390,   390,   641,   390,   404,   462,
     390,   478,   479,   390,   390,   390,   404,   390,   390,   390,
      87,   122,   166,   481,   406,   456,    20,   407,   407,   230,
     684,   685,   404,   404,   406,   406,   404,   407,   409,   410,
     395,   396,     3,   395,   396,     3,    19,    15,   409,    19,
      19,   532,   410,    19,     3,    20,   625,   625,     3,    19,
      86,   233,   280,   282,   297,   328,   329,   486,   625,   486,
     625,   404,   407,    15,    15,   392,   396,   392,    27,   396,
     396,   396,   392,   396,   392,   396,   568,   568,     7,   396,
     396,   392,    18,   391,   542,   550,    15,    18,   555,   391,
     420,   390,   395,   392,    20,   390,   462,   390,    19,   176,
     390,   394,   404,   407,   392,   528,   530,   535,   409,    27,
     460,   396,   101,   454,   406,    93,   220,   221,   395,   452,
     576,   404,   404,   390,   404,   390,   390,   406,   390,   390,
     390,   390,   406,   390,   390,    19,   591,   404,   404,   390,
     404,   390,   404,   404,   390,   404,   390,   390,   390,   390,
     390,   404,   440,   390,   390,   390,   390,   390,   390,   390,
     390,   390,   390,   390,   390,   404,   404,    93,   148,   234,
     288,   312,   314,   319,   321,   325,   326,   395,   599,   606,
     609,   390,    93,   172,   361,   362,   365,   395,   452,   638,
     390,   394,   678,   395,   390,   390,   404,   108,   110,   108,
     110,   395,   390,   390,   408,   407,   324,   684,   473,   476,
       3,     3,   440,   440,    15,   440,   625,     3,   625,     3,
     145,   145,   572,    27,   568,   568,   568,   568,   568,   396,
     392,   544,   568,   545,   547,   568,   568,   396,   568,   529,
      19,    50,    90,   162,   163,   164,   165,   166,   167,   168,
     182,   185,   538,   539,   564,   565,   569,   574,   390,   392,
     143,    20,   410,   459,   461,    80,   102,   103,   104,   579,
     583,   579,   584,   407,   588,   390,   396,   390,   390,   390,
     390,   390,   390,   390,   390,   390,   390,   390,   390,   618,
     624,   406,   290,   291,   325,   290,   406,   600,   280,   409,
     602,   603,   601,   327,   406,   390,   330,   619,   643,   651,
     409,   652,   657,   639,   640,   409,   390,   677,   478,   390,
      20,   412,   412,   412,   412,   408,   404,     3,     3,    15,
      15,   392,   392,   392,   392,   396,   568,   392,   396,    15,
     392,    22,   391,    22,   391,   568,   568,   568,   395,   574,
     567,   693,   390,   568,   570,   571,   530,    15,   410,   462,
     463,   394,   582,    30,   222,   585,   404,   462,   620,   404,
     404,   406,   404,   394,   440,   394,   394,   404,   404,   394,
     463,   394,   656,   394,   407,   658,   663,    20,   394,   664,
     669,   217,   236,   273,   341,   395,   676,   481,   390,   390,
     390,   390,   497,   497,   568,   392,     7,    28,   547,   395,
     568,   573,   568,   564,   390,   183,   394,    22,    22,    32,
     396,   390,   145,   582,   581,    19,   413,   223,   586,   390,
     621,   394,   623,   611,   604,   611,   607,   394,   650,   655,
     654,   659,   665,   140,   141,   295,   466,   404,   274,   298,
     374,   375,   376,   377,   675,   390,   481,   481,   481,   481,
       3,     3,   392,   391,   392,     7,   392,   390,   392,   390,
     693,   394,   540,   574,   557,   568,   568,    96,   151,   152,
     206,   211,   571,    15,   109,   214,   215,   218,   219,   395,
     580,   407,   220,   587,   619,   622,   395,   409,   612,   613,
     148,   290,   313,   395,   605,   395,   142,   292,   293,   294,
     296,   307,   395,   477,   608,   649,   648,   354,   355,   358,
     359,   360,   395,   653,   662,   668,   404,   404,   404,   217,
     406,   544,   547,   392,   538,   184,     6,    15,    16,    17,
     391,   395,   541,   543,   546,   549,   551,   553,   390,   390,
     391,   391,   391,   391,   390,   390,   406,   216,   217,   217,
     405,   404,   390,   406,    65,   142,   156,   213,   216,   217,
     273,   276,   280,   288,   290,   292,   293,   294,   295,   296,
     297,   303,   307,   308,   311,   323,   331,   395,   477,   610,
     313,   320,   614,   406,   404,   406,   390,   404,   404,   404,
     238,   117,   404,    97,   306,   309,   390,   143,   172,   214,
     234,   280,   346,   347,   350,   351,   353,   361,   362,   395,
     644,   357,   357,   406,   406,   406,   390,   357,   363,   395,
     660,   357,   364,   395,   666,   315,   396,   392,   390,   395,
     540,   538,   568,     7,   393,   396,   568,   568,   568,   568,
     218,   218,   218,   280,   404,   394,   406,   316,   295,   333,
     466,   274,   406,   335,   406,   404,   404,   404,   238,   404,
     117,   404,   298,   299,   300,   301,   302,   303,   304,   305,
     332,    97,   306,   309,   300,   404,   324,   298,   390,   404,
     390,   404,   404,   345,   657,   238,   345,    90,   357,   349,
     406,   348,    75,   352,   232,   223,   645,   223,   646,   390,
     404,   404,   356,   404,   670,   658,   661,   390,   670,   664,
     667,   390,   544,   392,   391,   543,   538,   551,   392,   392,
     392,   392,   405,   405,   405,   406,   615,   317,   318,   404,
     404,   404,   217,   406,   336,   404,   404,   406,   406,   404,
     406,   218,   404,   218,   367,   368,   369,   647,   404,   404,
     406,   404,   404,    68,   406,   663,   406,   669,   366,   671,
     671,   404,   392,   568,   390,   390,   390,   390,   395,   407,
     617,   315,   406,   404,   404,   671,   404,   406,   310,   616,
     390
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   400,   401,   401,   402,   402,   403,   404,   404,   404,
     405,   405,   405,   406,   406,   406,   406,   406,   406,   407,
     407,   408,   408,   409,   410,   410,   411,   411,   412,   413,
     413,   414,   414,   415,   416,   416,   417,   417,   417,   418,
     418,   419,   419,   420,   420,   420,   420,   420,   420,   420,
     420,   420,   421,   421,   422,   422,   422,   422,   423,   423,
     423,   423,   423,   423,   424,   425,   425,   425,   425,   426,
     427,   428,   429,   430,   431,   432,   432,   433,   433,   433,
     434,   435,   435,   435,   435,   435,   436,   437,   437,   438,
     439,   439,   440,   440,   440,   441,   442,   442,   443,   443,
     443,   443,   444,   445,   445,   446,   447,   448,   448,   449,
     449,   450,   450,   451,   451,   451,   451,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   453,   453,   453,   453,   454,   454,   454,   454,   454,
     455,   455,   456,   457,   457,   458,   459,   459,   459,   460,
     460,   461,   462,   462,   463,   464,   465,   466,   466,   467,
     468,   468,   468,   469,   470,   471,   471,   471,   472,   472,
     473,   473,   473,   473,   473,   473,   474,   474,   474,   475,
     475,   476,   476,   477,   477,   478,   478,   479,   479,   480,
     481,   481,   481,   481,   481,   481,   482,   483,   484,   485,
     486,   486,   487,   488,   489,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   491,   491,
     491,   492,   493,   493,   493,   493,   494,   494,   494,   495,
     496,   496,   496,   496,   496,   496,   496,   496,   497,   497,
     498,   499,   500,   501,   502,   503,   504,   505,   506,   507,
     508,   509,   510,   511,   511,   511,   512,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   522,   522,
     523,   523,   523,   525,   524,   526,   527,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   528,
     529,   529,   530,   530,   531,   532,   532,   533,   534,   534,
     535,   537,   536,   538,   538,   539,   539,   540,   540,   541,
     542,   542,   542,   542,   542,   542,   543,   543,   543,   543,
     543,   544,   545,   545,   545,   546,   546,   547,   548,   548,
     548,   548,   549,   549,   549,   550,   550,   550,   550,   551,
     551,   551,   551,   552,   552,   553,   553,   554,   555,   555,
     555,   555,   556,   556,   557,   557,   557,   558,   558,   559,
     559,   560,   560,   560,   560,   560,   561,   561,   561,   562,
     562,   562,   562,   562,   562,   562,   562,   562,   562,   562,
     563,   563,   564,   565,   566,   567,   567,   567,   567,   567,
     567,   567,   567,   567,   567,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   568,   568,   568,   568,   568,   568,   568,   568,
     568,   568,   569,   569,   569,   569,   569,   569,   570,   571,
     571,   571,   572,   572,   573,   573,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   575,   576,   576,   576,   576,   577,   577,   578,
     579,   580,   580,   580,   580,   580,   580,   581,   581,   582,
     582,   583,   584,   585,   585,   585,   586,   586,   587,   587,
     588,   589,   590,   591,   591,   591,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   592,   592,   592,   592,   592,   592,
     592,   592,   592,   592,   593,   594,   594,   595,   595,   595,
     595,   595,   595,   595,   595,   595,   596,   597,   598,   598,
     599,   599,   599,   599,   599,   599,   599,   599,   599,   600,
     599,   601,   599,   599,   599,   599,   602,   602,   603,   604,
     604,   605,   605,   605,   606,   606,   607,   607,   608,   608,
     608,   608,   608,   608,   608,   608,   608,   608,   608,   609,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   610,
     610,   610,   610,   610,   610,   610,   610,   610,   610,   611,
     611,   612,   613,   614,   614,   614,   615,   615,   616,   616,
     617,   618,   619,   619,   621,   620,   622,   622,   623,   623,
     624,   625,   625,   626,   627,   628,   629,   630,   631,   632,
     633,   634,   634,   634,   634,   634,   634,   634,   634,   634,
     635,   636,   636,   636,   636,   636,   637,   638,   638,   638,
     639,   638,   640,   638,   638,   641,   641,   642,   643,   644,
     644,   644,   644,   644,   644,   644,   644,   644,   644,   644,
     644,   645,   644,   646,   644,   644,   644,   647,   647,   647,
     648,   649,   649,   650,   650,   651,   652,   653,   653,   653,
     653,   653,   654,   655,   655,   656,   656,   657,   658,   659,
     660,   660,   660,   661,   662,   662,   663,   663,   664,   665,
     666,   666,   666,   667,   668,   668,   669,   669,   670,   670,
     671,   671,   672,   673,   673,   673,   673,   673,   673,   673,
     673,   673,   673,   673,   673,   673,   674,   674,   674,   675,
     675,   675,   675,   675,   676,   676,   676,   676,   676,   676,
     676,   677,   677,   678,   678,   679,   680,   681,   682,   682,
     682,   682,   682,   683,   684,   684,   685,   685,   686,   686,
     686,   686,   686,   686,   686,   686,   686,   687,   688,   688,
     688,   688,   688,   688,   688,   688,   688,   688,   688,   688,
     688,   688,   688,   688,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     689,   689,   689,   689,   689,   689,   689,   689,   689,   689,
     689,   690,   690,   690,   690,   690,   690,   690,   690,   690,
     690,   691,   691,   691,   691,   692,   692,   692,   693,   693,
     693,   693,   693,   693,   693,   693,   693,   693,   693,   693,
     693,   693,   693,   693,   693,   693,   693,   693,   693,   693,
     693
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     3,     2,     3,     3,     3,
       4,     5,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     5,     0,     1,     3,     3,     0,     8,     1,
       4,     1,     1,     0,     1,     2,     3,     0,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     4,     2,     3,
       2,     2,     1,     1,     1,     0,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     0,     1,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       3,     3,     3,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       1,     4,     0,     3,     3,     3,     0,     1,     1,     4,
       0,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       9,     9,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     3,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     3,     1,     3,     1,     1,     1,     2,     3,     2,
       4,     0,     5,     0,     1,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     1,     3,     1,     1,
       1,     1,     1,     3,     1,     5,    11,     1,     1,     1,
       2,     1,     7,     9,     7,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     3,     1,     3,     3,     1,     2,
       2,     6,     1,     3,     0,     4,     3,     1,     3,     3,
       3,     2,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       5,     7,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     1,     1,     1,     1,     2,     2,     3,     3,     6,
       3,     3,     3,     3,     5,     6,     6,     6,     6,     4,
       8,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     3,     1,     3,     0,     1,     4,     6,     4,     3,
       5,     5,     4,     6,     3,     2,     5,     5,     8,     8,
       8,     8,     2,     1,     2,     2,     2,     0,     3,     5,
       0,     2,     4,     4,     4,     2,     2,     0,     3,     0,
       3,     3,     2,     0,     2,     2,     0,     2,     0,     2,
       4,     5,     2,     0,     3,     3,     3,     3,     5,     6,
       4,     6,     4,     6,     4,     4,     5,     6,     3,     3,
       4,     5,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     5,     4,     2,     3,     3,     1,     2,     3,
       2,     4,     3,     2,     3,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     3,     4,     2,     2,     1,     0,
       2,     3,     1,     0,     1,     2,     0,     2,     0,     1,
       3,     0,     0,     2,     0,     3,     0,     3,     0,     3,
       3,     1,     0,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     1,     2,     2,
       0,     3,     0,     3,     2,     0,     3,     5,     0,     4,
       4,     3,     2,     3,     3,     3,     3,     4,     4,     3,
       2,     0,     3,     0,     3,     3,     3,     1,     1,     1,
       0,     0,     3,     0,     3,     4,     1,     2,     2,     2,
       4,     4,     0,     0,     3,     0,     3,     3,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     0,
       0,     2,     2,     0,     0,     3,     1,     5,     1,     2,
       0,     2,     2,     3,     3,     4,     4,     4,     5,     5,
       4,     3,     4,     4,     4,     4,     1,     1,     1,     1,
       1,     1,     1,     1,     0,     2,     2,     2,     3,     3,
       4,     0,     3,     0,     3,     0,     3,     2,     3,     3,
       5,     5,     3,     2,     3,     3,     1,     2,     4,     3,
       3,     3,     2,     2,     2,     2,     2,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     1,     2,     2,     2,     1,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 738 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 739 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 752 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 762 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 763 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 770 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 771 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 772 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 780 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 781 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 782 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 783 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 784 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 785 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 792 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 800 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 804 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 816 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 820 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 827 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 836 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3960 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 843 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3972 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 850 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3989 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3995 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 864 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 4005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 869 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 4011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 4017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 875 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 4035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 4041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 4047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 4053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 4059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 4065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 4071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 889 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 4077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 890 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 4083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 891 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 4089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 4095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 898 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 4101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 899 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 4111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 909 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 4117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 910 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 4123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 911 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 4129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 912 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 4135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 915 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 4141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 916 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 4147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 917 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 4153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 918 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 919 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 920 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 930 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 931 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 932 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 933 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 942 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 945 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 952 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 955 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 958 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 961 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 969 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 971 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 979 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4261 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 984 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4267 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 985 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 989 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 996 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 997 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1003 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1008 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1012 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1026 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1040 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1047 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4367 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1066 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4373 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1067 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4379 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1068 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4385 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1069 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4391 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1074 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1081 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1085 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1093 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4427 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1099 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4435 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1113 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4441 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4447 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1118 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1124 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4467 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     this_proto->name = s->name;
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1134 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4491 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1146 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1150 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4506 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1151 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1152 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4518 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1153 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4524 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1154 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4530 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1155 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4536 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1156 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4542 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1157 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4548 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1158 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1159 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1160 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1165 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1167 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4584 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1168 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1172 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4596 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1174 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4608 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1175 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1176 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1180 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4631 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1186 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1190 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1198 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1199 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1207 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4668 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1215 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4674 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1216 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4680 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1217 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1221 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1222 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1236 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1238 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1251 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1257 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4735 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1270 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4745 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1284 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4751 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1285 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1286 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1291 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1295 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4775 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4781 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1297 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1298 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4793 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1299 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4799 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1300 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4805 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1306 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4811 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4817 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4823 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1313 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1317 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1318 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1339 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1357 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1358 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1359 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1360 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1361 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1362 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1371 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1374 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1377 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1380 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1384 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1388 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1395 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1398 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4955 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1403 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4966 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1409 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4978 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1416 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1421 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1426 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 5008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1431 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 5017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1435 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 5026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 5035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1443 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1452 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 5062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1460 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 5071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1464 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 5080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1471 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 5086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1472 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 5092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1473 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 5098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1479 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 5104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1482 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 5116 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1489 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 5128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1496 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 5137 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1500 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1508 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 5153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1509 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1510 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1516 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1519 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5179 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5185 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1523 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5191 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1524 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5197 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1525 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5203 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1526 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5209 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1527 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5215 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1528 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5221 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1533 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1538 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5241 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1547 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5259 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1569 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1571 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1573 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1575 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1579 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1581 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1583 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1586 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1589 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5331 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1595 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1596 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5343 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1597 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5349 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1601 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5355 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1602 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1611 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1613 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1615 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1617 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1619 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1623 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1627 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1630 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1633 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1635 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1640 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1641 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1649 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1650 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5471 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1659 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1663 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1664 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5489 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1665 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5495 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1666 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5501 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1667 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5507 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1668 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1669 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1670 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1672 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1673 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1674 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1675 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1696 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5585 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1707 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1708 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1715 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1716 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1723 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1732 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5635 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1740 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1764 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1765 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1769 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1785 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5708 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1798 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5714 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1799 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1802 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1819 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1832 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1833 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1834 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1835 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 5787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1840 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 5797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1848 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5803 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1851 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5833 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5839 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5845 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1861 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1865 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1868 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5870 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1877 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5876 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5882 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1881 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5888 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1882 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5894 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5900 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5906 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5912 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1889 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5918 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1895 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5924 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1896 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5930 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5936 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1903 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5942 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1908 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5948 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5954 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1917 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1924 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1925 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1926 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1927 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5990 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5996 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1935 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 6002 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 6008 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 6020 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 6032 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1958 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6038 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6044 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6050 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 6056 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1968 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 6062 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1969 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 6068 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1970 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 6074 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1971 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 6080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1972 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1976 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 6092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1977 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 6098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1978 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 6104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1982 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 6110 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1983 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 6116 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1984 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 6122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1985 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 6128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1987 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 6140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1988 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 6146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1989 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 6152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1990 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6158 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1991 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6164 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1992 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6170 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1996 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6176 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1997 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6182 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 2011 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6207 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2034 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6224 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2048 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2049 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2050 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2052 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2062 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6302 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2068 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2069 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2070 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2071 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2072 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6356 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2073 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6362 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2074 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2075 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2076 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2084 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2088 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2089 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2090 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2091 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2092 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6458 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6464 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6470 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2106 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6476 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2107 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6482 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2108 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6488 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2110 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6494 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2111 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6500 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6525 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2139 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6531 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6537 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2141 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6549 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2144 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6561 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2148 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6567 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2151 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6573 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2152 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6579 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2153 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6590 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2161 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6602 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2168 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2177 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6620 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2178 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6626 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2182 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6637 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2188 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2198 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6666 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2207 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2218 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6699 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2225 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2230 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6720 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6726 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6732 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2238 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2246 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2247 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2248 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2249 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2250 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2257 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2284 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2295 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2296 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2299 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2300 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2314 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2317 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2321 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2322 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2323 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2327 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2328 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2332 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2333 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2337 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2356 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2361 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
#line 6944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2387 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 6950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2388 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 6956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2394 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2395 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2397 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 6979 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2403 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 6985 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6991 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2405 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2406 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 7003 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2407 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 7009 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 7015 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 7021 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 7027 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2411 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 7033 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2412 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 7039 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 7045 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 7051 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2415 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 7057 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2416 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 7063 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2417 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 7069 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2418 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 7075 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2419 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 7081 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2420 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 7087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2421 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 7093 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2422 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 7099 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2423 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 7105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2424 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 7111 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2425 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 7117 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2426 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 7123 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2427 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 7129 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2428 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 7135 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2429 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 7141 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2430 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 7147 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2431 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 7153 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2432 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7159 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2433 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7165 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2434 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7171 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2435 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2436 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2437 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2438 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2439 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7206 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7212 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2446 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7218 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2447 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7224 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2448 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7230 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2449 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7236 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2450 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7242 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2451 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7248 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2452 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7254 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2453 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7260 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2454 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7266 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2455 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7272 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2456 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7278 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2457 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7284 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2458 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7290 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2459 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2470 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7314 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2487 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2488 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 7326 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2489 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7332 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2490 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7338 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2491 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7344 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2492 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7350 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2496 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7368 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2511 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7374 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2520 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7380 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2521 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7386 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2522 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7392 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2523 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7398 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2524 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7404 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2525 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 7410 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2526 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7416 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2527 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7422 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2528 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7428 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2529 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7434 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2530 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7440 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2542 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7451 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7457 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2557 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7463 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2558 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7469 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2562 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7475 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2563 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2572 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7487 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2573 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7493 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2574 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7499 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2575 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7505 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2576 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7511 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2577 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7517 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2578 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 7523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7529 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7535 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7541 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 7562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2604 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2605 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7574 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2606 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7580 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2607 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2608 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7592 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7598 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7604 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7610 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7616 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7622 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7628 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7634 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7640 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7646 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2618 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7652 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2619 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 7658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2620 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 7664 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2621 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7670 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2622 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7676 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2623 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2624 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7688 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2625 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7694 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2626 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7700 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2627 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 7706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2629 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 7712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2630 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2631 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2632 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2633 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2634 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2635 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2636 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2637 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2640 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2641 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7784 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2642 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2663 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7807 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2664 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7813 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2673 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7819 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2674 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2678 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2687 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2710 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 7872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2728 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2739 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2742 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2745 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2750 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2753 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2758 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2761 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2765 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2771 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2772 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2773 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2775 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2776 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2777 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2784 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7997 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2793 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 8007 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 8013 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2799 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 8019 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2806 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_radv, (yyvsp[-1].i));
  init_list(&RADV_CFG->patt_list);
  init_list(&RADV_CFG->pref_list);
  init_list(&RADV_CFG->rdnss_list);
  init_list(&RADV_CFG->dnssl_list);
}
#line 8031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2817 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_CFG->pref_list, NODE this_radv_prefix); }
#line 8037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->rdnss_list, &radv_dns_list); }
#line 8049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_CFG->dnssl_list, &radv_dns_list); }
#line 8061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_CFG->trigger_prefix = (yyvsp[0].px).addr;
     RADV_CFG->trigger_pxlen = (yyvsp[0].px).len;
     RADV_CFG->trigger_valid = 1;
   }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2837 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct radv_iface_config));
  add_tail(&RADV_CFG->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  init_list(&RADV_IFACE->pref_list);
  init_list(&RADV_IFACE->rdnss_list);
  init_list(&RADV_IFACE->dnssl_list);

  RADV_IFACE->min_ra_int = -1; /* undefined */
  RADV_IFACE->max_ra_int = DEFAULT_MAX_RA_INT;
  RADV_IFACE->min_delay = DEFAULT_MIN_DELAY;
  RADV_IFACE->current_hop_limit = DEFAULT_CURRENT_HOP_LIMIT;
  RADV_IFACE->default_lifetime = -1;
  RADV_IFACE->default_lifetime_sensitive = 1;
  RADV_IFACE->default_preference = RA_PREF_MEDIUM;
}
#line 8092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 709:
#line 2855 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_ra_int = (yyvsp[0].i); if ((yyvsp[0].i) < 3) cf_error("Min RA interval must be at least 3"); }
#line 8098 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2856 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->max_ra_int = (yyvsp[0].i); if (((yyvsp[0].i) < 4) || ((yyvsp[0].i) > 1800)) cf_error("Max RA interval must be in range 4-1800"); }
#line 8104 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2857 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->min_delay = (yyvsp[0].i); if ((yyvsp[0].i) <= 0) cf_error("Min delay must be positive"); }
#line 8110 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2858 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->managed = (yyvsp[0].i); }
#line 8116 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2859 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->other_config = (yyvsp[0].i); }
#line 8122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2860 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->link_mtu = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Link MTU must be 0 or positive"); }
#line 8128 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2861 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->reachable_time = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 3600000)) cf_error("Reachable time must be in range 0-3600000"); }
#line 8134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2862 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->retrans_timer = (yyvsp[0].i); if ((yyvsp[0].i) < 0) cf_error("Retrans timer must be 0 or positive"); }
#line 8140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2863 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->current_hop_limit = (yyvsp[0].i); if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255))  cf_error("Current hop limit must be in range 0-255"); }
#line 8146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 718:
#line 2864 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_IFACE->default_lifetime = (yyvsp[-1].i);
     if (((yyvsp[-1].i) < 0) || ((yyvsp[-1].i) > 9000))  cf_error("Default lifetime must be in range 0-9000");
     if ((yyvsp[0].i) != -1) RADV_IFACE->default_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2869 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->default_preference = (yyvsp[0].i); }
#line 8162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&RADV_IFACE->pref_list, NODE this_radv_prefix); }
#line 8168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8174 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2871 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->rdnss_list, &radv_dns_list); }
#line 8180 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { init_list(&radv_dns_list); }
#line 8186 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2872 "cf-parse.y" /* yacc.c:1646  */
    { add_tail_list(&RADV_IFACE->dnssl_list, &radv_dns_list); }
#line 8192 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 725:
#line 2873 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->rdnss_local = (yyvsp[0].i); }
#line 8198 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 726:
#line 2874 "cf-parse.y" /* yacc.c:1646  */
    { RADV_IFACE->dnssl_local = (yyvsp[0].i); }
#line 8204 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 727:
#line 2878 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_LOW; }
#line 8210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 728:
#line 2879 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_MEDIUM; }
#line 8216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2880 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RA_PREF_HIGH; }
#line 8222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 730:
#line 2883 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_iface_config *ic = RADV_IFACE;

  if (ic->min_ra_int == (u32) -1)
    ic->min_ra_int = MAX_(ic->max_ra_int / 3, 3);

  if (ic->default_lifetime == (u32) -1)
    ic->default_lifetime = 3 * ic->max_ra_int;

  if ((ic->min_ra_int > 3) &&
      (ic->min_ra_int > (ic->max_ra_int * 3 / 4)))
    cf_error("Min RA interval must be at most 3/4 * Max RA interval %d %d", ic->min_ra_int, ic->max_ra_int);

  if ((ic->default_lifetime > 0) && (ic->default_lifetime < ic->max_ra_int))
    cf_error("Default lifetime must be either 0 or at least Max RA interval");
}
#line 8243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 736:
#line 2916 "cf-parse.y" /* yacc.c:1646  */
    {
  this_radv_prefix = cfg_allocz(sizeof(struct radv_prefix_config));
  RADV_PREFIX->prefix = (yyvsp[0].px).addr;
  RADV_PREFIX->pxlen = (yyvsp[0].px).len;

  RADV_PREFIX->onlink = 1;
  RADV_PREFIX->autonomous = 1;
  RADV_PREFIX->valid_lifetime = DEFAULT_VALID_LIFETIME;
  RADV_PREFIX->preferred_lifetime = DEFAULT_PREFERRED_LIFETIME;
}
#line 8258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2928 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->skip = (yyvsp[0].i); }
#line 8264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2929 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->onlink = (yyvsp[0].i); }
#line 8270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2930 "cf-parse.y" /* yacc.c:1646  */
    { RADV_PREFIX->autonomous = (yyvsp[0].i); }
#line 8276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2931 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->valid_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Valid lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->valid_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2936 "cf-parse.y" /* yacc.c:1646  */
    {
     RADV_PREFIX->preferred_lifetime = (yyvsp[-1].i);
     if ((yyvsp[-1].i) < 0) cf_error("Preferred lifetime must be 0 or positive");
     if ((yyvsp[0].i) != -1) RADV_PREFIX->preferred_lifetime_sensitive = (yyvsp[0].i);
   }
#line 8296 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2944 "cf-parse.y" /* yacc.c:1646  */
    {
  if (RADV_PREFIX->preferred_lifetime > RADV_PREFIX->valid_lifetime)
    cf_error("Preferred lifetime must be at most Valid lifetime");

  if (RADV_PREFIX->valid_lifetime_sensitive > RADV_PREFIX->preferred_lifetime_sensitive)
    cf_error("Valid lifetime sensitive requires that Preferred lifetime is sensitive too");
}
#line 8308 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2968 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_rdnss_config *cf = cfg_allocz(sizeof(struct radv_rdnss_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->server = (yyvsp[0].a);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8320 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2977 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_RDNSS->lifetime = 0;
  RADV_RDNSS->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 752:
#line 2984 "cf-parse.y" /* yacc.c:1646  */
    { RADV_RDNSS->lifetime = (yyvsp[0].i); RADV_RDNSS->lifetime_mult = radv_mult_val; }
#line 8335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 753:
#line 2988 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No nameserver in RDNSS section");

  struct radv_rdnss_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_RDNSS->lifetime;
    cf->lifetime_mult = RADV_RDNSS->lifetime_mult;
  }
}
#line 8351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 758:
#line 3012 "cf-parse.y" /* yacc.c:1646  */
    {
  struct radv_dnssl_config *cf = cfg_allocz(sizeof(struct radv_dnssl_config));
  add_tail(&radv_dns_list, NODE cf);

  cf->domain = (yyvsp[0].t);
  cf->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;

  if (radv_process_domain(cf) < 0)
    cf_error("Invalid domain dame");
}
#line 8366 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 759:
#line 3024 "cf-parse.y" /* yacc.c:1646  */
    {
  RADV_DNSSL->lifetime = 0;
  RADV_DNSSL->lifetime_mult = DEFAULT_DNS_LIFETIME_MULT;
}
#line 8375 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 762:
#line 3031 "cf-parse.y" /* yacc.c:1646  */
    { RADV_DNSSL->lifetime = (yyvsp[0].i); RADV_DNSSL->lifetime_mult = radv_mult_val; }
#line 8381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 763:
#line 3035 "cf-parse.y" /* yacc.c:1646  */
    {
  if (EMPTY_LIST(radv_dns_list))
    cf_error("No domain in DNSSL section");

  struct radv_dnssl_config *cf;
  WALK_LIST(cf, radv_dns_list)
  {
    cf->lifetime = RADV_DNSSL->lifetime;
    cf->lifetime_mult = RADV_DNSSL->lifetime_mult;
  }
}
#line 8397 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 768:
#line 3059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); radv_mult_val = 0; }
#line 8403 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 769:
#line 3060 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; radv_mult_val = (yyvsp[0].i); if (((yyvsp[0].i) < 1) || ((yyvsp[0].i) > 254)) cf_error("Multiplier must be in range 1-254"); }
#line 8409 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 770:
#line 3064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = -1; }
#line 8415 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 771:
#line 3065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 8421 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 772:
#line 3071 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 8430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 775:
#line 3080 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 8436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 776:
#line 3081 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 8442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 777:
#line 3082 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 8448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 778:
#line 3083 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 8454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 779:
#line 3084 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 8460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 780:
#line 3085 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 8466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 782:
#line 3087 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 8472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 783:
#line 3088 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 8478 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 784:
#line 3089 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 8484 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 786:
#line 3094 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 8490 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 787:
#line 3095 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 8496 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 788:
#line 3096 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 8502 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 789:
#line 3101 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 8508 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 790:
#line 3102 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 8514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 791:
#line 3103 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 8520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 792:
#line 3104 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 8526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 793:
#line 3105 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 8532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 795:
#line 3109 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 8538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 796:
#line 3110 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 8544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 797:
#line 3111 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 8550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 798:
#line 3112 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 8556 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 799:
#line 3113 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 8562 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 800:
#line 3114 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 8568 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 805:
#line 3128 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 8582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 807:
#line 3147 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 810:
#line 3156 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 811:
#line 3157 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 813:
#line 3161 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 8614 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 814:
#line 3170 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 8627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 815:
#line 3178 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 8636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 816:
#line 3185 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 8642 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 817:
#line 3186 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 8648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 818:
#line 3190 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 8658 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 3195 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 8669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 3201 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 8677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 821:
#line 3204 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8686 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 3209 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8692 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 823:
#line 3210 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8698 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 824:
#line 3211 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8704 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 825:
#line 3212 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8710 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 826:
#line 3213 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 827:
#line 3217 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 8722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 895:
#line 3225 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 8728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 896:
#line 3225 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 8734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 899:
#line 3225 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 8740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 908:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 909:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 910:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 911:
#line 3228 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 912:
#line 3229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 913:
#line 3229 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 914:
#line 3230 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 915:
#line 3231 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 916:
#line 3232 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 917:
#line 3233 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 918:
#line 3234 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 919:
#line 3235 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 920:
#line 3236 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 921:
#line 3237 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 922:
#line 3238 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8830 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 923:
#line 3239 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 924:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 925:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 926:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 927:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8860 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 928:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 929:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 930:
#line 3240 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8882 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3242 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/radv/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

