/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

#define yylval          cf_lval
#define yychar          cf_char

/* Copy the first part of user declarations.  */
#line 1 "cf-parse.y" /* yacc.c:339  */

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */
static int
f_valid_set_type(int type)
{
  switch (type)
  {
  case T_INT:
  case T_PAIR:
  case T_QUAD:
  case T_ENUM:
  case T_IP:
  case T_EC:
    return 1;

  default:
    return 0;
  }
}

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet;

static inline int ospf_cfg_is_v2(void) { return OSPF_CFG->ospf2; }
static inline int ospf_cfg_is_v3(void) { return ! OSPF_CFG->ospf2; }

static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if (ip->waitint == 0)
    ip->waitint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT3_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  int nssa = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
      backbone = 1;
    if (ac->type == OPT_N)
      nssa = 1;
  }

  cf->abr = areano > 1;

  /* Route export or NSSA translation (RFC 3101 3.1) */
  cf->asbr = (this_proto->out_filter != FILTER_REJECT) || (nssa && cf->abr);

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error("Vlinks cannot be used on single area router");

  if (cf->asbr && (areano == 1) && (this_area->type == 0))
    cf_error("ASBR must be in non-stub area");
}

static inline void
ospf_check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
ospf_check_auth(void)
{
  if (ospf_cfg_is_v3())
    cf_error("Authentication not supported in OSPFv3");
}


/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


#line 594 "cf-parse.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END = 258,
    CLI_MARKER = 259,
    INVALID_TOKEN = 260,
    ELSECOL = 261,
    DDOT = 262,
    GEQ = 263,
    LEQ = 264,
    NEQ = 265,
    AND = 266,
    OR = 267,
    PO = 268,
    PC = 269,
    NUM = 270,
    ENUM = 271,
    RTRID = 272,
    IPA = 273,
    SYM = 274,
    TEXT = 275,
    PREFIX_DUMMY = 276,
    DEFINE = 277,
    ON = 278,
    OFF = 279,
    YES = 280,
    NO = 281,
    S = 282,
    MS = 283,
    US = 284,
    PORT = 285,
    LOG = 286,
    SYSLOG = 287,
    ALL = 288,
    DEBUG = 289,
    TRACE = 290,
    INFO = 291,
    REMOTE = 292,
    WARNING = 293,
    ERROR = 294,
    AUTH = 295,
    FATAL = 296,
    BUG = 297,
    STDERR = 298,
    SOFT = 299,
    TIMEFORMAT = 300,
    ISO = 301,
    OLD = 302,
    SHORT = 303,
    LONG = 304,
    BASE = 305,
    NAME = 306,
    CONFIRM = 307,
    UNDO = 308,
    CHECK = 309,
    TIMEOUT = 310,
    LATENCY = 311,
    LIMIT = 312,
    WATCHDOG = 313,
    CONFIGURE = 314,
    DOWN = 315,
    KERNEL = 316,
    PERSIST = 317,
    SCAN = 318,
    TIME = 319,
    LEARN = 320,
    DEVICE = 321,
    ROUTES = 322,
    GRACEFUL = 323,
    RESTART = 324,
    KRT_SOURCE = 325,
    KRT_METRIC = 326,
    TABLE = 327,
    KRT_PREFSRC = 328,
    KRT_REALM = 329,
    ROUTER = 330,
    ID = 331,
    PROTOCOL = 332,
    TEMPLATE = 333,
    PREFERENCE = 334,
    DISABLED = 335,
    DIRECT = 336,
    INTERFACE = 337,
    IMPORT = 338,
    EXPORT = 339,
    FILTER = 340,
    NONE = 341,
    STATES = 342,
    FILTERS = 343,
    RECEIVE = 344,
    ACTION = 345,
    WARN = 346,
    BLOCK = 347,
    DISABLE = 348,
    KEEP = 349,
    FILTERED = 350,
    PASSWORD = 351,
    FROM = 352,
    PASSIVE = 353,
    TO = 354,
    EVENTS = 355,
    PACKETS = 356,
    PROTOCOLS = 357,
    INTERFACES = 358,
    PRIMARY = 359,
    STATS = 360,
    COUNT = 361,
    FOR = 362,
    COMMANDS = 363,
    PREEXPORT = 364,
    NOEXPORT = 365,
    GENERATE = 366,
    ROA = 367,
    LISTEN = 368,
    BGP = 369,
    V6ONLY = 370,
    DUAL = 371,
    ADDRESS = 372,
    PASSWORDS = 373,
    DESCRIPTION = 374,
    SORTED = 375,
    RELOAD = 376,
    IN = 377,
    OUT = 378,
    MRTDUMP = 379,
    MESSAGES = 380,
    RESTRICT = 381,
    MEMORY = 382,
    IGP_METRIC = 383,
    CLASS = 384,
    DSCP = 385,
    WAIT = 386,
    MAX = 387,
    FLUSH = 388,
    AS = 389,
    SHOW = 390,
    STATUS = 391,
    SUMMARY = 392,
    ROUTE = 393,
    SYMBOLS = 394,
    ADD = 395,
    DELETE = 396,
    DUMP = 397,
    RESOURCES = 398,
    SOCKETS = 399,
    NEIGHBORS = 400,
    ATTRIBUTES = 401,
    EVAL = 402,
    ECHO = 403,
    ENABLE = 404,
    FUNCTION = 405,
    PRINT = 406,
    PRINTN = 407,
    UNSET = 408,
    RETURN = 409,
    ACCEPT = 410,
    REJECT = 411,
    QUITBIRD = 412,
    INT = 413,
    BOOL = 414,
    IP = 415,
    PREFIX = 416,
    PAIR = 417,
    QUAD = 418,
    EC = 419,
    SET = 420,
    STRING = 421,
    BGPMASK = 422,
    BGPPATH = 423,
    CLIST = 424,
    ECLIST = 425,
    IF = 426,
    THEN = 427,
    ELSE = 428,
    CASE = 429,
    TRUE = 430,
    FALSE = 431,
    RT = 432,
    RO = 433,
    UNKNOWN = 434,
    GENERIC = 435,
    GW = 436,
    NET = 437,
    MASK = 438,
    PROTO = 439,
    SOURCE = 440,
    SCOPE = 441,
    CAST = 442,
    DEST = 443,
    IFNAME = 444,
    IFINDEX = 445,
    LEN = 446,
    DEFINED = 447,
    CONTAINS = 448,
    RESET = 449,
    PREPEND = 450,
    FIRST = 451,
    LAST = 452,
    MATCH = 453,
    ROA_CHECK = 454,
    EMPTY = 455,
    WHERE = 456,
    BFD = 457,
    MIN = 458,
    IDLE = 459,
    RX = 460,
    TX = 461,
    INTERVAL = 462,
    MULTIPLIER = 463,
    MULTIHOP = 464,
    NEIGHBOR = 465,
    DEV = 466,
    LOCAL = 467,
    SESSIONS = 468,
    HOLD = 469,
    CONNECT = 470,
    RETRY = 471,
    KEEPALIVE = 472,
    STARTUP = 473,
    VIA = 474,
    NEXT = 475,
    HOP = 476,
    SELF = 477,
    DEFAULT = 478,
    PATH = 479,
    METRIC = 480,
    START = 481,
    DELAY = 482,
    FORGET = 483,
    AFTER = 484,
    BGP_PATH = 485,
    BGP_LOCAL_PREF = 486,
    BGP_MED = 487,
    BGP_ORIGIN = 488,
    BGP_NEXT_HOP = 489,
    BGP_ATOMIC_AGGR = 490,
    BGP_AGGREGATOR = 491,
    BGP_COMMUNITY = 492,
    BGP_EXT_COMMUNITY = 493,
    RR = 494,
    RS = 495,
    CLIENT = 496,
    CLUSTER = 497,
    AS4 = 498,
    ADVERTISE = 499,
    IPV4 = 500,
    CAPABILITIES = 501,
    PREFER = 502,
    OLDER = 503,
    MISSING = 504,
    LLADDR = 505,
    DROP = 506,
    IGNORE = 507,
    REFRESH = 508,
    INTERPRET = 509,
    COMMUNITIES = 510,
    BGP_ORIGINATOR_ID = 511,
    BGP_CLUSTER_LIST = 512,
    IGP = 513,
    GATEWAY = 514,
    RECURSIVE = 515,
    MED = 516,
    TTL = 517,
    SECURITY = 518,
    DETERMINISTIC = 519,
    SECONDARY = 520,
    ALLOW = 521,
    PATHS = 522,
    AWARE = 523,
    LINK = 524,
    OSPF = 525,
    AREA = 526,
    OSPF_METRIC1 = 527,
    OSPF_METRIC2 = 528,
    OSPF_TAG = 529,
    OSPF_ROUTER_ID = 530,
    RFC1583COMPAT = 531,
    STUB = 532,
    TICK = 533,
    COST = 534,
    COST2 = 535,
    RETRANSMIT = 536,
    HELLO = 537,
    TRANSMIT = 538,
    PRIORITY = 539,
    DEAD = 540,
    TYPE = 541,
    BROADCAST = 542,
    BCAST = 543,
    NONBROADCAST = 544,
    NBMA = 545,
    POINTOPOINT = 546,
    PTP = 547,
    POINTOMULTIPOINT = 548,
    PTMP = 549,
    SIMPLE = 550,
    AUTHENTICATION = 551,
    STRICT = 552,
    CRYPTOGRAPHIC = 553,
    ELIGIBLE = 554,
    POLL = 555,
    NETWORKS = 556,
    HIDDEN = 557,
    VIRTUAL = 558,
    ONLY = 559,
    BUFFER = 560,
    LARGE = 561,
    NORMAL = 562,
    STUBNET = 563,
    TAG = 564,
    EXTERNAL = 565,
    LSADB = 566,
    ECMP = 567,
    WEIGHT = 568,
    NSSA = 569,
    TRANSLATOR = 570,
    STABILITY = 571,
    GLOBAL = 572,
    LSID = 573,
    INSTANCE = 574,
    REAL = 575,
    NETMASK = 576,
    LENGTH = 577,
    MERGE = 578,
    LSA = 579,
    SUPPRESSION = 580,
    TOPOLOGY = 581,
    STATE = 582,
    PIPE = 583,
    PEER = 584,
    MODE = 585,
    OPAQUE = 586,
    TRANSPARENT = 587,
    RIP = 588,
    INFINITY = 589,
    PERIOD = 590,
    GARBAGE = 591,
    MULTICAST = 592,
    QUIET = 593,
    NOLISTEN = 594,
    VERSION1 = 595,
    PLAINTEXT = 596,
    MD5 = 597,
    HONOR = 598,
    NEVER = 599,
    ALWAYS = 600,
    RIP_METRIC = 601,
    RIP_TAG = 602,
    STATIC = 603,
    PROHIBIT = 604,
    MULTIPATH = 605,
    BLACKHOLE = 606,
    UNREACHABLE = 607
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 523 "cf-parse.y" /* yacc.c:355  */

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;

#line 1014 "cf-parse.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE cf_lval;

int cf_parse (void);

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 1031 "cf-parse.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  68
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2898

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  374
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  259
/* YYNRULES -- Number of rules.  */
#define YYNRULES  853
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1617

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   607

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     365,   366,    28,    26,   370,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   367,   364,
      23,    22,    24,   371,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   372,     2,   373,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   368,     2,   369,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,   363
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   713,   713,   714,   717,   719,   727,   736,   737,   738,
     745,   746,   747,   755,   756,   757,   758,   759,   760,   766,
     767,   774,   775,   779,   786,   787,   791,   795,   802,   810,
     811,   818,   819,   825,   834,   835,   839,   844,   845,   849,
     850,   854,   855,   859,   860,   861,   862,   863,   864,   865,
     866,   867,   873,   874,   884,   885,   886,   887,   890,   891,
     892,   893,   894,   895,   899,   905,   906,   907,   908,   916,
     919,   926,   929,   932,   935,   939,   940,   944,   945,   946,
     954,   959,   960,   964,   971,   972,   978,   983,   987,  1001,
    1015,  1016,  1020,  1021,  1022,  1033,  1035,  1037,  1041,  1042,
    1043,  1044,  1049,  1055,  1056,  1060,  1068,  1072,  1074,  1080,
    1081,  1088,  1089,  1093,  1099,  1103,  1109,  1119,  1121,  1125,
    1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,  1135,
    1136,  1140,  1141,  1142,  1143,  1147,  1148,  1149,  1150,  1151,
    1155,  1161,  1165,  1173,  1174,  1182,  1190,  1191,  1192,  1196,
    1197,  1201,  1206,  1207,  1211,  1213,  1221,  1225,  1226,  1232,
    1239,  1240,  1241,  1245,  1253,  1259,  1260,  1261,  1265,  1266,
    1270,  1271,  1272,  1273,  1274,  1275,  1281,  1282,  1283,  1287,
    1288,  1292,  1293,  1299,  1300,  1303,  1305,  1309,  1310,  1314,
    1332,  1333,  1334,  1335,  1336,  1337,  1345,  1348,  1351,  1354,
    1358,  1359,  1362,  1365,  1369,  1373,  1378,  1384,  1391,  1396,
    1401,  1406,  1410,  1414,  1418,  1427,  1435,  1439,  1446,  1447,
    1448,  1453,  1457,  1464,  1471,  1475,  1483,  1484,  1485,  1490,
    1494,  1497,  1498,  1499,  1500,  1501,  1502,  1503,  1508,  1513,
    1521,  1528,  1535,  1543,  1545,  1547,  1549,  1551,  1553,  1555,
    1557,  1560,  1564,  1570,  1571,  1572,  1576,  1577,  1583,  1585,
    1587,  1589,  1591,  1593,  1597,  1601,  1604,  1608,  1609,  1610,
    1614,  1615,  1616,  1624,  1624,  1634,  1638,  1639,  1640,  1641,
    1642,  1643,  1644,  1645,  1646,  1647,  1648,  1649,  1650,  1671,
    1682,  1683,  1690,  1691,  1698,  1707,  1711,  1715,  1739,  1740,
    1744,  1757,  1757,  1773,  1774,  1777,  1778,  1782,  1785,  1794,
    1807,  1808,  1809,  1810,  1811,  1815,  1823,  1824,  1825,  1826,
    1827,  1831,  1834,  1835,  1836,  1840,  1843,  1852,  1855,  1856,
    1857,  1858,  1862,  1863,  1864,  1868,  1869,  1870,  1871,  1875,
    1876,  1877,  1878,  1882,  1883,  1887,  1888,  1892,  1899,  1900,
    1901,  1902,  1909,  1910,  1913,  1914,  1921,  1933,  1934,  1938,
    1939,  1943,  1944,  1945,  1946,  1947,  1951,  1952,  1953,  1957,
    1958,  1959,  1960,  1961,  1962,  1963,  1964,  1965,  1966,  1967,
    1971,  1972,  1982,  1986,  2009,  2023,  2024,  2025,  2026,  2027,
    2028,  2029,  2030,  2031,  2032,  2036,  2037,  2038,  2039,  2040,
    2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2053,  2054,  2055,  2057,  2059,  2061,  2063,  2064,  2065,
    2066,  2067,  2077,  2078,  2079,  2080,  2081,  2082,  2083,  2085,
    2086,  2091,  2114,  2115,  2116,  2117,  2118,  2119,  2123,  2126,
    2127,  2128,  2136,  2143,  2152,  2153,  2157,  2163,  2173,  2182,
    2188,  2193,  2200,  2205,  2211,  2212,  2213,  2221,  2222,  2223,
    2224,  2225,  2231,  2243,  2244,  2245,  2246,  2249,  2251,  2255,
    2259,  2270,  2271,  2272,  2273,  2274,  2275,  2278,  2280,  2283,
    2285,  2288,  2291,  2296,  2297,  2298,  2302,  2303,  2307,  2308,
    2311,  2330,  2336,  2360,  2362,  2363,  2367,  2368,  2369,  2370,
    2371,  2372,  2378,  2379,  2380,  2381,  2382,  2383,  2384,  2385,
    2386,  2387,  2388,  2389,  2390,  2391,  2392,  2393,  2394,  2395,
    2396,  2397,  2398,  2399,  2400,  2401,  2402,  2403,  2404,  2405,
    2406,  2407,  2408,  2409,  2410,  2411,  2412,  2413,  2414,  2420,
    2421,  2422,  2423,  2424,  2425,  2426,  2427,  2428,  2429,  2430,
    2431,  2432,  2433,  2434,  2445,  2455,  2456,  2460,  2461,  2462,
    2463,  2464,  2465,  2466,  2467,  2468,  2471,  2486,  2489,  2491,
    2495,  2496,  2497,  2498,  2499,  2500,  2501,  2502,  2503,  2504,
    2504,  2505,  2505,  2506,  2507,  2508,  2512,  2513,  2517,  2525,
    2527,  2531,  2532,  2533,  2537,  2538,  2541,  2543,  2546,  2547,
    2548,  2549,  2550,  2551,  2552,  2553,  2554,  2555,  2556,  2559,
    2579,  2580,  2581,  2582,  2583,  2584,  2585,  2586,  2587,  2588,
    2589,  2590,  2591,  2592,  2593,  2594,  2595,  2596,  2597,  2598,
    2599,  2600,  2601,  2602,  2603,  2604,  2605,  2606,  2607,  2608,
    2609,  2610,  2611,  2612,  2613,  2614,  2615,  2616,  2617,  2620,
    2622,  2625,  2627,  2636,  2638,  2639,  2642,  2644,  2648,  2649,
    2652,  2662,  2683,  2685,  2689,  2689,  2692,  2694,  2697,  2699,
    2703,  2707,  2708,  2713,  2716,  2719,  2724,  2727,  2732,  2735,
    2739,  2743,  2746,  2747,  2748,  2749,  2750,  2751,  2752,  2753,
    2759,  2766,  2767,  2768,  2773,  2774,  2780,  2787,  2788,  2789,
    2790,  2791,  2792,  2793,  2794,  2795,  2796,  2797,  2798,  2799,
    2803,  2804,  2805,  2810,  2811,  2812,  2813,  2814,  2817,  2818,
    2819,  2820,  2821,  2822,  2823,  2826,  2828,  2831,  2833,  2837,
    2849,  2856,  2863,  2864,  2865,  2866,  2867,  2870,  2879,  2887,
    2894,  2895,  2899,  2904,  2910,  2913,  2918,  2919,  2920,  2921,
    2922,  2925,  2932,  2932,  2932,  2932,  2932,  2932,  2932,  2932,
    2932,  2932,  2932,  2932,  2932,  2932,  2932,  2932,  2933,  2933,
    2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,
    2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,
    2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,
    2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,  2933,
    2933,  2933,  2933,  2933,  2933,  2934,  2934,  2934,  2934,  2934,
    2934,  2934,  2934,  2934,  2935,  2935,  2935,  2935,  2936,  2936,
    2936,  2937,  2937,  2937,  2937,  2937,  2938,  2938,  2939,  2940,
    2941,  2942,  2943,  2944,  2945,  2946,  2947,  2948,  2949,  2949,
    2949,  2949,  2949,  2949
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "PORT", "LOG", "SYSLOG",
  "ALL", "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH",
  "FATAL", "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT",
  "LONG", "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "LATENCY",
  "LIMIT", "WATCHDOG", "CONFIGURE", "DOWN", "KERNEL", "PERSIST", "SCAN",
  "TIME", "LEARN", "DEVICE", "ROUTES", "GRACEFUL", "RESTART", "KRT_SOURCE",
  "KRT_METRIC", "TABLE", "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID",
  "PROTOCOL", "TEMPLATE", "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE",
  "IMPORT", "EXPORT", "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE",
  "ACTION", "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD",
  "FROM", "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "NOEXPORT",
  "GENERATE", "ROA", "LISTEN", "BGP", "V6ONLY", "DUAL", "ADDRESS",
  "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN", "OUT", "MRTDUMP",
  "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC", "CLASS", "DSCP", "WAIT",
  "MAX", "FLUSH", "AS", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "LINK", "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG", "EXTERNAL",
  "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY", "GLOBAL",
  "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "MERGE", "LSA",
  "SUPPRESSION", "TOPOLOGY", "STATE", "PIPE", "PEER", "MODE", "OPAQUE",
  "TRANSPARENT", "RIP", "INFINITY", "PERIOD", "GARBAGE", "MULTICAST",
  "QUIET", "NOLISTEN", "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER",
  "ALWAYS", "RIP_METRIC", "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH",
  "BLACKHOLE", "UNREACHABLE", "';'", "'('", "')'", "':'", "'{'", "'}'",
  "','", "'?'", "'['", "']'", "$accept", "config", "conf_entries",
  "definition", "expr", "expr_us", "bool", "ipa", "ipa_scope", "prefix",
  "prefix_or_ipa", "pxlen", "datetime", "text", "text_or_none",
  "log_config", "syslog_name", "log_file", "log_mask", "log_mask_list",
  "log_cat", "mrtdump_base", "timeformat_which", "timeformat_spec",
  "timeformat_base", "debug_unix", "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT",
  "cmd_CONFIGURE_CONFIRM", "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK",
  "cmd_DOWN", "cfg_name", "cfg_timeout", "kern_proto_start", "kern_item",
  "kif_proto_start", "kif_item", "kern_sys_item", "rtrid", "idval",
  "listen", "listen_opts", "listen_opt", "gr_opts", "tab_sorted", "newtab",
  "roa_table_start", "roa_table_opts", "roa_table", "proto_start",
  "proto_name", "proto_item", "imexport", "limit_action", "limit_spec",
  "rtable", "debug_default", "iface_patt_node_init",
  "iface_patt_node_body", "iface_negate", "iface_patt_node",
  "iface_patt_list", "iface_patt_list_nopx", "iface_patt_init",
  "iface_patt", "tos", "dev_proto_start", "dev_proto", "dev_iface_init",
  "dev_iface_patt", "debug_mask", "debug_list", "debug_flag",
  "mrtdump_mask", "mrtdump_list", "mrtdump_flag", "password_list",
  "password_items", "password_item", "password_item_begin",
  "password_item_params", "cmd_SHOW_STATUS", "cmd_SHOW_MEMORY",
  "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL", "optsym",
  "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY", "cmd_SHOW_ROUTE",
  "r_args", "export_mode", "cmd_SHOW_ROA", "roa_args", "roa_mode",
  "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg", "cmd_ADD_ROA",
  "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_EVENTS", "cmd_DUMP_INTERFACES",
  "cmd_DUMP_NEIGHBORS", "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES",
  "cmd_DUMP_PROTOCOLS", "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size",
  "cmd_DISABLE", "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD",
  "cmd_RELOAD_IN", "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP",
  "cmd_RESTRICT", "proto_patt", "proto_patt2", "filter_def", "$@1",
  "filter_eval", "type", "one_decl", "decls", "declsn", "filter_body",
  "filter", "where_filter", "function_params", "function_body",
  "function_def", "$@2", "cmds", "cmds_int", "block", "fipa", "set_atom",
  "switch_atom", "pair_expr", "pair_atom", "pair_item", "ec_expr",
  "ec_kind", "ec_item", "set_item", "switch_item", "set_items",
  "switch_items", "fprefix_s", "fprefix", "fprefix_set", "switch_body",
  "bgp_path_expr", "bgp_path", "bgp_path_tail1", "bgp_path_tail2",
  "constant", "constructor", "rtadot", "function_call", "symbol",
  "static_attr", "term", "break_command", "print_one", "print_list",
  "var_listn", "var_list", "cmd", "bfd_proto_start", "bfd_proto_item",
  "bfd_proto_opts", "bfd_proto", "bfd_iface_start", "bfd_iface_item",
  "bfd_iface_opts", "bfd_iface_opt_list", "bfd_iface", "bfd_multihop",
  "bfd_neigh_iface", "bfd_neigh_local", "bfd_neigh_multihop",
  "bfd_neighbor", "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start",
  "bgp_nbr_opts", "bgp_proto", "ospf_proto_start", "ospf_proto",
  "ospf_proto_item", "ospf_area_start", "ospf_area", "ospf_area_opts",
  "ospf_area_item", "$@3", "$@4", "ospf_stubnet", "ospf_stubnet_start",
  "ospf_stubnet_opts", "ospf_stubnet_item", "ospf_vlink",
  "ospf_vlink_opts", "ospf_vlink_item", "ospf_vlink_start",
  "ospf_iface_item", "pref_list", "pref_item", "pref_base", "pref_opt",
  "nbma_list", "nbma_eligible", "nbma_item", "ospf_iface_start",
  "ospf_instance_id", "ospf_iface_patt_list", "$@5", "ospf_iface_opts",
  "ospf_iface_opt_list", "ospf_iface", "opttext", "cmd_SHOW_OSPF",
  "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,    59,    40,    41,    58,   123,   125,
      44,    63,    91,    93
};
# endif

#define YYPACT_NINF -1340

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1340)))

#define YYTABLE_NINF -445

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-445)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      45,  2713,    64,   765,   501,   606,   139,   501,   501,   706,
     501,   153,   -32,   670,     1,    67,   806,  1507,    91,   501,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
     192,   758,   313,   686,   462,   244,   219,   259, -1340, -1340,
     358,   275,   264,   377,  1507,   398, -1340, -1340, -1340, -1340,
   -1340, -1340,   252,   252, -1340, -1340, -1340, -1340,    57, -1340,
     596, -1340,   252,   457, -1340, -1340, -1340,   252, -1340,   252,
    2309,   252,  1275,   252,  2382,   252,  2249,   252,  2340, -1340,
   -1340,  2170,  2433, -1340, -1340, -1340,   150, -1340,   486,   509,
     527,   486,   483, -1340,   578,   586,   501,   501,   590,   233,
   -1340,   476,   608,   105, -1340,   611,   621, -1340, -1340,   396,
     448,   624,   705,   705,   650,   664,   669,   684,   693,   703,
     734,   743,    87, -1340, -1340, -1340,   628,   407, -1340,   565,
      20,     7,  1507, -1340,   451,   460,   466, -1340, -1340,   471,
     478,   482,   956,   129, -1340, -1340, -1340, -1340, -1340,  2080,
   -1340,  2800, -1340, -1340,  1239,   798,   838,   828, -1340, -1340,
     794, -1340, -1340,    26,   103,   150,    54, -1340, -1340, -1340,
   -1340,   549,   494,    54,    54,   726,   741,   641, -1340,   866,
   -1340,   233,   523,  2866, -1340,   782,   895,   566,   588, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,   598,
     150,   905,   881,    54,   414, -1340,   498,   616,   902,   213,
     233, -1340,   613,   615,   618,   629,   214,   701,   916,   645,
     985,   776,   213,   414,   950,   747,   -63,   891,   414,    92,
     705,   477,   953,   228,   972,   823,   819,   510,   818,   817,
     529,   804,   802,   414,   801,   800,   808,    22,   -21,   840,
     816,   821,   414,   871, -1340,   731,   730,   687,   414,  1015,
      54,   414,  1016,   784, -1340, -1340,   742,   749, -1340,   750,
    1027,   539, -1340,   757,   756,    54,  1051, -1340,   213,   760,
      39,    54,    54,  1055,    88, -1340,   770,   772, -1340,   771,
     773,   858,   705,  1057, -1340,   785,   584,   787,  1065,   414,
    1075,   414,  1074,  1077, -1340,   791,   796,   797,  1088,  1145,
   -1340,   807,   809, -1340, -1340,  1021,  1165,   483, -1340, -1340,
    1167,    54,  1169, -1340, -1340,  1171,  1173, -1340, -1340, -1340,
     131,  1174,  1159,  1178, -1340, -1340,   780,  1179, -1340,  1180,
     704, -1340, -1340,  2554,  1008,   624, -1340,   624,   624, -1340,
     421,   469,  1181,  1184, -1340, -1340,   -22,  1045,  1046, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340,    87, -1340,    87,
    1507,    87,    87,  1176, -1340,  1182,  1096,  1168,   982,  1186,
       7,     7,  1166,  1164,  1507,  1507,  1507,  1507,  1507,  1196,
   -1340, -1340,  1183, -1340,   850,    72, -1340, -1340, -1340, -1340,
     847, -1340,  1210, -1340, -1340, -1340,    12,    93, -1340,    25,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340,  1507,  1507,  1507,  1507,
    1507,  1507,  1507,  1507,  1507,  1507,  1507,  1507,  1507,   786,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,   528,
   -1340, -1340,  1226, -1340,  1507,   213, -1340, -1340,  1239,   867,
   -1340, -1340, -1340, -1340, -1340, -1340,    54,  1507, -1340, -1340,
   -1340, -1340,    54,   862,   869, -1340,   951, -1340, -1340,    54,
   -1340, -1340, -1340, -1340, -1340, -1340,   868,  1207, -1340,   120,
     874, -1340,   865,  1221, -1340, -1340, -1340,   -97, -1340, -1340,
   -1340, -1340,   687, -1340, -1340, -1340, -1340,    95,  1030, -1340,
    1135,  1507, -1340, -1340,    95, -1340,    95, -1340, -1340, -1340,
   -1340, -1340, -1340,  1185,  1197,   414,    97, -1340,   878,  1193,
     880,   882,    54,    53,   992,   414,   705,   893, -1340,   909,
    1229,   163,    54,  1130,    54,  1201,  1202,    54,  1206,   -90,
      54,    54,   414,  1225,   937,  1216,   941,   414,   952,   414,
     272,   414,   905,   414,   954,   960,   414,   414,   414,   961,
    1170, -1340, -1340, -1340, -1340,   414, -1340,  1265,    54,   414,
   -1340, -1340, -1340,  1315,   973,   974, -1340, -1340,   975,    54,
   -1340,   976, -1340,  1249, -1340, -1340, -1340,   993,   998,  1000,
      54,  1010,  1019,  1026, -1340, -1340,   417, -1340,   414, -1340,
     905, -1340, -1340,   995, -1340,   705, -1340,  1137, -1340, -1340,
   -1340,    54, -1340,    54, -1340,   414,   414, -1340, -1340, -1340,
      54, -1340,   705, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340,   562, -1340, -1340,  1369, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340,   569, -1340, -1340, -1340, -1340,  1388, -1340, -1340,
   -1340,  1373, -1340, -1340,  1378,   705, -1340, -1340,  1377,  1382,
   -1340,  1030, -1340, -1340, -1340, -1340,   705, -1340, -1340, -1340,
    1385, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
    1394,  1386,  1386,   636,   624,  1386,   624,  1386, -1340, -1340,
      54,   705, -1340,  1392,  1397, -1340, -1340,   883, -1340, -1340,
   -1340, -1340,   271, -1340,  1043, -1340,  1389, -1340, -1340, -1340,
   -1340,   304,   339,   622,  1060,   654,    65, -1340,  1507, -1340,
    1507, -1340,  1406,  1047,  1050,  1242,   246,   397, -1340, -1340,
   -1340,  1404,  1403, -1340,  1652,  1652,  1652,  1782,  1782,  1652,
    1652,  1652,  1652,   556,   556,  1164,  1164, -1340,  1058, -1340,
   -1340, -1340, -1340,  1239, -1340,  1997, -1340,   572, -1340, -1340,
    1285,  1402, -1340, -1340, -1340, -1340, -1340, -1340, -1340,  1064,
   -1340,  1066, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340,    98,  1070,  1061, -1340, -1340,
      54, -1340, -1340,   705, -1340, -1340, -1340,   520,  1207, -1340,
     705, -1340, -1340,  1408, -1340,  1067, -1340,  1335, -1340, -1340,
   -1340, -1340,   414,  2866, -1340, -1340,  2401,    54,    54,  1076,
      54,  1085,  1086, -1340,   414, -1340, -1340,  1087,  1092,  1093,
    1094,   414,  1095,  1099, -1340, -1340,  1419, -1340,    54,    54,
   -1340,  1101,    54,  1103,    54,    54,  1105,    54,  1106,  1107,
    1108,  1110,  1117,    54, -1340,   687, -1340,  1119, -1340,  1120,
    1124,  1126,  1128,  1132,  1139,  1140, -1340, -1340,  1141,  1142,
    1143, -1340,   167, -1340,    54, -1340, -1340,  1855,  1150, -1340,
   -1340, -1340,  1151,    33, -1340,  1072,  1153, -1340, -1340, -1340,
    1154, -1340, -1340, -1340,    54,   489,   696,  1083,  1187,  1188,
   -1340,  1229, -1340,   705,  1115,  1137, -1340, -1340, -1340, -1340,
   -1340,   -22, -1340, -1340, -1340,  1021, -1340, -1340,   131, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
    1457,  1491, -1340, -1340,   687, -1340, -1340,   687,  1513, -1340,
     687,  1386,  1526,  1386,  1528, -1340, -1340,  1387,  1395, -1340,
    1507, -1340,  1515,  1507,  1507,  1507, -1340,  1507, -1340,  1507,
     707,  1559,  1507,  1208,  1507, -1340, -1340,  1507, -1340, -1340,
    1190,   628, -1340,  1507, -1340, -1340, -1340, -1340, -1340, -1340,
    1067, -1340, -1340, -1340,  1207,   155, -1340, -1340, -1340,  1189,
    1192, -1340,  1401, -1340,  1003, -1340,   898, -1340, -1340, -1340,
   -1340,   705, -1340, -1340,  1191,  1195,  1211, -1340,  1212, -1340,
   -1340,  1213, -1340, -1340, -1340, -1340,  1215, -1340, -1340, -1340,
     165, -1340, -1340, -1340,  1228, -1340,  1230,  1231, -1340,  1232,
   -1340, -1340, -1340, -1340, -1340,  1235,  1236, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,  1237,
   -1340, -1340,   414,   208,   144, -1340,  1266,   705, -1340, -1340,
     173, -1340,  1238, -1340,  1218, -1340, -1340, -1340, -1340, -1340,
    1249, -1340,  1240,  1529,  1529,  1529,  1529, -1340, -1340, -1340,
   -1340,  1229,    54,  1115, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340,  1551, -1340,  1558, -1340,  1574,  1575, -1340, -1340,
    1613,  1696,  1721,  1746,   732,  1507, -1340, -1340,  2866,  1200,
    1204,  2866,  1242,  1578,  1771, -1340,   -10, -1340,  1584, -1340,
   -1340,  1245,  1507, -1340, -1340, -1340,  1507,  1507,  1244,    35,
    2080,  1243,  1460, -1340,  1207, -1340,  1599,   705, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340,  1247, -1340,    62,
   -1340, -1340,    54, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,    54,    54,
     414,    54, -1340,  1248,   687, -1340, -1340,  1250,  1251,    54,
   -1340, -1340,    54,  1252,   663, -1340,   417, -1340,  1253,  1262,
    1263,  1264, -1340, -1340, -1340, -1340,   476,   476, -1340, -1340,
   -1340, -1340,  1507,  1811,  1622,  1482,  1261, -1340,  1507,  1096,
    1507, -1340,  2022,  2702,    34, -1340, -1340,  1609,   322, -1340,
    2866,  1273,  1268, -1340,  1503, -1340,  1067,  1247, -1340, -1340,
    1630,   213,  1427,  1288,  1067,  1286, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340,   323,    54,  1379,
     440, -1340,  1291, -1340,   417,   417,   417,   417,  1653,  1654,
    1841, -1340,  1299,  1301,     4, -1340,  2047,  1305,  2072,  1954,
   -1340,   877, -1340,  1507,  1507,   719,  1460, -1340,  1650, -1340,
     394, -1340, -1340,   705,  1452, -1340,  1218, -1340, -1340,    10,
     -35,    19,   473,    54,    54,    54, -1340, -1340,   270, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340,  1507, -1340,  1507, -1340, -1340, -1340, -1340,
    1307,   155,  1498, -1340,    18,  2097,  2122,  1318,  1321,  1322,
    1324,  1326, -1340,  1327,   414,   733,  1478,    54,    54, -1340,
    1332, -1340,   414, -1340, -1340,  2484, -1340, -1340, -1340,  -163,
     414,    54,   414, -1340,  1333, -1340,    54,    54,    54,  1461,
     158,   -18, -1340, -1340,  1334, -1340, -1340, -1340,  1396, -1340,
    1330,  1336,  1337,  1340,   877,    59, -1340, -1340, -1340,   847,
   -1340, -1340,  1705, -1340, -1340, -1340,   206, -1340, -1340,  1507,
    1507,  1507,  1507, -1340, -1340, -1340,  1485,  1496,  1497, -1340,
   -1340, -1340, -1340,  1436,    54,  1358,   414,  1411,   305,  1462,
     414,  1399,   414,    54,    54,    54,  1499,    54,   320,  1049,
    1407,   121,  1435,    54,  1414,  1442, -1340, -1340,  1398, -1340,
      54,  1400, -1340, -1340, -1340, -1340, -1340, -1340, -1340,    54,
      54, -1340, -1340, -1340, -1340, -1340, -1340,  1507, -1340, -1340,
   -1340, -1340, -1340,  1866,   136,    59,   151,  1891,  1918,  1943,
    1972,    54,    54,    54,   414, -1340, -1340, -1340,   197,    54,
      54, -1340,   338, -1340,  1405, -1340, -1340, -1340, -1340,    54,
   -1340,    54, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340,   414, -1340, -1340, -1340,   414, -1340,    54,   414, -1340,
   -1340, -1340, -1340, -1340,  1376, -1340,  1507, -1340, -1340, -1340,
    1412,  1413,  1420,  1421, -1340, -1340, -1340, -1340,    21, -1340,
   -1340, -1340, -1340, -1340,  1437, -1340,   414, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340,  1866, -1340, -1340, -1340, -1340, -1340,
    1441, -1340, -1340, -1340, -1340,  1422, -1340
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    75,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   382,     0,     0,
     768,   769,   770,   771,   772,   773,   774,   775,   776,   777,
     778,   779,   780,   781,   782,   783,   784,   785,   786,   787,
     788,   789,   790,   791,   792,   793,   794,   795,   796,   797,
     798,   799,   800,   801,   802,   803,   804,   805,   806,   807,
     808,   809,   810,   811,   812,   813,   814,     3,     1,     2,
       0,     0,     0,     0,     0,     0,     0,     0,   111,   112,
       0,     0,     0,     0,   382,     0,   752,   753,   754,   755,
     756,   757,   113,   113,   758,   759,   760,   761,   109,   762,
       0,   764,   113,   117,   765,   766,   767,   113,   818,   113,
     117,   113,   117,   113,   117,   113,   117,   113,   117,     5,
     763,   117,   117,   267,   269,   268,     0,    76,    75,     0,
       0,    75,    77,    74,     0,     0,     0,     0,     0,     0,
     266,   238,   271,     0,   222,     0,     0,   205,   230,     0,
     201,   201,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   365,   369,   378,   375,   309,   384,   372,     0,
       0,   368,   382,   414,     0,     0,     0,   370,   371,     0,
       0,     0,   382,     0,   373,   374,   379,   412,   413,     0,
     411,     0,   254,   253,     0,   256,     0,     0,    30,    29,
      35,    38,    36,     0,    18,     0,     0,    57,    56,    55,
      54,     0,     0,     0,     0,     0,   103,     0,   273,     0,
      96,     0,     0,   275,   301,   114,     0,     0,     0,   107,
      80,    86,   159,   492,   462,   554,   690,   696,   731,     0,
       0,     0,     0,     0,    18,   163,     0,     0,     0,     0,
       0,   817,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,    18,     0,
     493,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    18,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,   819,     0,     0,     0,    18,     0,
       0,    18,     0,     0,   820,   557,     0,     0,   565,     0,
       0,     0,   821,     0,     0,     0,     0,   729,     0,     0,
       0,     0,     0,     0,     0,   822,     0,     0,   184,   188,
       0,     0,     0,     0,   823,     0,     0,     0,     0,    18,
       0,    18,     0,     0,   815,     0,     0,     0,     0,    32,
     816,     0,     0,   166,   165,     0,     0,    77,    71,    72,
       0,    78,     0,   260,   258,     0,     0,   261,   177,   176,
       0,     0,     0,     0,   270,   272,   271,     0,   202,     0,
     226,   197,   196,     0,     0,   201,   200,   201,   201,   681,
     201,   201,     0,     0,    19,    20,     0,     0,     0,   249,
     245,   250,   246,   243,   244,   247,   248,   365,   384,   365,
     382,   365,   365,     0,   357,     0,   382,     0,     0,     0,
     368,   368,     0,   409,   382,   382,   382,   382,   382,     0,
     328,   329,     0,   331,     0,     0,   310,   313,   311,   315,
     382,   312,   337,   335,   336,   343,     0,   348,   352,     0,
     836,   831,   832,   833,   834,   385,   835,   386,   387,   388,
     389,   390,   391,   392,   393,   394,   838,   841,   840,   837,
     839,   842,   843,   844,   847,   845,   846,   848,   849,   850,
     851,   852,   853,   415,   416,   251,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   382,     0,
      43,    44,    45,    46,    47,    48,    49,    50,    51,     0,
      41,   257,     0,   259,   382,     0,    37,    39,     0,     0,
       7,     9,    14,    16,    15,    17,     0,   382,    13,    65,
     143,   144,    58,     0,     0,    64,     0,    67,    68,     0,
     104,   105,    92,    93,    94,   155,     0,   290,   106,     0,
       0,    53,     0,     0,   115,   824,   828,     0,   160,   120,
     142,   128,     0,   118,   119,   145,   133,     0,   290,   134,
       0,   382,   122,   132,     0,   123,     0,   130,   121,   161,
     162,   467,   496,     0,     0,    18,    18,   508,     0,     0,
       0,     0,     0,    18,     0,    18,     0,     0,   509,     0,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,    18,     0,    18,
       0,    18,     0,    18,     0,     0,    18,    18,    18,     0,
       0,   497,   555,   566,   558,    18,   563,   560,     0,    18,
     556,   568,   691,     0,     0,     0,   692,   697,     0,     0,
     145,     0,   189,   185,   712,   710,   711,     0,     0,     0,
       0,     0,     0,     0,   698,   705,   190,   732,    18,   737,
       0,   733,   747,     0,   746,     0,   750,     0,   748,   749,
     736,     0,    81,     0,    83,    18,    18,   826,   827,   825,
       0,    31,     0,   830,   829,   171,   170,   172,   174,   175,
     173,     0,   168,   264,     0,    73,    79,    69,   262,   263,
     181,   182,     0,   179,   265,   239,   242,     0,   198,   203,
     221,     0,   228,   227,     0,     0,   204,   211,     0,     0,
     219,   290,   213,   212,   216,   217,     0,   218,   220,   206,
       0,   210,   229,   237,   231,   234,   235,   233,   236,   232,
       0,   672,   672,     0,   201,   672,   201,   672,   673,   751,
       0,     0,    23,     0,     0,   361,   362,     0,   363,   364,
     359,   347,   442,   445,     0,   422,     0,   423,   366,   367,
     360,     0,     0,     0,     0,     0,     0,   330,   382,   395,
     382,   324,   322,     0,     0,   321,     0,     0,   376,   349,
     350,     0,     0,   377,   407,   405,   403,   400,   401,   402,
     404,   406,   408,   396,   397,   398,   399,   417,     0,   418,
     420,   421,   255,     0,   252,     0,    34,     0,    33,    66,
       0,     0,    60,    61,    62,    63,    10,    11,    12,     0,
     145,     0,    90,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,     0,     0,     0,   274,   294,
       0,   100,   101,     0,    95,    97,    52,     0,   290,   116,
       0,   110,   129,   149,   152,   164,   141,   135,   125,   295,
     296,   131,    18,   297,   126,   124,   117,     0,     0,     0,
       0,     0,     0,   502,    18,   537,   539,     0,     0,     0,
       0,    18,     0,     0,   553,   510,     0,   493,     0,     0,
     500,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   504,     0,   505,     0,   535,     0,
       0,     0,     0,     0,     0,     0,   516,   517,     0,     0,
       0,   541,     0,   559,     0,   564,   562,     0,     0,   694,
     695,   700,     0,   727,   709,     0,     0,   704,   699,   701,
       0,   707,   708,   706,     0,     0,     0,     0,     0,     0,
     743,    21,   745,     0,   740,   744,    89,    82,    84,    85,
      87,    25,    24,    88,   167,     0,    70,   178,     0,   199,
     225,   224,   223,   208,   215,   209,   207,   214,   491,   671,
       0,     0,   680,   689,     0,   687,   684,     0,     0,   682,
       0,   672,     0,   672,     0,    26,    27,     0,     0,   358,
     382,   431,     0,   382,   382,   382,   410,   382,   429,   382,
       0,     0,   382,   382,   382,   314,   309,   382,   338,   344,
       0,     0,   353,   382,    42,     6,    40,     8,    59,   102,
     156,    91,   289,   288,   290,   382,    99,    98,   299,   292,
       0,   302,     0,   150,     0,   145,     0,   140,   127,   470,
     470,     0,   469,   463,     0,     0,     0,   552,     0,   548,
     547,     0,   538,   542,   543,   544,     0,   534,   525,    22,
       0,   494,   495,   498,     0,   506,     0,     0,   529,     0,
     512,   511,   524,   523,   518,     0,     0,   536,   521,   513,
     514,   515,   540,   550,   520,   519,   551,   522,   545,     0,
     561,   661,    18,     0,    18,   579,     0,     0,   581,   571,
      18,   567,     0,   585,   662,   693,   703,   725,   730,   183,
     185,   702,     0,     0,     0,     0,     0,   187,   734,   735,
     742,    21,     0,   741,   169,   180,   675,   674,   688,   683,
     685,   686,     0,   676,     0,   678,     0,     0,   443,   424,
       0,     0,     0,     0,     0,   382,   380,   323,   321,     0,
       0,   327,     0,     0,     0,   291,     0,   435,     0,   436,
     437,     0,   382,   433,   434,   432,   382,   382,     0,   382,
       0,     0,   382,   305,     0,   298,     0,   146,   147,   151,
     153,   138,   136,   137,   139,   145,   464,   479,   465,   483,
     466,   468,     0,   530,   549,   532,   533,   501,   499,   528,
     527,   507,   526,   503,   546,   145,   584,   572,     0,     0,
      18,     0,   570,     0,     0,   588,   583,   587,     0,     0,
     577,   569,     0,   595,   718,   186,   190,    28,     0,     0,
       0,     0,   738,   739,   677,   679,   238,   238,   428,   426,
     427,   425,   382,     0,   325,   382,     0,   419,   382,   382,
     382,   382,     0,     0,     0,   300,   306,     0,     0,   455,
     438,   440,     0,   293,     0,   148,   154,   479,   477,   482,
       0,     0,   486,     0,   664,   668,   574,   575,   573,   576,
     649,   609,   589,   649,   578,   663,   596,     0,     0,     0,
       0,   728,     0,   195,   190,   190,   190,   190,     0,     0,
       0,   381,     0,     0,     0,   351,     0,     0,     0,     0,
     449,   382,   354,   382,   382,     0,   382,   454,     0,   481,
       0,   484,   485,     0,   488,   531,   662,   666,   670,     0,
       0,     0,   598,     0,     0,     0,   721,   719,    18,   713,
     714,   715,   716,   717,   720,   726,   191,   192,   193,   194,
     240,   241,   430,   382,   334,   382,   332,   448,   383,   452,
       0,   382,   446,   307,     0,     0,     0,     0,     0,     0,
       0,     0,   441,     0,    18,     0,     0,     0,     0,   480,
       0,   487,    18,   490,   665,     0,   580,   652,   650,   653,
      18,     0,    18,   586,     0,   582,     0,     0,     0,     0,
       0,     0,   594,   608,     0,   157,   158,   722,     0,   723,
       0,     0,     0,     0,   382,   382,   316,   320,   318,   382,
     456,   319,   341,   339,   340,   345,     0,   451,   450,   382,
     382,   382,   382,   457,   108,   476,     0,     0,     0,   471,
     475,   478,   489,     0,     0,     0,    18,     0,     0,     0,
      18,     0,    18,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   669,   648,     0,   654,
       0,     0,   592,   593,   591,   590,   602,   600,   599,     0,
       0,   603,   605,   606,   607,   597,   724,   382,   333,   453,
     308,   447,   356,   321,     0,   382,     0,     0,     0,     0,
       0,     0,     0,     0,    18,   614,   656,   646,     0,     0,
       0,   641,    18,   647,     0,   630,   610,   613,   611,     0,
     628,     0,   615,   617,   618,   619,   620,   621,   622,   623,
     624,    18,   635,   636,   637,    18,   612,     0,    18,   667,
     655,   651,   601,   604,     0,   317,   382,   342,   355,   346,
       0,     0,     0,     0,   472,   473,   474,   631,     0,   639,
     638,   640,   642,   643,     0,   644,    18,   627,   616,   626,
     629,   632,   625,   326,     0,   461,   459,   460,   458,   634,
     658,   657,   645,   633,   659,     0,   660
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1340, -1340, -1340, -1340,   -85,  -201,   -49,  -253,  -923,  -143,
    -722, -1340,   -66,   -79, -1340, -1340, -1340, -1340, -1340,  1241,
     938, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340,   617,  1409, -1340, -1340, -1340, -1340, -1340, -1340,
    -296, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340,  1428,   -91,  1516, -1340,    -9,  -495, -1340, -1340, -1340,
   -1340,   695,  -644, -1340, -1340, -1340,   287, -1340, -1340, -1340,
   -1340,    46, -1340,   803,   -57, -1340,   779, -1239,   647,  -648,
   -1340,  -261, -1340, -1340, -1340, -1340,  -131, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340,  -314, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340,   894,  1425, -1340, -1340, -1340, -1340,  -835,   735,
     609,  1255,  1081,  1432, -1340,   948, -1340, -1340, -1104, -1340,
     373,  -180,  1022,   302, -1024,   795, -1339, -1172,  1645, -1253,
    1032,   315, -1340, -1340,  -181,  1028, -1340, -1340, -1340, -1340,
     385,   538, -1340, -1340, -1039, -1340,   149,   631,   -17, -1340,
   -1340,   496,   824,   567, -1106, -1340, -1340, -1340, -1340,   775,
   -1340, -1340,   551, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340,   949, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340,   542, -1340, -1340, -1340, -1340, -1340, -1340, -1340,   502,
   -1340, -1340, -1340, -1340, -1340,  -371, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340,   884,
   -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1340, -1038
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    87,   528,   537,   529,   396,   907,   982,
     983,   762,  1258,   202,   692,    88,   516,   203,   519,   509,
     510,    89,   211,   212,    90,    91,    20,    21,    22,    23,
      24,    25,   132,   362,    92,   345,    93,   351,   346,    94,
     546,    95,   549,   865,    96,   541,    97,    98,   557,    99,
     100,   227,   252,   572,  1067,   878,   561,   101,   873,  1209,
    1064,   874,   875,  1297,   840,   841,  1366,   102,   103,   565,
     253,   356,   701,   702,   371,   712,   713,   327,   955,   328,
     329,   967,    26,    27,    28,    29,   392,    30,    31,    32,
     383,   740,    33,   380,   725,    34,   384,   373,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,   195,   512,    48,    49,    50,    51,    52,    53,    54,
      55,    56,   126,   377,   104,   547,   105,   855,   856,   857,
    1060,   880,   881,   573,   868,   859,   106,   552,  1198,  1199,
    1392,   184,   442,  1452,   792,   793,   443,  1180,   794,   444,
     445,  1455,   446,  1456,   185,   448,   449,  1394,   412,   186,
     413,   422,   187,   188,   189,  1201,   190,   483,  1178,  1202,
    1291,  1292,   773,   774,  1203,   107,  1074,   886,   108,  1215,
    1410,  1350,  1299,  1216,  1218,  1302,  1354,  1413,  1220,    57,
     109,   601,   110,   111,   112,   306,   307,   308,   947,  1132,
    1243,  1248,  1246,  1247,  1360,  1424,  1133,  1362,  1434,  1134,
    1498,  1359,  1418,  1419,  1501,  1588,  1615,  1611,  1235,  1253,
    1305,  1356,  1415,  1358,  1236,  1000,    58,    59,    60,    61,
      62,    63,    64,    65,   753,   113,   114,   115,   116,   657,
    1374,  1322,  1254,  1138,   650,   651,   117,   118,   336,   974,
     975,   337,    66,   119,    67,   120,   121,   122,   484
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     191,   633,   447,   441,   222,   956,   953,   760,  1177,   397,
     398,  1385,  1278,   538,   996,   918,  1200,   600,   603,   295,
     393,   305,   420,   313,  1445,   326,   870,   335,   394,   395,
     347,   352,  1059,  1446,  1447,  1448,  1036,   394,   395,   394,
     395,  -304,   486,   487,   488,   489,   490,   418,  1150,     1,
    -304,  -304,  -304,  -304,  1186,  1453,   491,   492,   493,   494,
     495,   496,   497,   498,    68,  -303,   499,   223,   520,   520,
     517,   624,   521,   521,  -303,  -303,  -303,  -303,  1186,  1512,
     486,   487,   488,   489,   490,  1187,   594,   522,   523,   524,
     525,   141,  1300,  1286,   491,   492,   493,   494,   495,   496,
     497,   498,   407,  1334,   499,   622,   408,   520,   378,  1187,
     520,   521,   520,  1420,   521,   409,   521,  1052,   520,   799,
     800,   531,   521,  1433,   152,  1188,   192,   934,   536,   536,
     876,   522,   523,   524,   525,   193,   654,   522,   523,   524,
     525,  1454,   133,   919,   436,   437,   438,   166,   439,  1188,
    1499,  1446,  1447,  1448,  1036,   423,   140,  1500,   563,   520,
    1200,   860,  1288,   521,   550,   435,  1446,  1447,  1448,  1036,
     577,   526,   890,   520,  1186,   969,  1497,   521,   522,   523,
     524,   525,   520,   590,   599,   353,   521,  1453,   520,   669,
     153,   595,   521,   578,   354,   564,  1050,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,   908,  1187,   908,   522,   523,   524,
     525,   197,   520,  1441,   591,   636,   521,  1196,  1562,   597,
    1197,  1189,  1190,  1191,  1192,  1193,  1194,  1195,  1262,   710,
     648,   419,   198,   199,   618,  1393,   658,   659,   216,   652,
     739,  1196,  1339,   629,  1197,  1188,   861,   862,   863,   634,
     625,   530,   637,   379,   750,  1421,   751,   752,   623,   755,
     757,   436,   437,   438,  1036,   439,   872,   711,   368,   898,
     899,   225,   871,  1454,  1053,  1510,   706,   369,  1422,   486,
     487,   488,   489,   490,  1301,   520,   559,  1443,  1513,   521,
     682,  1514,   684,   491,   492,   493,   494,   495,   496,   497,
     498,  1390,  1200,   499,   522,   523,   524,   525,   909,   661,
     909,   414,   486,   487,   488,   489,   490,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,   215,   829,   491,   492,   493,   494,
     495,   496,   497,   498,  1423,   520,   499,  1196,  1393,   521,
    1197,  1522,  1208,   903,  1344,   761,   217,   486,   487,   488,
     489,   490,  1200,   520,  1345,  1279,   583,   521,   219,  1440,
     226,   491,   492,   493,   494,   495,   496,   497,   498,  1059,
    1386,   499,   522,   523,   524,   525,   891,   218,   421,  1416,
     204,  1001,   797,  1449,  1012,   798,  1014,  1450,  1425,   220,
    1609,   655,   656,   767,   518,   802,   198,   199,   803,   772,
    -304,  1137,  1342,  1065,  -304,  1200,  1200,   781,   782,   783,
     784,   785,   436,   437,   438,  1036,   439,   224,   527,   527,
     971,  1578,   972,   795,  -303,   229,   205,  1563,  -303,   520,
    1564,  1028,   206,   521,  1241,  1029,   826,  1551,   789,   981,
     386,   536,   790,   662,   663,  1363,  1364,   831,   522,   523,
     524,   525,   410,   584,   839,   605,   598,   527,   411,   194,
     527,   801,   527,  1363,  1364,   754,   606,   386,   527,   804,
     805,   806,   807,   808,   809,   810,   811,   812,   813,   814,
     815,   816,   877,   981,   864,  1295,  1200,  1438,   386,   877,
     221,   877,   956,  1574,   440,   394,   395,   825,  1238,  1239,
    1249,  1576,   240,  1404,   964,   930,   127,   897,  1016,   527,
     830,   213,   358,   756,  1589,  1590,  1449,   911,   355,   913,
     123,   124,   916,   527,  -303,   920,   921,   910,   214,  1227,
     359,  1118,   527,  1240,   931,   932,   889,   892,   527,   965,
     241,   387,   566,   242,   900,   125,   902,   243,   244,   361,
     245,   246,   247,   945,   883,  1594,   414,   248,   414,   372,
     414,   414,   527,   922,   952,   884,   567,   885,   927,   532,
     929,  1296,   933,  1525,   935,   960,  1526,   938,   939,   940,
     318,   363,   992,   966,   497,   498,   943,   249,   499,   364,
     946,  1304,   250,   367,   568,   569,   976,  1143,   977,  1144,
    1539,   370,   319,   570,   388,   980,   533,   534,  1405,  1406,
    1057,  1037,  1407,  1408,   381,  1426,   441,   441,  1365,   968,
     385,   447,   602,  1011,   382,  1013,   127,   374,   375,  1106,
     486,   487,   488,   489,   490,   527,   978,   979,  1540,  1002,
    1162,  1020,  1164,   386,   491,   492,   493,   494,   495,   496,
     497,   498,   376,   399,   499,  1003,   542,   415,   543,   544,
     566,   128,   486,   487,   488,   489,   490,   400,   230,   129,
     130,   131,   401,   231,  1023,  1015,   491,   492,   493,   494,
     495,   496,   497,   498,   574,   527,   499,   402,   232,   843,
     844,   845,   846,   847,   848,   849,   403,   850,   851,   852,
     853,   854,   542,   527,   543,   544,   404,   720,  1158,  1024,
     571,  1159,   568,   569,  1161,   486,   487,   488,   489,   490,
    1151,   233,  1004,   394,   395,   123,   124,  1062,   207,   491,
     492,   493,   494,   495,   496,   497,   498,   405,  1369,   499,
     486,   487,   488,   489,   490,   357,   406,   208,   360,   545,
     125,   672,   610,   611,   491,   492,   493,   494,   495,   496,
     497,   498,   440,  1409,   499,  1427,  1428,  1429,    69,  1430,
     389,  1030,   416,  1031,   209,  1056,   417,   198,   199,   527,
    1431,   614,   615,   142,   143,   390,   391,   721,  1370,  1371,
    1372,  1373,   765,   144,   766,  1073,   768,   769,    70,   374,
     375,   200,  1075,  1076,  1145,  1078,  1146,    71,   145,   234,
      72,   981,   201,   511,   673,  1397,   424,   146,  1219,   147,
     148,    73,   722,  1091,  1092,   425,   251,  1094,   571,  1096,
    1097,   426,  1099,  1068,    74,   210,   427,   723,  1105,   136,
     137,   513,  1432,   428,    75,  1081,   674,   429,    76,   724,
     514,    77,  1086,    78,    79,   675,   515,  1119,   535,  1120,
     162,    80,   163,   164,   165,   166,   167,   168,   539,  1005,
    1398,  1399,   540,   169,   170,   791,   171,   235,   172,  1142,
    1317,   644,   645,   149,   154,   548,  1058,   551,    81,    82,
     553,   486,   487,   488,   489,   490,  1186,   822,   823,  1318,
      83,   134,   135,   138,   139,   491,   492,   493,   494,   495,
     496,   497,   498,   196,   554,   499,  1006,   155,  1007,   156,
     157,   832,   833,    84,   560,  1400,    85,  1187,   834,   835,
    1401,   984,   985,  1008,   555,   236,  1319,   173,   987,   988,
     237,  1046,   823,   174,   676,   677,   678,   679,  1311,  1466,
    1467,   150,  1328,  1329,   981,   238,   556,   817,   778,   779,
     158,   159,   160,   161,  1009,  1010,   558,  1188,   562,   162,
     576,   163,   164,   165,   166,   167,   168,   579,  1211,   580,
     818,   585,   169,   170,  1245,   171,   581,   172,   819,   836,
     837,   838,  1025,   820,   821,  1323,   586,   582,   175,   176,
    1212,  1213,  1214,   772,  1320,   588,  1170,  1171,  1172,   587,
    1173,   742,  1174,   394,   395,   970,   589,  1181,   592,   596,
    1182,   394,   395,  1207,  1027,   593,  1184,   743,   604,   151,
     365,   366,  1321,   177,   178,   430,   431,   432,   433,  1189,
    1190,  1191,  1192,  1193,  1194,  1195,   173,   607,   608,   879,
     179,   609,   174,   180,   612,   613,   616,   181,   617,  1196,
     619,   620,  1197,  1376,  1377,  1378,  1379,  1263,   486,   487,
     488,   489,   490,  1237,   621,  1242,   626,  1175,  1259,  1260,
    1261,  1250,   491,   492,   493,   494,   495,   496,   497,   498,
     627,   744,   499,   628,   630,   631,   745,   746,   632,   695,
    1411,   635,  1272,   638,   747,   639,   640,   175,   176,   162,
     643,   163,   164,   165,   166,   167,   168,   641,   642,   696,
     697,   646,   169,   170,   647,   171,   649,   172,   653,    86,
     660,   748,   698,   699,   664,   700,   665,  1303,   668,   666,
     670,   667,   177,   178,   430,   431,   432,   433,   681,   671,
     683,   680,   685,  1306,  1307,   687,  1309,   686,  1273,   179,
     688,   689,   180,   690,  1314,   691,   181,  1315,   703,   749,
     705,   693,   707,   694,   708,  1282,   709,   714,   715,  1283,
    1284,   716,   718,   719,   758,  1290,   173,   759,   763,   764,
     770,  1308,   174,   776,   775,   780,   499,   771,   787,   843,
     844,   845,   846,   847,   848,   849,  1469,   850,   851,   852,
     853,   854,   182,   777,  1451,   786,  1417,   796,  1417,   183,
     788,   162,  1352,   163,   164,   165,   166,   167,   168,   824,
     867,   828,   842,  1367,   169,   170,   791,   171,   866,   172,
     869,   882,   893,   894,   895,  1391,   896,   175,   176,  1019,
     486,   487,   488,   489,   490,  1330,   901,   904,  1181,   906,
     887,  1336,   772,  1338,   491,   492,   493,   494,   495,   496,
     497,   498,   888,   905,   499,   912,   914,   915,  1435,  1436,
    1437,   917,   177,   178,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   486,   487,   488,   489,   490,   173,   179,
     923,   924,   180,   925,   174,   926,   181,   491,   492,   493,
     494,   495,   496,   497,   498,   942,   928,   499,   936,  1439,
     240,   182,   536,  1470,   937,   941,  1395,  1396,   183,  1290,
    1584,  1585,  1586,   944,   948,  1610,  1503,   949,   950,   951,
     954,  1506,  1507,  1508,  1451,  1511,  1451,  1553,  1554,  1555,
    1556,  1557,  1558,  1559,  1560,  1465,   318,   957,   241,   175,
     176,   242,   958,  1472,   959,   243,   244,   973,  1181,   246,
     247,  1502,   986,  1504,   961,   248,   843,   844,   845,   846,
     847,   848,   849,   962,   850,   851,   852,   853,   854,  1535,
     963,   989,   990,   991,   177,   178,   993,   998,  1546,  1547,
    1548,   994,  1550,  1552,   997,   249,   999,  1017,  1566,  1021,
     250,   179,  1018,  1032,   180,  1570,  1022,  1033,   181,  1040,
    1034,  1041,  1048,  1043,  1572,  1573,  1026,  1537,  1049,  1055,
    1051,  1543,  1523,  1545,  1054,  1063,  1066,  1065,  1089,  1152,
    1077,  1139,  1527,  1528,  1529,  1530,   536,   536,   536,  1079,
    1080,  1082,  1147,  1591,  1592,  1593,  1083,  1084,  1085,  1087,
    1156,   182,  -444,  1088,  1597,  1093,  1598,  1095,   183,  1098,
    1100,  1101,  1102,   162,  1103,   163,   164,   165,   166,   167,
     168,  1104,  1601,  1107,  1108,  1587,   169,   170,  1109,   171,
    1110,   172,  1111,  1595,  1157,   162,  1112,   163,   164,   165,
     166,   167,   168,  1113,  1114,  1115,  1116,  1117,   169,   170,
    1333,   171,  1599,   172,  1135,  1136,  1600,  1140,  1141,  1602,
     162,   228,   163,   164,   165,   166,   167,   168,  1160,  1163,
     239,  1165,  1166,   169,   170,   254,   171,   255,   172,   296,
    1167,   309,  1169,   314,  1206,   330,  1244,  1613,  1252,  1257,
     173,  1148,  1149,  1204,  1264,  1221,   174,   297,  1205,  1604,
    1183,  1265,   298,   299,   300,  1222,  1274,   486,   487,   488,
     489,   490,   173,   182,  1275,  1223,  1224,  1225,   174,  1226,
     183,   491,   492,   493,   494,   495,   496,   497,   498,  1266,
    1267,   499,  1228,  1276,  1229,  1230,  1231,   173,   301,  1232,
    1233,  1234,  1251,   174,  1256,   302,  1280,  1289,  1035,   303,
    1281,   175,   176,  1285,  1294,  1298,  1310,  1324,  1312,  1313,
    1316,   486,   487,   488,   489,   490,  1325,  1326,  1327,  1332,
    1335,  1343,  1347,   175,   176,   491,   492,   493,   494,   495,
     496,   497,   498,  1346,   304,   499,   177,   178,  1348,  1351,
    1353,  1047,  1355,  1368,  1357,  1375,  1380,  1381,   175,   176,
    -445,  -445,  -445,   179,  1383,  1403,   180,  1384,   177,   178,
     181,  1388,  1412,  1442,  -445,  -445,  -445,  -445,   495,   496,
     497,   498,  1444,  1459,   499,   179,  1460,  1461,   180,  1462,
    1463,  1464,   181,   177,   178,  1468,  1471,  1505,  1515,  1509,
    1517,  1519,  1518,  1531,   486,   487,   488,   489,   490,  1520,
     179,  1516,  1524,   180,  1532,  1533,  1534,   181,   491,   492,
     493,   494,   495,   496,   497,   498,  1536,  1538,   499,   486,
     487,   488,   489,   490,  1544,  1565,  1542,  1549,  1567,  1561,
    1568,  1596,  1603,   491,   492,   493,   494,   495,   496,   497,
     498,  1614,  1612,   499,   486,   487,   488,   489,   490,   827,
    1210,  1044,  1569,   575,  1571,  1541,   704,  1155,   491,   492,
     493,   494,   495,   496,   497,   498,  1605,  1606,   499,   486,
     487,   488,   489,   490,  1607,  1608,  1616,  1255,  1154,  1185,
     486,   487,   488,   491,   492,   493,   494,   495,   496,   497,
     498,   717,   858,   499,   491,   492,   493,   494,   495,   496,
     497,   498,   995,  1293,   499,   741,  1061,  1521,  1038,   486,
     487,   488,   489,   490,  -439,   182,  1577,   434,  1179,  1039,
    1042,  1287,   183,   491,   492,   493,   494,   495,   496,   497,
     498,  1579,  1402,   499,  1168,  1217,  1337,   182,  1349,   486,
     487,   488,   489,   490,   183,  1361,  1090,     0,  1414,  1153,
       0,     0,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,   182,   499,   486,   487,   488,   489,   490,   183,
       0,     0,     0,     0,     0,     0,     0,     0,   491,   492,
     493,   494,   495,   496,   497,   498,     0,     0,   499,   486,
     487,   488,   489,   490,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   491,   492,   493,   494,   495,   496,   497,
     498,     0,     0,   499,     0,  1176,   486,   487,   488,   489,
     490,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     491,   492,   493,   494,   495,   496,   497,   498,  1121,     0,
     499,   486,   487,   488,   489,   490,     0,     0,     0,   450,
       0,     0,     0,     0,     0,   491,   492,   493,   494,   495,
     496,   497,   498,     0,     0,   499,     0,     0,     0,  1268,
     486,   487,   488,   489,   490,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   491,   492,   493,   494,   495,   496,
     497,   498,     0,  1122,   499,   486,   487,   488,   489,   490,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,     0,   499,
     486,   487,   488,   489,   490,   451,   452,     0,   453,   454,
       0,     0,     0,     0,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,   499,   486,   487,   488,   489,   490,
       0,     0,  1269,     0,     0,     0,     0,     0,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,     0,   499,
     486,   487,   488,   489,   490,   450,     0,  1270,     0,  1123,
       0,     0,     0,   456,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,   499,   486,   487,   488,   489,   490,
       0,     0,  1271,     0,     0,     0,     0,     0,     0,   491,
     492,   493,   494,   495,   496,   497,   498,     0,     0,   499,
     486,   487,   488,   489,   490,     0,     0,  1277,     0,     0,
       0,     0,     0,  1124,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,   499,     0,     0,     0,     0,     0,
       0,   451,   452,     0,   453,   454,     0,  1125,     0,  1126,
       0,     0,     0,     0,  1127,     0,  1128,  1331,     0,     0,
    1129,  1130,     0,     0,     0,     0,     0,     0,   455,     0,
       0,     0,     0,     0,     0,   466,   467,   468,   469,   470,
     471,   472,   473,   474,     0,     0,     0,  1382,     0,     0,
       0,     0,     0,     0,     0,   240,     0,     0,     0,   456,
       0,   475,   476,     0,  1131,     0,     0,     0,     0,     0,
       0,     0,  1575,     0,     0,     0,     0,   477,   478,   479,
     480,     0,   338,   339,   340,     0,   341,   342,     0,   343,
       0,     0,     0,   241,     0,     0,   242,  1580,     0,     0,
     243,   244,     0,     0,   246,   247,     0,     0,     0,     0,
     248,     0,   457,   458,     0,   459,   460,   461,   462,   463,
     464,   465,     0,     0,  1581,     0,     0,     0,     0,     0,
     315,     0,     0,     0,   240,     0,     0,     0,     0,     0,
     249,     0,     0,     0,     0,   250,     0,     0,     0,  1582,
       0,   481,   482,     0,     0,   316,     0,     0,     0,     0,
       0,   466,   467,   468,   469,   470,   471,   472,   473,   474,
       0,     0,   241,     0,     0,   242,     0,     0,  1583,   243,
     244,     0,   317,   246,   247,     0,     0,   475,   476,   248,
       0,     0,     0,     0,   240,     0,   318,     0,     0,   256,
       0,  1045,     0,   477,   478,   479,   480,     0,     0,     0,
       0,     0,     0,     0,   257,     0,     0,     0,   319,   249,
       0,     0,     0,     0,   250,   240,  1340,     0,   258,     0,
       0,     0,   241,     0,     0,   242,     0,     0,     0,   243,
     244,   259,   260,   246,   247,   331,     0,     0,     0,   248,
       0,  1387,     0,   261,     0,     0,   262,     0,   263,     0,
       0,     0,     0,   241,     0,     0,   242,   240,     0,     0,
     243,   244,     0,     0,   246,   247,  1389,   481,   482,   249,
     248,     0,     0,     0,   250,     0,   240,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   264,     0,
     265,  1457,     0,     0,     0,   241,     0,     0,   242,   266,
     249,     0,   243,   244,     0,   250,   246,   247,   240,     0,
       0,     0,   248,     0,   241,     0,  1458,   242,     0,   332,
       0,   243,   244,     0,  1069,   246,   247,     0,     0,     0,
       0,   248,     0,     0,     0,   267,     0,   348,     0,     0,
       0,     0,   249,     0,     0,     0,   241,   250,     0,   242,
       0,     0,   268,   243,   244,     0,     0,   246,   247,   269,
     270,   249,   271,   248,   272,   273,   250,   274,   275,   344,
     276,     0,     0,   277,   278,     0,   279,     0,   349,  1473,
       0,     0,     0,     0,     0,     0,   320,   726,     0,   280,
     281,     0,     0,   249,   282,     0,   283,   284,   250,   285,
       0,     0,   394,   395,   286,     0,     0,     0,   287,   288,
       0,   289,   290,     0,   291,   292,   293,     0,     0,     0,
       0,   318,     0,     0,   321,   322,   323,     0,   727,     0,
       0,     0,     0,   324,     0,     0,     0,     0,     0,   333,
       0,     0,     0,   319,     0,     0,     0,     0,   325,     0,
       0,  1070,  1071,     0,     0,     0,  1474,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   728,     0,     0,
    1475,     0,   729,     0,     0,     0,     0,     0,     0,   730,
     731,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     732,     0,     0,     0,     0,     0,     0,     0,     0,   733,
     734,   735,   736,     0,   737,   738,     0,     0,   294,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1476,     0,     0,
    1477,  1478,     0,     0,     0,     0,     0,     0,     0,   334,
     486,   487,   488,   489,   490,     0,     0,     0,     0,     0,
       0,     0,   310,   311,   491,   492,   493,   494,   495,   496,
     497,   498,     0,     0,   499,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   312,     0,     0,     0,     0,     0,  1479,     4,     0,
    1480,     0,     0,     0,  1481,     0,   571,     0,     0,     0,
    1072,     0,  1482,     0,  1483,     0,  1484,  1485,  1486,  1487,
    1488,  1489,     0,     5,     6,     0,     0,  1490,     0,     0,
       0,  1491,  1492,     7,     0,  1493,     0,     0,     0,     0,
       0,     0,   350,   485,     0,     0,     0,  1494,   486,   487,
     488,   489,   490,     0,     0,  1495,     0,     8,     0,     0,
       0,     0,   491,   492,   493,   494,   495,   496,   497,   498,
       0,     0,   499,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     9,     0,     0,    10,     0,
      11,     0,     0,  1496,     0,     0,     0,    12,     0,    13,
       0,     0,     0,     0,    14,    15,    16,     0,     0,     0,
       0,    17,    18,    19,   486,   487,   488,   489,   490,     0,
       0,     0,     0,     0,     0,  1341,     0,     0,   491,   492,
     493,   494,   495,   496,   497,   498,     0,     0,   499
};

static const yytype_int16 yycheck[] =
{
      17,   297,   183,   183,    83,   653,   650,    29,  1032,   152,
     153,     7,    22,   214,   736,   105,  1055,   270,   271,   110,
     151,   112,    15,   114,     6,   116,   123,   118,    18,    19,
     121,   122,   867,    15,    16,    17,    18,    18,    19,    18,
      19,     6,     8,     9,    10,    11,    12,    27,   971,     4,
      15,    16,    17,    18,    19,  1394,    22,    23,    24,    25,
      26,    27,    28,    29,     0,     6,    32,    84,    15,    15,
      44,    92,    19,    19,    15,    16,    17,    18,    19,    97,
       8,     9,    10,    11,    12,    50,   149,    34,    35,    36,
      37,   123,    30,  1199,    22,    23,    24,    25,    26,    27,
      28,    29,    15,  1275,    32,    83,    19,    15,     3,    50,
      15,    19,    15,   148,    19,    28,    19,    19,    15,    26,
      27,   206,    19,  1362,   123,    90,    35,   622,   213,   214,
      35,    34,    35,    36,    37,    44,    97,    34,    35,    36,
      37,  1394,     3,   233,    15,    16,    17,    18,    19,    90,
     313,    15,    16,    17,    18,   172,     3,   320,   243,    15,
    1199,    41,  1200,    19,   221,   182,    15,    16,    17,    18,
     249,    68,    75,    15,    19,   670,  1415,    19,    34,    35,
      36,    37,    15,   262,   269,    35,    19,  1526,    15,   332,
     123,   254,    19,   250,    44,   244,   840,   162,   163,   164,
     165,   166,   167,   168,    41,    50,    41,    34,    35,    36,
      37,    19,    15,  1385,   263,   300,    19,   182,    97,   268,
     185,   162,   163,   164,   165,   166,   167,   168,  1151,    98,
     315,   211,    19,    20,   283,  1341,   321,   322,    19,   318,
     383,   182,  1281,   292,   185,    90,   126,   127,   128,   298,
     271,   205,   301,   148,   385,   290,   387,   388,   236,   390,
     391,    15,    16,    17,    18,    19,   562,   136,    35,   216,
     217,    19,   369,  1526,   176,   117,   361,    44,   313,     8,
       9,    10,    11,    12,   222,    15,   240,  1391,   306,    19,
     339,   309,   341,    22,    23,    24,    25,    26,    27,    28,
      29,  1339,  1341,    32,    34,    35,    36,    37,   145,   221,
     145,   162,     8,     9,    10,    11,    12,   162,   163,   164,
     165,   166,   167,   168,    80,   526,    22,    23,    24,    25,
      26,    27,    28,    29,   369,    15,    32,   182,  1444,    19,
     185,  1445,  1064,   596,    22,   367,    87,     8,     9,    10,
      11,    12,  1391,    15,    32,   365,   142,    19,    83,  1383,
     108,    22,    23,    24,    25,    26,    27,    28,    29,  1204,
     366,    32,    34,    35,    36,    37,   279,    19,   371,   369,
      67,   752,   370,   365,   755,   373,   757,   369,   369,   125,
     369,   352,   353,   410,   368,   370,    19,    20,   373,   416,
     365,   368,   368,   370,   369,  1444,  1445,   424,   425,   426,
     427,   428,    15,    16,    17,    18,    19,    19,   365,   365,
     673,  1525,   675,   440,   365,   368,   113,   306,   369,    15,
     309,   366,   119,    19,   290,   370,   515,   117,   366,   692,
      19,   526,   370,   355,   356,   140,   141,   532,    34,    35,
      36,    37,   365,   239,   539,   227,   364,   365,   371,   368,
     365,   368,   365,   140,   141,    44,   238,    19,   365,   486,
     487,   488,   489,   490,   491,   492,   493,   494,   495,   496,
     497,   498,   567,   736,   364,  1207,  1525,   217,    19,   574,
     113,   576,  1140,  1517,   365,    18,    19,   514,   290,   291,
     327,   365,    45,   109,    87,   233,    20,   592,   761,   365,
     527,    49,     3,    44,   317,   318,   365,   602,   368,   604,
      19,    20,   607,   365,   369,   610,   611,   364,    66,   364,
       3,   364,   365,   325,   262,   263,   585,   586,   365,   122,
      83,    93,    44,    86,   593,    44,   595,    90,    91,    66,
      93,    94,    95,   638,   571,   217,   407,   100,   409,    83,
     411,   412,   365,   612,   649,   574,    68,   576,   617,    20,
     619,  1215,   621,   367,   623,   660,   370,   626,   627,   628,
     107,     3,   725,   166,    28,    29,   635,   130,    32,     3,
     639,  1235,   135,     3,    96,    97,   681,   108,   683,   110,
     295,   368,   129,   105,   156,   690,    57,    58,   214,   215,
     863,   365,   218,   219,     3,   142,   796,   797,   295,   668,
     224,   802,   145,   754,     3,   756,    20,    19,    20,   925,
       8,     9,    10,    11,    12,   365,   685,   686,   333,     3,
    1011,   370,  1013,    19,    22,    23,    24,    25,    26,    27,
      28,    29,    44,     3,    32,    19,    15,    29,    17,    18,
      44,    55,     8,     9,    10,    11,    12,     3,    72,    63,
      64,    65,     3,    77,   370,   760,    22,    23,    24,    25,
      26,    27,    28,    29,    68,   365,    32,     3,    92,   169,
     170,   171,   172,   173,   174,   175,     3,   177,   178,   179,
     180,   181,    15,   365,    17,    18,     3,     3,  1004,   370,
     212,  1007,    96,    97,  1010,     8,     9,    10,    11,    12,
     973,   125,    86,    18,    19,    19,    20,   870,    42,    22,
      23,    24,    25,    26,    27,    28,    29,     3,   298,    32,
       8,     9,    10,    11,    12,   128,     3,    61,   131,   108,
      44,   167,   242,   243,    22,    23,    24,    25,    26,    27,
      28,    29,   365,   369,    32,   292,   293,   294,     3,   296,
     322,   788,   365,   790,    88,   860,   211,    19,    20,   365,
     307,   252,   253,   113,   114,   337,   338,    83,   348,   349,
     350,   351,   407,   123,   409,   886,   411,   412,    33,    19,
      20,    43,   887,   888,   108,   890,   110,    42,   138,   213,
      45,  1064,    54,    15,   230,    96,   365,   147,  1071,   149,
     150,    56,   118,   908,   909,   365,   369,   912,   212,   914,
     915,   365,   917,   882,    69,   149,   365,   133,   923,   133,
     134,     3,   369,   365,    79,   894,   262,   365,    83,   145,
      22,    86,   901,    88,    89,   271,    62,   942,   364,   944,
      13,    96,    15,    16,    17,    18,    19,    20,   142,   233,
     151,   152,   131,    26,    27,    28,    29,   281,    31,   964,
     217,   342,   343,   213,    78,    19,   366,   364,   123,   124,
     108,     8,     9,    10,    11,    12,    19,   369,   370,   236,
     135,     7,     8,     9,    10,    22,    23,    24,    25,    26,
      27,    28,    29,    19,    19,    32,   280,   111,   282,   113,
     114,    59,    60,   158,    19,   206,   161,    50,    59,    60,
     211,   369,   370,   297,   368,   339,   273,    90,   369,   370,
     344,   369,   370,    96,   360,   361,   362,   363,  1244,   216,
     217,   281,  1266,  1267,  1207,   359,   368,   171,   420,   421,
     154,   155,   156,   157,   328,   329,   368,    90,    87,    13,
      68,    15,    16,    17,    18,    19,    20,   364,    80,   364,
     194,   280,    26,    27,  1127,    29,   368,    31,   202,    38,
      39,    40,   370,   207,   208,  1256,    80,   368,   151,   152,
     102,   103,   104,  1020,   341,    20,  1023,  1024,  1025,   364,
    1027,     3,  1029,    18,    19,    20,   240,  1034,    68,   128,
    1037,    18,    19,    20,   370,   278,  1043,    19,    75,   359,
     136,   137,   369,   186,   187,   188,   189,   190,   191,   162,
     163,   164,   165,   166,   167,   168,    90,    75,   225,    19,
     203,   232,    96,   206,   236,   238,   252,   210,   256,   182,
     259,   261,   185,  1324,  1325,  1326,  1327,  1152,     8,     9,
      10,    11,    12,  1122,   266,  1124,   236,   370,  1144,  1145,
    1146,  1130,    22,    23,    24,    25,    26,    27,    28,    29,
     274,    83,    32,   272,   223,   364,    88,    89,   368,    78,
    1353,    86,   370,    87,    96,   321,   364,   151,   152,    13,
      83,    15,    16,    17,    18,    19,    20,   368,   368,    98,
      99,   364,    26,    27,   368,    29,    75,    31,   368,   364,
      75,   123,   111,   112,   364,   114,   364,  1222,   280,   368,
      83,   368,   186,   187,   188,   189,   190,   191,    83,   364,
      75,   364,    78,  1238,  1239,   364,  1241,    80,  1175,   203,
     364,   364,   206,    75,  1249,    20,   210,  1252,     3,   161,
       3,   364,     3,   364,     3,  1192,     3,     3,    19,  1196,
    1197,     3,     3,     3,     3,  1202,    90,     3,   143,   143,
      14,  1240,    96,   211,    26,    29,    32,    15,    15,   169,
     170,   171,   172,   173,   174,   175,  1407,   177,   178,   179,
     180,   181,   365,    27,  1394,    19,  1359,     7,  1361,   372,
     370,    13,  1301,    15,    16,    17,    18,    19,    20,     3,
     365,   364,   364,  1318,    26,    27,    28,    29,   364,    31,
      19,   106,   364,    50,   364,   368,   364,   151,   152,   366,
       8,     9,    10,    11,    12,  1272,   264,   364,  1275,    30,
      75,  1278,  1279,  1280,    22,    23,    24,    25,    26,    27,
      28,    29,    75,   364,    32,   145,    75,    75,  1363,  1364,
    1365,    75,   186,   187,    45,    46,    47,    48,    49,    50,
      51,    52,    53,     8,     9,    10,    11,    12,    90,   203,
      75,   364,   206,    87,    96,   364,   210,    22,    23,    24,
      25,    26,    27,    28,    29,   145,   364,    32,   364,  1368,
      45,   365,  1407,  1408,   364,   364,  1343,  1344,   372,  1346,
    1531,  1532,  1533,    68,    19,  1588,  1421,   364,   364,   364,
     364,  1426,  1427,  1428,  1524,  1430,  1526,   298,   299,   300,
     301,   302,   303,   304,   305,  1404,   107,   364,    83,   151,
     152,    86,   364,  1412,   364,    90,    91,   230,  1385,    94,
      95,  1420,     3,  1422,   364,   100,   169,   170,   171,   172,
     173,   174,   175,   364,   177,   178,   179,   180,   181,  1474,
     364,     3,    19,    15,   186,   187,    19,     3,  1483,  1484,
    1485,    19,  1487,  1488,    19,   130,    20,    15,  1493,   366,
     135,   203,    15,     7,   206,  1500,    27,   370,   210,    15,
     370,    18,    20,   365,  1509,  1510,   366,  1476,   364,   368,
     364,  1480,  1449,  1482,   364,    27,   101,   370,    19,   324,
     364,   369,  1459,  1460,  1461,  1462,  1531,  1532,  1533,   364,
     364,   364,   369,  1538,  1539,  1540,   364,   364,   364,   364,
       3,   365,   366,   364,  1549,   364,  1551,   364,   372,   364,
     364,   364,   364,    13,   364,    15,    16,    17,    18,    19,
      20,   364,  1567,   364,   364,  1534,    26,    27,   364,    29,
     364,    31,   364,  1542,     3,    13,   364,    15,    16,    17,
      18,    19,    20,   364,   364,   364,   364,   364,    26,    27,
      28,    29,  1561,    31,   364,   364,  1565,   364,   364,  1568,
      13,    93,    15,    16,    17,    18,    19,    20,    15,     3,
     102,     3,   145,    26,    27,   107,    29,   109,    31,   111,
     145,   113,    27,   115,   143,   117,   280,  1596,   330,    20,
      90,   364,   364,   364,     3,   364,    96,   282,   366,  1576,
     370,     3,   287,   288,   289,   370,   366,     8,     9,    10,
      11,    12,    90,   365,   370,   364,   364,   364,    96,   364,
     372,    22,    23,    24,    25,    26,    27,    28,    29,    15,
      15,    32,   364,    15,   364,   364,   364,    90,   323,   364,
     364,   364,   364,    96,   364,   330,    22,   364,   366,   334,
     365,   151,   152,   369,    15,   368,   368,   364,   368,   368,
     368,     8,     9,    10,    11,    12,   364,   364,   364,     7,
     369,    22,   364,   151,   152,    22,    23,    24,    25,    26,
      27,    28,    29,   370,   369,    32,   186,   187,   145,    19,
     223,   366,   364,   274,   368,   364,     3,     3,   151,   152,
       8,     9,    10,   203,   365,    15,   206,   366,   186,   187,
     210,   366,   220,   366,    22,    23,    24,    25,    26,    27,
      28,    29,   184,   365,    32,   203,   365,   365,   206,   365,
     364,   364,   210,   186,   187,   217,   364,   364,   364,   238,
     370,   364,   366,   218,     8,     9,    10,    11,    12,   369,
     203,   315,     7,   206,   218,   218,   280,   210,    22,    23,
      24,    25,    26,    27,    28,    29,   368,   316,    32,     8,
       9,    10,    11,    12,   335,   300,   274,   238,   324,   332,
     298,   336,   366,    22,    23,    24,    25,    26,    27,    28,
      29,   310,   315,    32,     8,     9,    10,    11,    12,   518,
    1065,   823,   364,   247,   364,  1478,   357,   988,    22,    23,
      24,    25,    26,    27,    28,    29,   364,   364,    32,     8,
       9,    10,    11,    12,   364,   364,   364,  1140,   985,  1054,
       8,     9,    10,    22,    23,    24,    25,    26,    27,    28,
      29,   376,   547,    32,    22,    23,    24,    25,    26,    27,
      28,    29,   731,  1204,    32,   383,   868,  1444,   796,     8,
       9,    10,    11,    12,   364,   365,  1524,   182,  1033,   797,
     802,  1200,   372,    22,    23,    24,    25,    26,    27,    28,
      29,  1526,  1346,    32,  1020,  1070,  1279,   365,  1297,     8,
       9,    10,    11,    12,   372,  1313,   907,    -1,  1356,   975,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,   365,    32,     8,     9,    10,    11,    12,   372,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32,     8,
       9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    24,    25,    26,    27,    28,
      29,    -1,    -1,    32,    -1,   366,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    93,    -1,
      32,     8,     9,    10,    11,    12,    -1,    -1,    -1,     5,
      -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,
      27,    28,    29,    -1,    -1,    32,    -1,    -1,    -1,   366,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,   148,    32,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    81,    82,    -1,    84,    85,
      -1,    -1,    -1,    -1,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,     5,    -1,   366,    -1,   234,
      -1,    -1,    -1,   139,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,     8,     9,    10,    11,    12,
      -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,    -1,    -1,    32,
       8,     9,    10,    11,    12,    -1,    -1,   366,    -1,    -1,
      -1,    -1,    -1,   288,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    81,    82,    -1,    84,    85,    -1,   312,    -1,   314,
      -1,    -1,    -1,    -1,   319,    -1,   321,   366,    -1,    -1,
     325,   326,    -1,    -1,    -1,    -1,    -1,    -1,   108,    -1,
      -1,    -1,    -1,    -1,    -1,   241,   242,   243,   244,   245,
     246,   247,   248,   249,    -1,    -1,    -1,   366,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,   139,
      -1,   267,   268,    -1,   369,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   366,    -1,    -1,    -1,    -1,   283,   284,   285,
     286,    -1,    72,    73,    74,    -1,    76,    77,    -1,    79,
      -1,    -1,    -1,    83,    -1,    -1,    86,   366,    -1,    -1,
      90,    91,    -1,    -1,    94,    95,    -1,    -1,    -1,    -1,
     100,    -1,   192,   193,    -1,   195,   196,   197,   198,   199,
     200,   201,    -1,    -1,   366,    -1,    -1,    -1,    -1,    -1,
      41,    -1,    -1,    -1,    45,    -1,    -1,    -1,    -1,    -1,
     130,    -1,    -1,    -1,    -1,   135,    -1,    -1,    -1,   366,
      -1,   357,   358,    -1,    -1,    66,    -1,    -1,    -1,    -1,
      -1,   241,   242,   243,   244,   245,   246,   247,   248,   249,
      -1,    -1,    83,    -1,    -1,    86,    -1,    -1,   366,    90,
      91,    -1,    93,    94,    95,    -1,    -1,   267,   268,   100,
      -1,    -1,    -1,    -1,    45,    -1,   107,    -1,    -1,    50,
      -1,   364,    -1,   283,   284,   285,   286,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,   129,   130,
      -1,    -1,    -1,    -1,   135,    45,   364,    -1,    79,    -1,
      -1,    -1,    83,    -1,    -1,    86,    -1,    -1,    -1,    90,
      91,    92,    93,    94,    95,    65,    -1,    -1,    -1,   100,
      -1,   364,    -1,   104,    -1,    -1,   107,    -1,   109,    -1,
      -1,    -1,    -1,    83,    -1,    -1,    86,    45,    -1,    -1,
      90,    91,    -1,    -1,    94,    95,   364,   357,   358,   130,
     100,    -1,    -1,    -1,   135,    -1,    45,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
     151,   364,    -1,    -1,    -1,    83,    -1,    -1,    86,   160,
     130,    -1,    90,    91,    -1,   135,    94,    95,    45,    -1,
      -1,    -1,   100,    -1,    83,    -1,   364,    86,    -1,   149,
      -1,    90,    91,    -1,    93,    94,    95,    -1,    -1,    -1,
      -1,   100,    -1,    -1,    -1,   196,    -1,    74,    -1,    -1,
      -1,    -1,   130,    -1,    -1,    -1,    83,   135,    -1,    86,
      -1,    -1,   213,    90,    91,    -1,    -1,    94,    95,   220,
     221,   130,   223,   100,   225,   226,   135,   228,   229,   369,
     231,    -1,    -1,   234,   235,    -1,   237,    -1,   115,    65,
      -1,    -1,    -1,    -1,    -1,    -1,   307,     3,    -1,   250,
     251,    -1,    -1,   130,   255,    -1,   257,   258,   135,   260,
      -1,    -1,    18,    19,   265,    -1,    -1,    -1,   269,   270,
      -1,   272,   273,    -1,   275,   276,   277,    -1,    -1,    -1,
      -1,   107,    -1,    -1,   345,   346,   347,    -1,    44,    -1,
      -1,    -1,    -1,   354,    -1,    -1,    -1,    -1,    -1,   269,
      -1,    -1,    -1,   129,    -1,    -1,    -1,    -1,   369,    -1,
      -1,   220,   221,    -1,    -1,    -1,   142,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,
     156,    -1,    88,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     106,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,
     116,   117,   118,    -1,   120,   121,    -1,    -1,   369,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   213,    -1,    -1,
     216,   217,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   369,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   340,   341,    22,    23,    24,    25,    26,    27,
      28,    29,    -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   369,    -1,    -1,    -1,    -1,    -1,   273,    45,    -1,
     276,    -1,    -1,    -1,   280,    -1,   212,    -1,    -1,    -1,
     369,    -1,   288,    -1,   290,    -1,   292,   293,   294,   295,
     296,   297,    -1,    70,    71,    -1,    -1,   303,    -1,    -1,
      -1,   307,   308,    80,    -1,   311,    -1,    -1,    -1,    -1,
      -1,    -1,   369,     3,    -1,    -1,    -1,   323,     8,     9,
      10,    11,    12,    -1,    -1,   331,    -1,   104,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   132,    -1,    -1,   135,    -1,
     137,    -1,    -1,   369,    -1,    -1,    -1,   144,    -1,   146,
      -1,    -1,    -1,    -1,   151,   152,   153,    -1,    -1,    -1,
      -1,   158,   159,   160,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    -1,    -1,    -1,   183,    -1,    -1,    22,    23,
      24,    25,    26,    27,    28,    29,    -1,    -1,    32
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   375,   376,    45,    70,    71,    80,   104,   132,
     135,   137,   144,   146,   151,   152,   153,   158,   159,   160,
     400,   401,   402,   403,   404,   405,   456,   457,   458,   459,
     461,   462,   463,   466,   469,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   563,   600,   601,
     602,   603,   604,   605,   606,   607,   626,   628,     0,     3,
      33,    42,    45,    56,    69,    79,    83,    86,    88,    89,
      96,   123,   124,   135,   158,   161,   364,   377,   389,   395,
     398,   399,   408,   410,   413,   415,   418,   420,   421,   423,
     424,   431,   441,   442,   498,   500,   510,   549,   552,   564,
     566,   567,   568,   609,   610,   611,   612,   620,   621,   627,
     629,   630,   631,    19,    20,    44,   496,    20,    55,    63,
      64,    65,   406,     3,   496,   496,   133,   134,   496,   496,
       3,   123,   113,   114,   123,   138,   147,   149,   150,   213,
     281,   359,   123,   123,    78,   111,   113,   114,   154,   155,
     156,   157,    13,    15,    16,    17,    18,    19,    20,    26,
      27,    29,    31,    90,    96,   151,   152,   186,   187,   203,
     206,   210,   365,   372,   515,   528,   533,   536,   537,   538,
     540,   542,    35,    44,   368,   485,   496,    19,    19,    20,
      43,    54,   387,   391,    67,   113,   119,    42,    61,    88,
     149,   396,   397,    49,    66,    80,    19,    87,    19,    83,
     125,   113,   387,   542,    19,    19,   108,   425,   425,   368,
      72,    77,    92,   125,   213,   281,   339,   344,   359,   425,
      45,    83,    86,    90,    91,    93,    94,    95,   100,   130,
     135,   369,   426,   444,   425,   425,    50,    65,    79,    92,
      93,   104,   107,   109,   149,   151,   160,   196,   213,   220,
     221,   223,   225,   226,   228,   229,   231,   234,   235,   237,
     250,   251,   255,   257,   258,   260,   265,   269,   270,   272,
     273,   275,   276,   277,   369,   426,   425,   282,   287,   288,
     289,   323,   330,   334,   369,   426,   569,   570,   571,   425,
     340,   341,   369,   426,   425,    41,    66,    93,   107,   129,
     307,   345,   346,   347,   354,   369,   426,   451,   453,   454,
     425,    65,   149,   269,   369,   426,   622,   625,    72,    73,
      74,    76,    77,    79,   369,   409,   412,   426,    74,   115,
     369,   411,   426,    35,    44,   368,   445,   406,     3,     3,
     406,    66,   407,     3,     3,   496,   496,     3,    35,    44,
     368,   448,    83,   471,    19,    20,    44,   497,     3,   148,
     467,     3,     3,   464,   470,   224,    19,    93,   156,   322,
     337,   338,   460,   460,    18,    19,   381,   383,   383,     3,
       3,     3,     3,     3,     3,     3,     3,    15,    19,    28,
     365,   371,   532,   534,   540,    29,   365,   211,    27,   211,
      15,   371,   535,   542,   365,   365,   365,   365,   365,   365,
     188,   189,   190,   191,   522,   542,    15,    16,    17,    19,
     365,   515,   516,   520,   523,   524,   526,   528,   529,   530,
       5,    81,    82,    84,    85,   108,   139,   192,   193,   195,
     196,   197,   198,   199,   200,   201,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   267,   268,   283,   284,   285,
     286,   357,   358,   541,   632,     3,     8,     9,    10,    11,
      12,    22,    23,    24,    25,    26,    27,    28,    29,    32,
      45,    46,    47,    48,    49,    50,    51,    52,    53,   393,
     394,    15,   486,     3,    22,    62,   390,    44,   368,   392,
      15,    19,    34,    35,    36,    37,    68,   365,   378,   380,
     445,   378,    20,    57,    58,   364,   378,   379,   379,   142,
     131,   419,    15,    17,    18,   108,   414,   499,    19,   416,
     448,   364,   511,   108,    19,   368,   368,   422,   368,   445,
      19,   430,    87,   378,   380,   443,    44,    68,    96,    97,
     105,   212,   427,   507,    68,   427,    68,   387,   448,   364,
     364,   368,   368,   142,   239,   280,    80,   364,    20,   240,
     387,   380,    68,   278,   149,   254,   128,   380,   364,   378,
     381,   565,   145,   381,    75,   227,   238,    75,   225,   232,
     242,   243,   236,   238,   252,   253,   252,   256,   380,   259,
     261,   266,    83,   236,    92,   271,   236,   274,   272,   380,
     223,   364,   368,   414,   380,    86,   378,   380,    87,   321,
     364,   368,   368,    83,   342,   343,   364,   368,   378,    75,
     618,   619,   387,   368,    97,   352,   353,   613,   378,   378,
      75,   221,   355,   356,   364,   364,   368,   368,   280,   383,
      83,   364,   167,   230,   262,   271,   360,   361,   362,   363,
     364,    83,   380,    75,   380,    78,    80,   364,   364,   364,
      75,    20,   388,   364,   364,    78,    98,    99,   111,   112,
     114,   446,   447,     3,   407,     3,   378,     3,     3,     3,
      98,   136,   449,   450,     3,    19,     3,   497,     3,     3,
       3,    83,   118,   133,   145,   468,     3,    44,    83,    88,
      95,    96,   106,   115,   116,   117,   118,   120,   121,   383,
     465,   507,     3,    19,    83,    88,    89,    96,   123,   161,
     460,   460,   460,   608,    44,   460,    44,   460,     3,     3,
      29,   367,   385,   143,   143,   534,   534,   542,   534,   534,
      14,    15,   542,   546,   547,    26,   211,    27,   535,   535,
      29,   542,   542,   542,   542,   542,    19,    15,   370,   366,
     370,    28,   518,   519,   522,   542,     7,   370,   373,    26,
      27,   368,   370,   373,   542,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   542,   542,   542,   171,   194,   202,
     207,   208,   369,   370,     3,   542,   387,   393,   364,   379,
     542,   378,    59,    60,    59,    60,    38,    39,    40,   378,
     438,   439,   364,   169,   170,   171,   172,   173,   174,   175,
     177,   178,   179,   180,   181,   501,   502,   503,   505,   509,
      41,   126,   127,   128,   364,   417,   364,   365,   508,    19,
     123,   369,   414,   432,   435,   436,    35,   378,   429,    19,
     505,   506,   106,   542,   429,   429,   551,    75,    75,   380,
      75,   279,   380,   364,    50,   364,   364,   378,   216,   217,
     380,   264,   380,   381,   364,   364,    30,   382,    41,   145,
     364,   378,   145,   378,    75,    75,   378,    75,   105,   233,
     378,   378,   380,    75,   364,    87,   364,   380,   364,   380,
     233,   262,   263,   380,   430,   380,   364,   364,   380,   380,
     380,   364,   145,   380,    68,   378,   380,   572,    19,   364,
     364,   364,   378,   436,   364,   452,   453,   364,   364,   364,
     378,   364,   364,   364,    87,   122,   166,   455,   380,   430,
      20,   381,   381,   230,   623,   624,   378,   378,   380,   380,
     378,   381,   383,   384,   369,   370,     3,   369,   370,     3,
      19,    15,   383,    19,    19,   506,   384,    19,     3,    20,
     599,   599,     3,    19,    86,   233,   280,   282,   297,   328,
     329,   460,   599,   460,   599,   378,   381,    15,    15,   366,
     370,   366,    27,   370,   370,   370,   366,   370,   366,   370,
     542,   542,     7,   370,   370,   366,    18,   365,   516,   524,
      15,    18,   529,   365,   394,   364,   369,   366,    20,   364,
     436,   364,    19,   176,   364,   368,   378,   381,   366,   502,
     504,   509,   383,    27,   434,   370,   101,   428,   380,    93,
     220,   221,   369,   426,   550,   378,   378,   364,   378,   364,
     364,   380,   364,   364,   364,   364,   380,   364,   364,    19,
     565,   378,   378,   364,   378,   364,   378,   378,   364,   378,
     364,   364,   364,   364,   364,   378,   414,   364,   364,   364,
     364,   364,   364,   364,   364,   364,   364,   364,   364,   378,
     378,    93,   148,   234,   288,   312,   314,   319,   321,   325,
     326,   369,   573,   580,   583,   364,   364,   368,   617,   369,
     364,   364,   378,   108,   110,   108,   110,   369,   364,   364,
     382,   381,   324,   623,   447,   450,     3,     3,   414,   414,
      15,   414,   599,     3,   599,     3,   145,   145,   546,    27,
     542,   542,   542,   542,   542,   370,   366,   518,   542,   519,
     521,   542,   542,   370,   542,   503,    19,    50,    90,   162,
     163,   164,   165,   166,   167,   168,   182,   185,   512,   513,
     538,   539,   543,   548,   364,   366,   143,    20,   384,   433,
     435,    80,   102,   103,   104,   553,   557,   553,   558,   381,
     562,   364,   370,   364,   364,   364,   364,   364,   364,   364,
     364,   364,   364,   364,   364,   592,   598,   380,   290,   291,
     325,   290,   380,   574,   280,   383,   576,   577,   575,   327,
     380,   364,   330,   593,   616,   452,   364,    20,   386,   386,
     386,   386,   382,   378,     3,     3,    15,    15,   366,   366,
     366,   366,   370,   542,   366,   370,    15,   366,    22,   365,
      22,   365,   542,   542,   542,   369,   548,   541,   632,   364,
     542,   544,   545,   504,    15,   384,   436,   437,   368,   556,
      30,   222,   559,   378,   436,   594,   378,   378,   380,   378,
     368,   414,   368,   368,   378,   378,   368,   217,   236,   273,
     341,   369,   615,   455,   364,   364,   364,   364,   471,   471,
     542,   366,     7,    28,   521,   369,   542,   547,   542,   538,
     364,   183,   368,    22,    22,    32,   370,   364,   145,   556,
     555,    19,   387,   223,   560,   364,   595,   368,   597,   585,
     578,   585,   581,   140,   141,   295,   440,   378,   274,   298,
     348,   349,   350,   351,   614,   364,   455,   455,   455,   455,
       3,     3,   366,   365,   366,     7,   366,   364,   366,   364,
     632,   368,   514,   548,   531,   542,   542,    96,   151,   152,
     206,   211,   545,    15,   109,   214,   215,   218,   219,   369,
     554,   381,   220,   561,   593,   596,   369,   383,   586,   587,
     148,   290,   313,   369,   579,   369,   142,   292,   293,   294,
     296,   307,   369,   451,   582,   378,   378,   378,   217,   380,
     518,   521,   366,   512,   184,     6,    15,    16,    17,   365,
     369,   515,   517,   520,   523,   525,   527,   364,   364,   365,
     365,   365,   365,   364,   364,   380,   216,   217,   217,   379,
     378,   364,   380,    65,   142,   156,   213,   216,   217,   273,
     276,   280,   288,   290,   292,   293,   294,   295,   296,   297,
     303,   307,   308,   311,   323,   331,   369,   451,   584,   313,
     320,   588,   380,   378,   380,   364,   378,   378,   378,   238,
     117,   378,    97,   306,   309,   364,   315,   370,   366,   364,
     369,   514,   512,   542,     7,   367,   370,   542,   542,   542,
     542,   218,   218,   218,   280,   378,   368,   380,   316,   295,
     333,   440,   274,   380,   335,   380,   378,   378,   378,   238,
     378,   117,   378,   298,   299,   300,   301,   302,   303,   304,
     305,   332,    97,   306,   309,   300,   378,   324,   298,   364,
     378,   364,   378,   378,   518,   366,   365,   517,   512,   525,
     366,   366,   366,   366,   379,   379,   379,   380,   589,   317,
     318,   378,   378,   378,   217,   380,   336,   378,   378,   380,
     380,   378,   380,   366,   542,   364,   364,   364,   364,   369,
     381,   591,   315,   380,   310,   590,   364
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   374,   375,   375,   376,   376,   377,   378,   378,   378,
     379,   379,   379,   380,   380,   380,   380,   380,   380,   381,
     381,   382,   382,   383,   384,   384,   385,   385,   386,   387,
     387,   388,   388,   389,   390,   390,   391,   391,   391,   392,
     392,   393,   393,   394,   394,   394,   394,   394,   394,   394,
     394,   394,   395,   395,   396,   396,   396,   396,   397,   397,
     397,   397,   397,   397,   398,   399,   399,   399,   399,   400,
     401,   402,   403,   404,   405,   406,   406,   407,   407,   407,
     408,   409,   409,   409,   409,   409,   410,   411,   411,   412,
     413,   413,   414,   414,   414,   415,   416,   416,   417,   417,
     417,   417,   418,   419,   419,   420,   421,   422,   422,   423,
     423,   424,   424,   425,   425,   425,   425,   426,   426,   426,
     426,   426,   426,   426,   426,   426,   426,   426,   426,   426,
     426,   427,   427,   427,   427,   428,   428,   428,   428,   428,
     429,   429,   430,   431,   431,   432,   433,   433,   433,   434,
     434,   435,   436,   436,   437,   438,   439,   440,   440,   441,
     442,   442,   442,   443,   444,   445,   445,   445,   446,   446,
     447,   447,   447,   447,   447,   447,   448,   448,   448,   449,
     449,   450,   450,   451,   451,   452,   452,   453,   453,   454,
     455,   455,   455,   455,   455,   455,   456,   457,   458,   459,
     460,   460,   461,   462,   463,   464,   464,   464,   464,   464,
     464,   464,   464,   464,   464,   464,   464,   464,   465,   465,
     465,   466,   467,   467,   467,   467,   468,   468,   468,   469,
     470,   470,   470,   470,   470,   470,   470,   470,   471,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   485,   485,   486,   486,   487,   488,
     489,   490,   491,   492,   493,   494,   495,   496,   496,   496,
     497,   497,   497,   499,   498,   500,   501,   501,   501,   501,
     501,   501,   501,   501,   501,   501,   501,   501,   501,   502,
     503,   503,   504,   504,   505,   506,   506,   507,   508,   508,
     509,   511,   510,   512,   512,   513,   513,   514,   514,   515,
     516,   516,   516,   516,   516,   516,   517,   517,   517,   517,
     517,   518,   519,   519,   519,   520,   520,   521,   522,   522,
     522,   522,   523,   523,   523,   524,   524,   524,   524,   525,
     525,   525,   525,   526,   526,   527,   527,   528,   529,   529,
     529,   529,   530,   530,   531,   531,   531,   532,   532,   533,
     533,   534,   534,   534,   534,   534,   535,   535,   535,   536,
     536,   536,   536,   536,   536,   536,   536,   536,   536,   536,
     537,   537,   538,   539,   540,   541,   541,   541,   541,   541,
     541,   541,   541,   541,   541,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   542,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   542,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   542,   542,   542,   542,   542,   542,
     542,   542,   543,   543,   543,   543,   543,   543,   544,   545,
     545,   545,   546,   546,   547,   547,   548,   548,   548,   548,
     548,   548,   548,   548,   548,   548,   548,   548,   548,   548,
     548,   548,   549,   550,   550,   550,   550,   551,   551,   552,
     553,   554,   554,   554,   554,   554,   554,   555,   555,   556,
     556,   557,   558,   559,   559,   559,   560,   560,   561,   561,
     562,   563,   564,   565,   565,   565,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   566,   567,   568,   568,   569,   569,   569,
     569,   569,   569,   569,   569,   569,   570,   571,   572,   572,
     573,   573,   573,   573,   573,   573,   573,   573,   573,   574,
     573,   575,   573,   573,   573,   573,   576,   576,   577,   578,
     578,   579,   579,   579,   580,   580,   581,   581,   582,   582,
     582,   582,   582,   582,   582,   582,   582,   582,   582,   583,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   584,
     584,   584,   584,   584,   584,   584,   584,   584,   584,   585,
     585,   586,   587,   588,   588,   588,   589,   589,   590,   590,
     591,   592,   593,   593,   595,   594,   596,   596,   597,   597,
     598,   599,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   608,   608,   608,   608,   608,   608,   608,   608,
     609,   610,   610,   610,   610,   610,   611,   612,   612,   612,
     612,   612,   612,   612,   612,   612,   612,   612,   612,   612,
     613,   613,   613,   614,   614,   614,   614,   614,   615,   615,
     615,   615,   615,   615,   615,   616,   616,   617,   617,   618,
     619,   620,   621,   621,   621,   621,   621,   622,   623,   623,
     624,   624,   625,   625,   625,   625,   625,   625,   625,   625,
     625,   626,   627,   627,   627,   627,   627,   627,   627,   627,
     627,   627,   627,   627,   627,   627,   627,   627,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   628,   628,   628,   628,   628,
     628,   628,   628,   628,   628,   629,   629,   629,   629,   629,
     629,   629,   629,   629,   630,   630,   630,   630,   631,   631,
     631,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     0,     4,     2,     0,     1,     2,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     3,     1,     1,     1,     1,     2,     4,
       3,     3,     3,     3,     3,     3,     4,     3,     3,     4,
       5,     3,     3,     4,     2,     0,     1,     0,     1,     2,
       2,     2,     3,     2,     3,     3,     2,     3,     3,     3,
       4,     5,     1,     1,     1,     4,     0,     2,     2,     2,
       1,     1,     5,     0,     1,     3,     3,     0,     8,     1,
       4,     1,     1,     0,     1,     2,     3,     0,     2,     2,
       2,     2,     2,     2,     3,     3,     3,     4,     2,     3,
       2,     2,     1,     1,     1,     0,     2,     2,     2,     2,
       2,     1,     1,     3,     3,     0,     1,     1,     2,     0,
       1,     3,     1,     3,     1,     0,     2,     2,     2,     2,
       3,     3,     3,     0,     3,     1,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     1,
       3,     1,     1,     4,     1,     0,     3,     4,     1,     2,
       0,     5,     5,     5,     5,     4,     3,     3,     4,     5,
       1,     0,     3,     4,     4,     0,     2,     3,     3,     3,
       2,     2,     2,     2,     3,     3,     2,     2,     1,     1,
       1,     4,     0,     3,     3,     3,     0,     1,     1,     4,
       0,     2,     2,     2,     2,     2,     2,     2,     0,     2,
       9,     9,     4,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     1,     1,     3,     0,     1,     3,     3,
       3,     3,     4,     4,     4,     4,     2,     1,     1,     1,
       1,     0,     1,     0,     4,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       0,     3,     1,     3,     1,     1,     1,     2,     3,     2,
       4,     0,     5,     0,     1,     1,     2,     1,     3,     1,
       1,     1,     1,     1,     3,     1,     1,     3,     1,     1,
       1,     1,     1,     3,     1,     5,    11,     1,     1,     1,
       2,     1,     7,     9,     7,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     3,     1,     3,     3,     1,     2,
       2,     6,     1,     3,     0,     4,     3,     1,     3,     3,
       3,     2,     2,     2,     2,     0,     2,     2,     0,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       5,     7,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       4,     1,     1,     1,     1,     2,     2,     3,     3,     6,
       3,     3,     3,     3,     5,     6,     6,     6,     6,     4,
       8,     4,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     3,     1,     3,     0,     1,     4,     6,     4,     3,
       5,     5,     4,     6,     3,     2,     5,     5,     8,     8,
       8,     8,     2,     1,     2,     2,     2,     0,     3,     5,
       0,     2,     4,     4,     4,     2,     2,     0,     3,     0,
       3,     3,     2,     0,     2,     2,     0,     2,     0,     2,
       4,     5,     2,     0,     3,     3,     3,     3,     5,     6,
       4,     6,     4,     6,     4,     4,     5,     6,     3,     3,
       4,     5,     5,     5,     5,     5,     4,     4,     5,     5,
       5,     5,     5,     5,     5,     5,     6,     6,     6,     5,
       6,     8,     6,     6,     5,     4,     5,     4,     5,     4,
       5,     4,     5,     5,     5,     5,     6,     5,     5,     6,
       5,     5,     5,     4,     2,     3,     3,     1,     2,     3,
       2,     4,     3,     2,     3,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     4,     2,     2,     2,     3,     3,
       3,     2,     3,     3,     3,     4,     2,     2,     1,     0,
       2,     3,     1,     0,     1,     2,     0,     2,     0,     1,
       3,     0,     0,     2,     0,     3,     0,     3,     0,     3,
       3,     1,     0,     4,     6,     6,     6,     7,     6,     7,
       5,     0,     2,     3,     2,     3,     3,     2,     3,     2,
       2,     3,     3,     5,     4,     4,     2,     3,     3,     4,
       4,     4,     5,     5,     4,     3,     4,     4,     4,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       2,     2,     3,     3,     4,     0,     3,     0,     3,     0,
       3,     2,     3,     3,     5,     5,     3,     2,     3,     3,
       1,     2,     4,     3,     3,     3,     2,     2,     2,     2,
       2,     4,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     2,
       2,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 713 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3648 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 714 "cf-parse.y" /* yacc.c:1646  */
    { return 0; }
#line 3654 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 727 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[-1].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[-3].s), SYM_CONSTANT | val->type, val);
   }
#line 3665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 737 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[-1].x)); }
#line 3671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 738 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[0].s)).i; }
#line 3679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 745 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000000; }
#line 3685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1000; }
#line 3691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 747 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (u32) (yyvsp[-1].i) * 1; }
#line 3697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 755 "cf-parse.y" /* yacc.c:1646  */
    {(yyval.i) = !!(yyvsp[0].i); }
#line 3703 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 756 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3709 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 757 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3715 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 758 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3721 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 759 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 3727 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 760 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 3733 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 767 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[0].s)).px.ip;
   }
#line 3742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 3748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 775 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 3754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 779 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!ip_is_prefix((yyvsp[-1].a), (yyvsp[0].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[-1].a); (yyval.px).len = (yyvsp[0].i);
   }
#line 3763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 787 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.px).addr = (yyvsp[0].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
#line 3769 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 791 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[0].i));
     (yyval.i) = (yyvsp[0].i);
   }
#line 3778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 795 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.i) = ipa_masklen((yyvsp[0].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[0].a));
   }
#line 3787 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 802 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.time) = tm_parse_datetime((yyvsp[0].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
#line 3797 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 811 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != (SYM_CONSTANT | T_STRING)) cf_error("String expected");
     (yyval.t) = SYM_VAL((yyvsp[0].s)).s;
   }
#line 3806 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 818 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 819 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 3818 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 825 "cf-parse.y" /* yacc.c:1646  */
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[-2].g);
    c->mask = (yyvsp[-1].i);
    add_tail(&new_config->logfiles, &c->n);
  }
#line 3829 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 834 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = (yyvsp[0].t); }
#line 3835 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 835 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = bird_name; }
#line 3841 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 839 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[0].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[0].t));
     (yyval.g) = f;
   }
#line 3851 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 844 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[0].t); }
#line 3857 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 845 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = stderr; }
#line 3863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 849 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 3869 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 850 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 3875 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 854 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1 << (yyvsp[0].i); }
#line 3881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (1 << (yyvsp[0].i)); }
#line 3887 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 859 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_DEBUG[0]; }
#line 3893 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 860 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_TRACE[0]; }
#line 3899 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 861 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_INFO[0]; }
#line 3905 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 862 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_REMOTE[0]; }
#line 3911 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_WARN[0]; }
#line 3917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 864 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_ERR[0]; }
#line 3923 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 865 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_AUTH[0]; }
#line 3929 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 866 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_FATAL[0]; }
#line 3935 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 867 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = L_BUG[0]; }
#line 3941 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 873 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_mrtdump = (yyvsp[-1].i); }
#line 3947 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 874 "cf-parse.y" /* yacc.c:1646  */
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[-1].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[-1].t));
     new_config->mrtdump_file = fileno(f);
   }
#line 3957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 884 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_route; }
#line 3963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 885 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_proto; }
#line 3969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 886 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_base; }
#line 3975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 887 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.tf) = &new_config->tf_log; }
#line 3981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 890 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-1].tf) = (struct timeformat){(yyvsp[0].t), NULL, 0}; }
#line 3987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 891 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-3].tf) = (struct timeformat){(yyvsp[-2].t), (yyvsp[0].t), (yyvsp[-1].i)}; }
#line 3993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 892 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
#line 3999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 893 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%F %T", NULL, 0}; }
#line 4005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 894 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){NULL, NULL, 0}; }
#line 4011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 895 "cf-parse.y" /* yacc.c:1646  */
    { *(yyvsp[-2].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
#line 4017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 905 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_debug = (yyvsp[0].i); }
#line 4023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 906 "cf-parse.y" /* yacc.c:1646  */
    { new_config->latency_limit = (yyvsp[0].i32); }
#line 4029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 907 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_warning = (yyvsp[0].i32); }
#line 4035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 908 "cf-parse.y" /* yacc.c:1646  */
    { new_config->watchdog_timeout = ((yyvsp[0].i32) + 999999) TO_S; }
#line 4041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 917 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_HARD, (yyvsp[-1].i)); }
#line 4047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 920 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig((yyvsp[-2].t), RECONFIG_SOFT, (yyvsp[-1].i)); }
#line 4053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 927 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_confirm(); }
#line 4059 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 930 "cf-parse.y" /* yacc.c:1646  */
    { cmd_reconfig_undo(); }
#line 4065 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 933 "cf-parse.y" /* yacc.c:1646  */
    { cmd_check_config((yyvsp[-1].t)); }
#line 4071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 936 "cf-parse.y" /* yacc.c:1646  */
    { cmd_shutdown(); }
#line 4077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 4083 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4089 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 945 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
#line 4095 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 4101 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 954 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = krt_init_config((yyvsp[-1].i)); }
#line 4107 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 959 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->persist = (yyvsp[0].i); }
#line 4113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 960 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[0].i);
   }
#line 4122 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 964 "cf-parse.y" /* yacc.c:1646  */
    {
      THIS_KRT->learn = (yyvsp[0].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[0].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
#line 4134 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 971 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->devroutes = (yyvsp[0].i); }
#line 4140 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 972 "cf-parse.y" /* yacc.c:1646  */
    { THIS_KRT->graceful_restart = (yyvsp[0].i); }
#line 4146 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 978 "cf-parse.y" /* yacc.c:1646  */
    { this_proto = kif_init_config((yyvsp[-1].i)); }
#line 4152 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 983 "cf-parse.y" /* yacc.c:1646  */
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[0].i);
   }
#line 4161 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 987 "cf-parse.y" /* yacc.c:1646  */
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[-1].t);
     kpi->prefix = (yyvsp[0].px).addr;
     kpi->pxlen = (yyvsp[0].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
#line 4173 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1001 "cf-parse.y" /* yacc.c:1646  */
    {
	if ((yyvsp[0].i) <= 0 || (yyvsp[0].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[0].i);
   }
#line 4183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1015 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id = (yyvsp[-1].i32); }
#line 4189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1016 "cf-parse.y" /* yacc.c:1646  */
    { new_config->router_id_from = this_ipatt; }
#line 4195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1020 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = (yyvsp[0].i); }
#line 4201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1022 "cf-parse.y" /* yacc.c:1646  */
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[0].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
#line 4213 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1041 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_addr = (yyvsp[0].a); }
#line 4219 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1042 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_port = (yyvsp[0].i); }
#line 4225 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1043 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 0; }
#line 4231 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1044 "cf-parse.y" /* yacc.c:1646  */
    { new_config->listen_bgp_flags = 1; }
#line 4237 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1049 "cf-parse.y" /* yacc.c:1646  */
    { new_config->gr_wait = (yyvsp[-1].i); }
#line 4243 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4249 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1056 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 4255 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1060 "cf-parse.y" /* yacc.c:1646  */
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[-1].s));
   cf->sorted = (yyvsp[0].i);
   }
#line 4265 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1068 "cf-parse.y" /* yacc.c:1646  */
    {
  this_roa_table = roa_new_table_config((yyvsp[0].s));
}
#line 4273 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1074 "cf-parse.y" /* yacc.c:1646  */
    {
     roa_add_item_config(this_roa_table, (yyvsp[-5].px).addr, (yyvsp[-5].px).len, (yyvsp[-3].i), (yyvsp[-1].i));
   }
#line 4281 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1088 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_PROTO; }
#line 4287 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1089 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = SYM_TEMPLATE; }
#line 4293 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1093 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
#line 4304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1099 "cf-parse.y" /* yacc.c:1646  */
    {
     cf_define_symbol((yyvsp[0].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[0].s)->name;
   }
#line 4313 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1103 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     this_proto->name = s->name;
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");
     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4324 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1109 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].s)->class != SYM_TEMPLATE) && ((yyvsp[0].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[-2].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[-2].s)->name;

     proto_copy_config(this_proto, (yyvsp[0].s)->def);
   }
#line 4337 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1121 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 0 || (yyvsp[0].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[0].i);
   }
#line 4346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1125 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->disabled = (yyvsp[0].i); }
#line 4352 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1126 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->debug = (yyvsp[0].i); }
#line 4358 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1127 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->mrtdump = (yyvsp[0].i); }
#line 4364 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1128 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_filter = (yyvsp[0].f); }
#line 4370 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1129 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_filter = (yyvsp[0].f); }
#line 4376 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1130 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->rx_limit = (yyvsp[0].g); }
#line 4382 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1131 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_limit = (yyvsp[0].g); }
#line 4388 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1132 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->out_limit = (yyvsp[0].g); }
#line 4394 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1133 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->in_keep_filtered = (yyvsp[0].i); }
#line 4400 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1134 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->table = (yyvsp[0].r); }
#line 4406 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1135 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->router_id = (yyvsp[0].i32); }
#line 4412 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1136 "cf-parse.y" /* yacc.c:1646  */
    { this_proto->dsc = (yyvsp[0].t); }
#line 4418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1140 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = (yyvsp[0].f); }
#line 4424 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1142 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_ACCEPT; }
#line 4430 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1143 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.f) = FILTER_REJECT; }
#line 4436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1147 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4442 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1148 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_WARN; }
#line 4448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1149 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_BLOCK; }
#line 4454 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1150 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_RESTART; }
#line 4460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1151 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = PLA_DISABLE; }
#line 4466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1155 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[-1].i);
     l->action = (yyvsp[0].i);
     (yyval.g) = l;
   }
#line 4477 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1161 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.g) = NULL; }
#line 4483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1165 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[0].s)->def;
   }
#line 4492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1173 "cf-parse.y" /* yacc.c:1646  */
    { new_config->proto_default_debug = (yyvsp[0].i); }
#line 4498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1174 "cf-parse.y" /* yacc.c:1646  */
    { new_config->cli_debug = (yyvsp[0].i); }
#line 4504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1182 "cf-parse.y" /* yacc.c:1646  */
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
#line 4514 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1190 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[0].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
#line 4520 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1191 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4526 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1192 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->pattern = (yyvsp[-1].t); this_ipn->prefix = (yyvsp[0].px).addr; this_ipn->pxlen = (yyvsp[0].px).len; }
#line 4532 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 1196 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 1; }
#line 4538 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 1197 "cf-parse.y" /* yacc.c:1646  */
    { this_ipn->positive = 0; }
#line 4544 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1211 "cf-parse.y" /* yacc.c:1646  */
    { iface_patt_check(); }
#line 4550 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1213 "cf-parse.y" /* yacc.c:1646  */
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
#line 4560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i) & 0xfc;        if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 255)) cf_error("TX class must be in range 0-255"); }
#line 4566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1226 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ((yyvsp[0].i) & 0x3f) << 2; if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
#line 4572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1232 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_device, (yyvsp[-1].i));
     init_list(&DIRECT_CFG->iface_list);
   }
#line 4581 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1245 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
#line 4591 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1259 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4597 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 1260 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4603 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 1261 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4609 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1266 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4615 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1270 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_STATES; }
#line 4621 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1271 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_ROUTES; }
#line 4627 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 1272 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_FILTERS; }
#line 4633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1273 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_IFACES; }
#line 4639 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 1274 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_EVENTS; }
#line 4645 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 1275 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = D_PACKETS; }
#line 4651 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 1281 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 4657 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1282 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 4663 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1283 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 4669 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1288 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-2].i) | (yyvsp[0].i); }
#line 4675 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1292 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_STATES; }
#line 4681 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1293 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = MD_MESSAGES; }
#line 4687 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1314 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[0].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
#line 4707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1332 "cf-parse.y" /* yacc.c:1646  */
    { }
#line 4713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1333 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->genfrom = (yyvsp[-2].time); }
#line 4719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1334 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->gento = (yyvsp[-2].time); }
#line 4725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1335 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accfrom = (yyvsp[-2].time); }
#line 4731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1336 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->accto = (yyvsp[-2].time); }
#line 4737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1337 "cf-parse.y" /* yacc.c:1646  */
    { this_p_item->id = (yyvsp[-2].i); if ((yyvsp[-2].i) <= 0) cf_error("Password ID has to be greated than zero."); }
#line 4743 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1346 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_status(); }
#line 4749 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1349 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_memory(); }
#line 4755 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1352 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 0); }
#line 4761 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1355 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_show, 0, 1); }
#line 4767 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1359 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 4773 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1363 "cf-parse.y" /* yacc.c:1646  */
    { if_show(); }
#line 4779 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1366 "cf-parse.y" /* yacc.c:1646  */
    { if_show_summary(); }
#line 4785 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1370 "cf-parse.y" /* yacc.c:1646  */
    { rt_show((yyvsp[-1].ra)); }
#line 4791 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1373 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
#line 4801 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1378 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
   }
#line 4812 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1384 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[0].px).addr;
     (yyval.ra)->pxlen = (yyvsp[0].px).len;
     (yyval.ra)->show_for = 1;
   }
#line 4824 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1391 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyvsp[0].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[0].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[0].s)->def)->table;
   }
#line 4834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1396 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4844 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1401 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[0].f);
   }
#line 4854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1406 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->verbose = 1;
   }
#line 4863 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1410 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->primary_only = 1;
   }
#line 4872 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1414 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->filtered = 1;
   }
#line 4881 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1418 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->export_mode = (yyvsp[-1].i);
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4895 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1427 "cf-parse.y" /* yacc.c:1646  */
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[0].s)->def;
     (yyval.ra) = (yyvsp[-2].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[0].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[0].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
#line 4908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1435 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 1;
   }
#line 4917 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1439 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ra) = (yyvsp[-1].ra);
     (yyval.ra)->stats = 2;
   }
#line 4926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1446 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_PREEXPORT; }
#line 4932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1447 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_EXPORT; }
#line 4938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1448 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = RSEM_NOEXPORT; }
#line 4944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1454 "cf-parse.y" /* yacc.c:1646  */
    { roa_show((yyvsp[-1].ro)); }
#line 4950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1457 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
#line 4962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1464 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[0].px).addr;
     (yyval.ro)->pxlen = (yyvsp[0].px).len;
     (yyval.ro)->mode = (yyvsp[-1].i);
   }
#line 4974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1471 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     (yyval.ro)->asn = (yyvsp[0].i);
   }
#line 4983 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1475 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ro) = (yyvsp[-2].ro);
     if ((yyvsp[0].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 4993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1483 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_PX; }
#line 4999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1484 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_IN; }
#line 5005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1485 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ROA_SHOW_FOR; }
#line 5011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1491 "cf-parse.y" /* yacc.c:1646  */
    { cmd_show_symbols((yyvsp[-1].sd)); }
#line 5017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1494 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
#line 5025 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1497 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TABLE; }
#line 5031 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1498 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FUNCTION; }
#line 5037 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1499 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_FILTER; }
#line 5043 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1500 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_PROTO; }
#line 5049 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1501 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_TEMPLATE; }
#line 5055 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1502 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->type = SYM_ROA; }
#line 5061 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1503 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.sd) = (yyvsp[-1].sd); (yyval.sd)->sym = (yyvsp[0].s); }
#line 5067 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1508 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
#line 5077 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1513 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[0].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[0].s)->def)->table;
   }
#line 5087 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1522 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5096 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1529 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[-1].rot), (yyvsp[-6].px).addr, (yyvsp[-6].px).len, (yyvsp[-4].i), (yyvsp[-2].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5105 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1536 "cf-parse.y" /* yacc.c:1646  */
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[-1].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
#line 5114 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1544 "cf-parse.y" /* yacc.c:1646  */
    { rdump(&root_pool); cli_msg(0, ""); }
#line 5120 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1546 "cf-parse.y" /* yacc.c:1646  */
    { sk_dump_all(); cli_msg(0, ""); }
#line 5126 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1548 "cf-parse.y" /* yacc.c:1646  */
    { io_log_dump(); cli_msg(0, ""); }
#line 5132 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1550 "cf-parse.y" /* yacc.c:1646  */
    { if_dump_all(); cli_msg(0, ""); }
#line 5138 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1552 "cf-parse.y" /* yacc.c:1646  */
    { neigh_dump_all(); cli_msg(0, ""); }
#line 5144 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1554 "cf-parse.y" /* yacc.c:1646  */
    { rta_dump_all(); cli_msg(0, ""); }
#line 5150 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1556 "cf-parse.y" /* yacc.c:1646  */
    { rt_dump_all(); cli_msg(0, ""); }
#line 5156 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1558 "cf-parse.y" /* yacc.c:1646  */
    { protos_dump_all(); cli_msg(0, ""); }
#line 5162 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1561 "cf-parse.y" /* yacc.c:1646  */
    { cmd_eval((yyvsp[-1].x)); }
#line 5168 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1564 "cf-parse.y" /* yacc.c:1646  */
    {
  cli_set_log_echo(this_cli, (yyvsp[-2].i), (yyvsp[-1].i));
  cli_msg(0, "");
}
#line 5177 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1570 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = ~0; }
#line 5183 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1571 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 5189 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1572 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[-1].i); }
#line 5195 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1576 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 4096; }
#line 5201 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1577 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].i) < 256 || (yyvsp[0].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[0].i);
   }
#line 5210 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1584 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_disable, 1, 0); }
#line 5216 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1586 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_enable, 1, 0); }
#line 5222 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1588 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_restart, 1, 0); }
#line 5228 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1590 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD); }
#line 5234 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1592 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
#line 5240 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1594 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-1].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
#line 5246 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1598 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_debug, 1, (yyvsp[-1].i)); }
#line 5252 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 265:
#line 1602 "cf-parse.y" /* yacc.c:1646  */
    { proto_apply_cmd((yyvsp[-2].ps), proto_cmd_mrtdump, 1, (yyvsp[-1].i)); }
#line 5258 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 266:
#line 1605 "cf-parse.y" /* yacc.c:1646  */
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
#line 5264 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 267:
#line 1608 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5270 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1609 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5276 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1610 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5282 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1614 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].s); (yyval.ps).patt = 0; }
#line 5288 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1615 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
#line 5294 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1616 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ps).ptr = (yyvsp[0].t); (yyval.ps).patt = 1; }
#line 5300 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 273:
#line 1624 "cf-parse.y" /* yacc.c:1646  */
    { (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[0].s) ); }
#line 5306 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 274:
#line 1625 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-2].s)->def = (yyvsp[0].f);
     (yyvsp[0].f)->name = (yyvsp[-2].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[-2].s)->name );
     cf_pop_scope();
   }
#line 5317 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1634 "cf-parse.y" /* yacc.c:1646  */
    { f_eval_int((yyvsp[0].x)); }
#line 5323 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 276:
#line 1638 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_INT; }
#line 5329 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 277:
#line 1639 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_BOOL; }
#line 5335 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1640 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_IP; }
#line 5341 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 279:
#line 1641 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PREFIX; }
#line 5347 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 280:
#line 1642 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PAIR; }
#line 5353 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 281:
#line 1643 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_QUAD; }
#line 5359 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1644 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_EC; }
#line 5365 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1645 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_STRING; }
#line 5371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1646 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH_MASK; }
#line 5377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1647 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_PATH; }
#line 5383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1648 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_CLIST; }
#line 5389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 287:
#line 1649 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = T_ECLIST; }
#line 5395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 288:
#line 1650 "cf-parse.y" /* yacc.c:1646  */
    { 
	switch ((yyvsp[-1].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
#line 5418 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 289:
#line 1671 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_VARIABLE | (yyvsp[-1].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[0].s)->name, (yyvsp[-1].i) );
     (yyvsp[0].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[0].s);
   }
#line 5431 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 290:
#line 1682 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = NULL; }
#line 5437 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 291:
#line 1683 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5446 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 292:
#line 1690 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s) = (yyvsp[0].s); }
#line 5452 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 293:
#line 1691 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.s) = (yyvsp[-2].s);
     (yyval.s)->aux2 = (yyvsp[0].s);
   }
#line 5461 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 294:
#line 1698 "cf-parse.y" /* yacc.c:1646  */
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[0].x);
     (yyval.f) = f;
   }
#line 5472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 1707 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[0].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[0].s)->def;
   }
#line 5481 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 297:
#line 1715 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[0].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
#line 5507 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 1739 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[-1].s); }
#line 5513 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 1740 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.s)=NULL; }
#line 5519 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 1744 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-3].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[-3].s);
       (yyval.x)->next = (yyvsp[-1].x);
     } else
       (yyval.x) = (yyvsp[-1].x);
   }
#line 5534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 1757 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "Beginning of function %s\n", (yyvsp[0].s)->name );
     (yyvsp[0].s) = cf_define_symbol((yyvsp[0].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[0].s));
   }
#line 5543 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 1760 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyvsp[-3].s)->def = (yyvsp[0].x);
     (yyvsp[-3].s)->aux2 = (yyvsp[-1].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[-3].s)->name); 
     cf_pop_scope();
   }
#line 5554 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 1773 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 5560 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 1774 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x)->next; (yyvsp[0].x)->next = NULL; }
#line 5566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 1777 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[0].x); }
#line 5572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 1778 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyvsp[0].x)->next = (yyvsp[-1].x)->next ; (yyvsp[-1].x)->next = (yyvsp[0].x); }
#line 5578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 1782 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[0].x);
   }
#line 5586 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 1785 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x)=(yyvsp[-1].x);
   }
#line 5594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 1794 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[0].a); }
#line 5600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 1807 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 1808 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 1809 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 1810 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 1811 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.v) = f_eval((yyvsp[-1].x), cfg_mem);
     if (!f_valid_set_type((yyval.v).type)) cf_error("Set-incompatible type");
   }
#line 5633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 1815 "cf-parse.y" /* yacc.c:1646  */
    {
     if (!cf_symbol_is_constant((yyvsp[0].s))) cf_error("%s: constant expected", (yyvsp[0].s)->name);
     if (!f_valid_set_type(SYM_TYPE((yyvsp[0].s)))) cf_error("%s: set-incompatible type", (yyvsp[0].s)->name);
     (yyval.v) = *(struct f_val *)((yyvsp[0].s)->def);
   }
#line 5643 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 1823 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[0].i); }
#line 5649 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 1824 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[-1].x)); }
#line 5655 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 1825 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[0].i32); }
#line 5661 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 1826 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5667 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 1827 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v).type = pair_a((yyvsp[0].i)); (yyval.v).val.i = pair_b((yyvsp[0].i)); }
#line 5673 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 321:
#line 1831 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = f_eval_int((yyvsp[0].x)); check_u16((yyval.i)); }
#line 5679 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 1834 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[0].i), (yyvsp[0].i)); }
#line 5685 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 1835 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = pair((yyvsp[-2].i), (yyvsp[0].i)); }
#line 5691 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 1836 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = 0xFFFF; }
#line 5697 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 325:
#line 1840 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[-3].i32)), pair_b((yyvsp[-3].i32)), pair_a((yyvsp[-1].i32)), pair_b((yyvsp[-1].i32)));
   }
#line 5705 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 1843 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[-9].i32)) != pair_b((yyvsp[-9].i32))) || (pair_a((yyvsp[-7].i32)) != pair_b((yyvsp[-7].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[-9].i32)), (yyvsp[-3].i), pair_b((yyvsp[-7].i32)), (yyvsp[-1].i)); 
   }
#line 5716 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 1852 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i32) = f_eval_int((yyvsp[0].x)); }
#line 5722 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 1855 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RT; }
#line 5728 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 1856 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_RO; }
#line 5734 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 1857 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 5740 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 331:
#line 1858 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = EC_GENERIC; }
#line 5746 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 1862 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), (yyvsp[-1].i32), (yyvsp[-1].i32)); }
#line 5752 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 1863 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_ec_item((yyvsp[-7].i), 0, (yyvsp[-5].i32), (yyvsp[-3].i32), (yyvsp[-1].i32)); }
#line 5758 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 1864 "cf-parse.y" /* yacc.c:1646  */
    {  (yyval.e) = f_new_ec_item((yyvsp[-5].i), 0, (yyvsp[-3].i32), 0, EC_ALL); }
#line 5764 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 1870 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5770 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 338:
#line 1871 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5776 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1877 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[0].v), (yyvsp[0].v)); }
#line 5782 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1878 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_new_item((yyvsp[-2].v), (yyvsp[0].v)); }
#line 5788 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1883 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5794 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1888 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = f_merge_items((yyvsp[-2].e), (yyvsp[0].e)); }
#line 5800 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1892 "cf-parse.y" /* yacc.c:1646  */
    {
     if (((yyvsp[0].i) < 0) || ((yyvsp[0].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[-2].a), (yyvsp[0].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[-2].a), (yyvsp[0].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[-2].a); (yyval.v).val.px.len = (yyvsp[0].i);
   }
#line 5809 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1899 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[0].v); }
#line 5815 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1900 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_PLUS; }
#line 5821 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 1901 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.v) = (yyvsp[-1].v); (yyval.v).val.px.len |= LEN_MINUS; }
#line 5827 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 1902 "cf-parse.y" /* yacc.c:1646  */
    { 
     if (! ((0 <= (yyvsp[-3].i)) && ((yyvsp[-3].i) <= (yyvsp[-1].i)) && ((yyvsp[-1].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[-3].i), (yyvsp[-1].i));
     (yyval.v) = (yyvsp[-5].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[-3].i) << 16) | ((yyvsp[-1].i) << 8);
   }
#line 5836 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 1909 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = f_new_trie(cfg_mem, sizeof(struct f_trie_node)); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5842 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 1910 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.trie) = (yyvsp[-2].trie); trie_add_fprefix((yyval.trie), &((yyvsp[0].v).val.px)); }
#line 5848 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 1913 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.e) = NULL; }
#line 5854 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 1914 "cf-parse.y" /* yacc.c:1646  */
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[-2].e); t; t = t->left)
       t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-3].e), (yyvsp[-2].e));
   }
#line 5866 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 356:
#line 1921 "cf-parse.y" /* yacc.c:1646  */
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[0].x);
     (yyval.e) = f_merge_items((yyvsp[-2].e), t);
 }
#line 5878 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1933 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 5884 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1934 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 5890 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 1938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5896 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 360:
#line 1939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = (yyvsp[-1].h); }
#line 5902 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 1943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5908 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 1944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5914 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 1945 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
#line 5920 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 1946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[-1].x); }
#line 5926 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5932 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1951 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[-1].i); }
#line 5938 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1952 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[0].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
#line 5944 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1953 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.h) = NULL; }
#line 5950 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1957 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[0].i); }
#line 5956 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1958 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
#line 5962 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1959 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
#line 5968 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1960 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[0].t); }
#line 5974 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1961 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5980 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1962 "cf-parse.y" /* yacc.c:1646  */
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[0].v); }
#line 5986 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1963 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[0].i32); }
#line 5992 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1964 "cf-parse.y" /* yacc.c:1646  */
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[-1].e)); DBG( "ook\n" ); }
#line 5998 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1965 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[-1].trie); }
#line 6004 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1966 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[0].i) >> 16; (yyval.x)->a2.i = (yyvsp[0].i) & 0xffff; }
#line 6010 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1967 "cf-parse.y" /* yacc.c:1646  */
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[0].h); (yyval.x)->a1.p = val; }
#line 6016 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 1971 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_dpair((yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6022 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 1972 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_ec((yyvsp[-5].i), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6028 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1986 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6053 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 2009 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[0].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[0].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[0].s)->def;
     (yyval.x)->a2.p = (yyvsp[0].s)->name;
   }
#line 6070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 385:
#line 2023 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
#line 6076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 2024 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
#line 6082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 2025 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
#line 6088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 2026 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
#line 6094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 2027 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
#line 6100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 2028 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
#line 6106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 2029 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
#line 6112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 2030 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
#line 6118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 2031 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
#line 6124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 2032 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
#line 6130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 395:
#line 2036 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 396:
#line 2037 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 2038 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 398:
#line 2039 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 2040 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 2041 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 2042 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 2043 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 403:
#line 2044 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 2045 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 405:
#line 2046 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 2047 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 407:
#line 2048 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = (yyvsp[-2].x); }
#line 6208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 2049 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->a2.p = (yyvsp[0].x); }
#line 6214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 2050 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[0].x); }
#line 6220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 2051 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[-1].x); }
#line 6226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 2053 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 2054 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 2055 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 2057 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
#line 6250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 2059 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = 'a'; }
#line 6256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 2061 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); (yyval.x)->code = P('e','a'); }
#line 6262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 417:
#line 2063 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[-2].x); (yyval.x)->aux = T_IP; }
#line 6268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 2064 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 2065 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[-5].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 2066 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 2067 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[-2].x); }
#line 6292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 2077 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
#line 6298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 2078 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
#line 6304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 2079 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
#line 6310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 2080 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); }
#line 6316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 2081 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'a'; }
#line 6322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 2082 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'd'; }
#line 6328 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 2083 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[-3].x); (yyval.x)->a2.p = (yyvsp[-1].x); (yyval.x)->aux = 'f'; }
#line 6334 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 2085 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-1].s), NULL, NULL); }
#line 6340 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 2086 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_roa_check((yyvsp[-5].s), (yyvsp[-3].x), (yyvsp[-1].x)); }
#line 6346 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 2091 "cf-parse.y" /* yacc.c:1646  */
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[-1].x);
     if ((yyvsp[-3].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[-3].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[-3].s)->def;
     sym = (yyvsp[-3].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[-3].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
#line 6371 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 432:
#line 2114 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_QUITBIRD; }
#line 6377 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 433:
#line 2115 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ACCEPT; }
#line 6383 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 2116 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_REJECT; }
#line 6389 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 2117 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_ERROR; }
#line 6395 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 436:
#line 2118 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NOP; }
#line 6401 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 437:
#line 2119 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = F_NONL; }
#line 6407 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 2123 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[0].x); (yyval.x)->a2.p = NULL; }
#line 6413 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 439:
#line 2126 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6419 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 2127 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6425 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 2128 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-2].x)) {
       (yyvsp[-2].x)->next = (yyvsp[0].x);
       (yyval.x) = (yyvsp[-2].x);
     } else (yyval.x) = (yyvsp[0].x);
   }
#line 6436 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 442:
#line 2136 "cf-parse.y" /* yacc.c:1646  */
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[0].x);
     (yyval.x)->next = NULL;
   }
#line 6448 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 2143 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[-2].x);
     (yyval.x)->next = (yyvsp[0].x);
   }
#line 6460 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 2152 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 6466 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 2153 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[0].x); }
#line 6472 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 2157 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[-2].x);
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6483 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 2163 "cf-parse.y" /* yacc.c:1646  */
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[-4].x);
     i->a2.p = (yyvsp[-2].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[0].x);
   }
#line 6498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 2173 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[-3].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[-3].s);
     (yyval.x)->a2.p = (yyvsp[-1].x);
   }
#line 6512 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 2182 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6523 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 2188 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6533 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 2193 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-3].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6545 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 2200 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[-1].x);
   }
#line 6555 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 2205 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.x) = (yyvsp[-2].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
#line 6566 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 2211 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[-1].x); (yyval.x)->a2.i = (yyvsp[-2].i); }
#line 6572 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 2212 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = (yyvsp[-1].x); }
#line 6578 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 2213 "cf-parse.y" /* yacc.c:1646  */
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[-3].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[-1].e) );
   }
#line 6589 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 2221 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_empty((yyvsp[-3].x)); }
#line 6595 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 2222 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6601 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 2223 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6607 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 2224 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6613 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 461:
#line 2225 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[-6].x), (yyvsp[-2].x) ); }
#line 6619 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 462:
#line 2232 "cf-parse.y" /* yacc.c:1646  */
    {
  this_proto = proto_config_new(&proto_bfd, (yyvsp[-1].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
#line 6633 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 470:
#line 2259 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
#line 6647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 471:
#line 2270 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 472:
#line 2271 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_rx_int = (yyvsp[0].i32); }
#line 6659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 473:
#line 2272 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->min_tx_int = (yyvsp[0].i32); }
#line 6665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 474:
#line 2273 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->idle_tx_int = (yyvsp[0].i32); }
#line 6671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 475:
#line 2274 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->multiplier = (yyvsp[0].i); }
#line 6677 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 476:
#line 2275 "cf-parse.y" /* yacc.c:1646  */
    { BFD_IFACE->passive = (yyvsp[0].i); }
#line 6683 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 2289 "cf-parse.y" /* yacc.c:1646  */
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
#line 6689 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 2292 "cf-parse.y" /* yacc.c:1646  */
    { BFD_CFG->multihop = BFD_IFACE; }
#line 6695 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 2296 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = NULL; }
#line 6701 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 2297 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].s)->name); }
#line 6707 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 2298 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.iface) = if_get_by_name((yyvsp[0].t)); }
#line 6713 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 2302 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = IPA_NONE; }
#line 6719 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 487:
#line 2303 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.a) = (yyvsp[0].a); }
#line 6725 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 2307 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 6731 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 2308 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = (yyvsp[0].i); }
#line 6737 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 2312 "cf-parse.y" /* yacc.c:1646  */
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[-3].a);
  BFD_NEIGHBOR->local = (yyvsp[-1].a);
  BFD_NEIGHBOR->iface = (yyvsp[-2].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[0].i);

  if ((yyvsp[0].i) && (yyvsp[-2].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[0].i) && ipa_zero((yyvsp[-1].a)))
    cf_error("Multihop neighbor requires specified local address");
}
#line 6757 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 2331 "cf-parse.y" /* yacc.c:1646  */
    { bfd_show_sessions(proto_get_named((yyvsp[-1].s), &proto_bfd)); }
#line 6763 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 2336 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_bgp, (yyvsp[-1].i));
     BGP_CFG->remote_port = BGP_PORT;
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->connect_delay_time = 5;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
#line 6790 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 2362 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_port = (yyvsp[0].i); if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>65535)) cf_error("Invalid port number");  }
#line 6796 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 2363 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->remote_as = (yyvsp[0].i); }
#line 6802 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 2369 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6808 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 499:
#line 2370 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-3].a); BGP_CFG->local_as = (yyvsp[-1].i); }
#line 6814 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 2372 "cf-parse.y" /* yacc.c:1646  */
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     BGP_CFG->remote_ip = (yyvsp[-3].a);
     if ((yyvsp[-2].iface)) BGP_CFG->iface = (yyvsp[-2].iface);
   }
#line 6825 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 502:
#line 2378 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->iface = if_get_by_name((yyvsp[-1].t)); }
#line 6831 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 503:
#line 2379 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_cluster_id = (yyvsp[-1].i32); }
#line 6837 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 504:
#line 2380 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rr_client = 1; }
#line 6843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 505:
#line 2381 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->rs_client = 1; }
#line 6849 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 506:
#line 2382 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->hold_time = (yyvsp[-1].i); }
#line 6855 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 2383 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->initial_hold_time = (yyvsp[-1].i); }
#line 6861 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 2384 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 0; }
#line 6867 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 509:
#line 2385 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = 64; }
#line 6873 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 510:
#line 2386 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->multihop = (yyvsp[-1].i); if (((yyvsp[-1].i)<1) || ((yyvsp[-1].i)>255)) cf_error("Multihop must be in range 1-255"); }
#line 6879 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 2387 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
#line 6885 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 2388 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
#line 6891 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 2389 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_SELF; }
#line 6897 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 2390 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_DROP; }
#line 6903 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 2391 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
#line 6909 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 2392 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_DIRECT; }
#line 6915 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 2393 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
#line 6921 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 2394 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->compare_path_lengths = (yyvsp[-1].i); }
#line 6927 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 2395 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->med_metric = (yyvsp[-1].i); }
#line 6933 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 2396 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_metric = (yyvsp[-1].i); }
#line 6939 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 2397 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->prefer_older = (yyvsp[-1].i); }
#line 6945 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 2398 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->deterministic_med = (yyvsp[-1].i); }
#line 6951 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 2399 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_med = (yyvsp[-1].i); }
#line 6957 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 2400 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->default_local_pref = (yyvsp[-1].i); }
#line 6963 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 2401 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->source_addr = (yyvsp[-1].a); }
#line 6969 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 2402 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); log(L_WARN "%s: Start delay time option is deprecated, use connect delay time", this_proto->name); }
#line 6975 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 2403 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_delay_time = (yyvsp[-1].i); }
#line 6981 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 2404 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->connect_retry_time = (yyvsp[-1].i); }
#line 6987 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 2405 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->keepalive_time = (yyvsp[-1].i); }
#line 6993 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 2406 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_amnesia_time = (yyvsp[-1].i); }
#line 6999 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 2407 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->error_delay_time_min = (yyvsp[-3].i); BGP_CFG->error_delay_time_max = (yyvsp[-1].i); }
#line 7005 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 2408 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->disable_after_error = (yyvsp[-1].i); }
#line 7011 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 2409 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_refresh = (yyvsp[-1].i); }
#line 7017 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 2410 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->enable_as4 = (yyvsp[-1].i); }
#line 7023 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 2411 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->capabilities = (yyvsp[-1].i); }
#line 7029 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 2412 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->advertise_ipv4 = (yyvsp[-1].i); }
#line 7035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 2413 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->password = (yyvsp[-1].t); }
#line 7041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 2414 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[-1].i);
     this_proto->in_limit->action = PLA_RESTART;
     log(L_WARN "%s: Route limit option is deprecated, use import limit", this_proto->name);
   }
#line 7052 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 539:
#line 2420 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->passive = (yyvsp[-1].i); }
#line 7058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 2421 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->interpret_communities = (yyvsp[-1].i); }
#line 7064 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 2422 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->secondary = (yyvsp[-1].i); }
#line 7070 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 542:
#line 2423 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_RX; }
#line 7076 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 2424 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = ADD_PATH_TX; }
#line 7082 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 2425 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->add_path = (yyvsp[-1].i) ? ADD_PATH_FULL : 0; }
#line 7088 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 2426 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = -1; }
#line 7094 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 546:
#line 2427 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->allow_local_as = (yyvsp[-1].i); }
#line 7100 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 547:
#line 2428 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = (yyvsp[-1].i); }
#line 7106 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 2429 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
#line 7112 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 2430 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->gr_time = (yyvsp[-1].i); }
#line 7118 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 2431 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->igp_table = (yyvsp[-1].r); }
#line 7124 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 2432 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->ttl_security = (yyvsp[-1].i); }
#line 7130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 2433 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->check_link = (yyvsp[-1].i); }
#line 7136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 2434 "cf-parse.y" /* yacc.c:1646  */
    { BGP_CFG->bfd = (yyvsp[-1].i); cf_check_bfd((yyvsp[-1].i)); }
#line 7142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 2445 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_ospf, (yyvsp[-1].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->tick = OSPF_DEFAULT_TICK;
     OSPF_CFG->ospf2 = OSPF_IS_V2;
  }
#line 7154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 2461 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->rfc1583 = (yyvsp[0].i); }
#line 7160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 2462 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->stub_router = (yyvsp[0].i); }
#line 7166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 2463 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[0].i) ? OSPF_DEFAULT_ECMP_LIMIT : 0; }
#line 7172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 2464 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->ecmp = (yyvsp[-2].i) ? (yyvsp[0].i) : 0; if ((yyvsp[0].i) < 0) cf_error("ECMP limit cannot be negative"); }
#line 7178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 2465 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->merge_external = (yyvsp[0].i); }
#line 7184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 2466 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->tick = (yyvsp[0].i); if((yyvsp[0].i)<=0) cf_error("Tick must be greater than zero"); }
#line 7190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 2467 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_CFG->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 2471 "cf-parse.y" /* yacc.c:1646  */
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[0].i32);
  this_area->default_cost = OSPF_DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = OSPF_DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
#line 7214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 2486 "cf-parse.y" /* yacc.c:1646  */
    { ospf_area_finish(); }
#line 7220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 2495 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = (yyvsp[0].i) ? 0 : OPT_E; /* We should remove the option */ }
#line 7226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 2496 "cf-parse.y" /* yacc.c:1646  */
    { this_area->type = OPT_N; }
#line 7232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 2497 "cf-parse.y" /* yacc.c:1646  */
    { this_area->summary = (yyvsp[0].i); }
#line 7238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 2498 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_nssa = (yyvsp[0].i); }
#line 7244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 2499 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 2500 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i) | LSA_EXT3_EBIT; ospf_check_defcost((yyvsp[0].i)); }
#line 7256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 2501 "cf-parse.y" /* yacc.c:1646  */
    { this_area->default_cost = (yyvsp[0].i); ospf_check_defcost((yyvsp[0].i)); }
#line 7262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 2502 "cf-parse.y" /* yacc.c:1646  */
    { this_area->translator = (yyvsp[0].i); }
#line 7268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 2503 "cf-parse.y" /* yacc.c:1646  */
    { this_area->transint = (yyvsp[0].i); }
#line 7274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 2504 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->net_list; }
#line 7280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 581:
#line 2505 "cf-parse.y" /* yacc.c:1646  */
    { this_nets = &this_area->enet_list; }
#line 7286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 2517 "cf-parse.y" /* yacc.c:1646  */
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[0].px);
     this_stubnet->cost = COST_D;
   }
#line 7297 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 2531 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->hidden = (yyvsp[0].i); }
#line 7303 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 2532 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->summary = (yyvsp[0].i); }
#line 7309 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 2533 "cf-parse.y" /* yacc.c:1646  */
    { this_stubnet->cost = (yyvsp[0].i); }
#line 7315 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 2537 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7321 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 2538 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7327 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 2547 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7333 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 2548 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7339 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 2549 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7345 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 2550 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7351 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 2551 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7357 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 2552 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7363 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 605:
#line 2553 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE;  }
#line 7369 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 2554 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7375 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 607:
#line 2555 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7381 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 2556 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7387 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 609:
#line 2560 "cf-parse.y" /* yacc.c:1646  */
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[0].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_VLINK;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  reset_passwords();
 }
#line 7408 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 2579 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->cost = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Cost must be in range 1-65535"); }
#line 7414 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 611:
#line 2580 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->helloint = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
#line 7420 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 2581 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->pollint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=0) cf_error("Poll int must be greater than zero"); }
#line 7426 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 2582 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rxmtint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Retransmit int must be greater than one"); }
#line 7432 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 614:
#line 2583 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->waitint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Wait interval must be greater than one"); }
#line 7438 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 2584 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadint = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead interval must be greater than one"); }
#line 7444 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 2585 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->deadc = (yyvsp[0].i) ; if ((yyvsp[0].i)<=1) cf_error("Dead count must be greater than one"); }
#line 7450 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 2586 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7456 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 2587 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
#line 7462 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 2588 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7468 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 2589 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
#line 7474 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 2590 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7480 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 2591 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTP ; }
#line 7486 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 2592 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7492 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 2593 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
#line 7498 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 2594 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->real_bcast = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("Real broadcast option requires OSPFv2"); }
#line 7504 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 2595 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ptp_netmask = (yyvsp[0].i); if (!ospf_cfg_is_v2()) cf_error("PtP netmask option requires OSPFv2"); }
#line 7510 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 2596 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->inftransdelay = (yyvsp[0].i) ; if (((yyvsp[0].i)<=0) || ((yyvsp[0].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
#line 7516 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 2597 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->priority = (yyvsp[0].i) ; if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Priority must be in range 0-255"); }
#line 7522 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 2598 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->strictnbma = (yyvsp[0].i) ; }
#line 7528 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 2599 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->stub = (yyvsp[0].i) ; }
#line 7534 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 2600 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->check_link = (yyvsp[0].i); }
#line 7540 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 2601 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ecmp_weight = (yyvsp[0].i) - 1; if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
#line 7546 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 2602 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->link_lsa_suppression = (yyvsp[0].i); if (!ospf_cfg_is_v3()) cf_error("Link LSA suppression option requires OSPFv3"); }
#line 7552 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 2604 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_NONE; }
#line 7558 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 2605 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE; ospf_check_auth(); }
#line 7564 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 2606 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT; ospf_check_auth(); }
#line 7570 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 2607 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = 0; }
#line 7576 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 2608 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
#line 7582 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 2609 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->rx_buffer = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
#line 7588 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 2610 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_tos = (yyvsp[0].i); }
#line 7594 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 2611 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_priority = (yyvsp[0].i); }
#line 7600 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 2612 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->tx_length = (yyvsp[0].i); if (((yyvsp[0].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[0].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
#line 7606 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 2613 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = (yyvsp[0].i); }
#line 7612 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 2614 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->ttl_security = 2; }
#line 7618 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 2615 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bfd = (yyvsp[0].i); cf_check_bfd((yyvsp[0].i)); }
#line 7624 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 2616 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->bsd_secondary = (yyvsp[0].i); }
#line 7630 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 2617 "cf-parse.y" /* yacc.c:1646  */
    { ospf_check_auth(); }
#line 7636 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 2628 "cf-parse.y" /* yacc.c:1646  */
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[0].px).addr;
   this_pref->px.len = (yyvsp[0].px).len;
 }
#line 7647 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 2638 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->hidden = 1; }
#line 7653 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 2639 "cf-parse.y" /* yacc.c:1646  */
    { this_pref->tag = (yyvsp[0].i); }
#line 7659 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 2648 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 0; }
#line 7665 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 2649 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i) = 1; }
#line 7671 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 2653 "cf-parse.y" /* yacc.c:1646  */
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[-2].a);
   this_nbma->eligible=(yyvsp[-1].i);
 }
#line 7682 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 2662 "cf-parse.y" /* yacc.c:1646  */
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  OSPF_PATT->instance_id = OSPF_CFG->instance_id;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
#line 7706 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 663:
#line 2685 "cf-parse.y" /* yacc.c:1646  */
    { OSPF_PATT->instance_id = (yyvsp[0].i); if (((yyvsp[0].i)<0) || ((yyvsp[0].i)>255)) cf_error("Instance ID must be in range 0-255"); }
#line 7712 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 664:
#line 2689 "cf-parse.y" /* yacc.c:1646  */
    { if (ospf_cfg_is_v3()) iface_patt_check(); }
#line 7718 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 670:
#line 2703 "cf-parse.y" /* yacc.c:1646  */
    { ospf_iface_finish(); }
#line 7724 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 672:
#line 2708 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.t) = NULL; }
#line 7730 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 673:
#line 2714 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh(proto_get_named((yyvsp[-1].s), &proto_ospf)); }
#line 7736 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 674:
#line 2717 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_neigh(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7742 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 675:
#line 2720 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_iface(proto_get_named((yyvsp[-2].s), &proto_ospf), (yyvsp[-1].t)); }
#line 7748 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 676:
#line 2725 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 1); }
#line 7754 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 677:
#line 2728 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 0, 0); }
#line 7760 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 678:
#line 2733 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 1); }
#line 7766 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 679:
#line 2736 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_state(proto_get_named((yyvsp[-2].s), &proto_ospf), 1, 0); }
#line 7772 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 680:
#line 2740 "cf-parse.y" /* yacc.c:1646  */
    { ospf_sh_lsadb((yyvsp[-1].ld)); }
#line 7778 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 681:
#line 2743 "cf-parse.y" /* yacc.c:1646  */
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
#line 7786 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 682:
#line 2746 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
#line 7792 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 683:
#line 2747 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[0].i32); }
#line 7798 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 684:
#line 2748 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
#line 7804 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 685:
#line 2749 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->type = (yyvsp[0].i); }
#line 7810 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 686:
#line 2750 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->lsid = (yyvsp[0].i32); }
#line 7816 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 687:
#line 2751 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
#line 7822 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 688:
#line 2752 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-2].ld); (yyval.ld)->router = (yyvsp[0].i32); }
#line 7828 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 689:
#line 2753 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.ld) = (yyvsp[-1].ld); (yyval.ld)->name = (yyvsp[0].s); }
#line 7834 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 690:
#line 2759 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_pipe, (yyvsp[-1].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
#line 7843 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 693:
#line 2768 "cf-parse.y" /* yacc.c:1646  */
    {
     if ((yyvsp[-1].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[-1].s)->def;
   }
#line 7853 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 694:
#line 2773 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_OPAQUE; }
#line 7859 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 695:
#line 2774 "cf-parse.y" /* yacc.c:1646  */
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
#line 7865 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 696:
#line 2780 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_rip, (yyvsp[-1].i));
     rip_init_config(RIP_CFG);
   }
#line 7874 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 699:
#line 2789 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->infinity = (yyvsp[-1].i); }
#line 7880 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 700:
#line 2790 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->port = (yyvsp[-1].i); }
#line 7886 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 701:
#line 2791 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->period = (yyvsp[-1].i); }
#line 7892 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 702:
#line 2792 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->garbage_time = (yyvsp[-1].i); }
#line 7898 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 703:
#line 2793 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->timeout_time = (yyvsp[-1].i); }
#line 7904 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 704:
#line 2794 "cf-parse.y" /* yacc.c:1646  */
    {RIP_CFG->authtype = (yyvsp[-1].i); }
#line 7910 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 706:
#line 2796 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_ALWAYS; }
#line 7916 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 707:
#line 2797 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEIGHBOR; }
#line 7922 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 708:
#line 2798 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->honor = HO_NEVER; }
#line 7928 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 710:
#line 2803 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_PLAINTEXT; }
#line 7934 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 711:
#line 2804 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_MD5; }
#line 7940 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 712:
#line 2805 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=AT_NONE; }
#line 7946 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 713:
#line 2810 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_BROADCAST; }
#line 7952 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 714:
#line 2811 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=0; }
#line 7958 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 715:
#line 2812 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_QUIET; }
#line 7964 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 716:
#line 2813 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_NOLISTEN; }
#line 7970 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 717:
#line 2814 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
#line 7976 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 719:
#line 2818 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->metric = (yyvsp[0].i); }
#line 7982 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 720:
#line 2819 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->mode |= (yyvsp[0].i); }
#line 7988 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 721:
#line 2820 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_tos = (yyvsp[0].i); }
#line 7994 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 722:
#line 2821 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->tx_priority = (yyvsp[0].i); }
#line 8000 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 723:
#line 2822 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = (yyvsp[0].i); }
#line 8006 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 724:
#line 2823 "cf-parse.y" /* yacc.c:1646  */
    { RIP_IPATT->ttl_security = 2; }
#line 8012 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 729:
#line 2837 "cf-parse.y" /* yacc.c:1646  */
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
#line 8026 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 731:
#line 2856 "cf-parse.y" /* yacc.c:1646  */
    {
     this_proto = proto_config_new(&proto_static, (yyvsp[-1].i));
     static_init_config((struct static_config *) this_proto);
  }
#line 8035 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 734:
#line 2865 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->check_link = (yyvsp[-1].i); }
#line 8041 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 735:
#line 2866 "cf-parse.y" /* yacc.c:1646  */
    { STATIC_CFG->igp_table = (yyvsp[-1].r); }
#line 8047 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 737:
#line 2870 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[0].px).addr;
     this_srt->masklen = (yyvsp[0].px).len;
  }
#line 8058 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 738:
#line 2879 "cf-parse.y" /* yacc.c:1646  */
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[-1].a);
     this_srt_nh->via_if = (yyvsp[0].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
#line 8071 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 739:
#line 2887 "cf-parse.y" /* yacc.c:1646  */
    {
     this_srt_nh->masklen = (yyvsp[0].i) - 1; /* really */
     if (((yyvsp[0].i)<1) || ((yyvsp[0].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
#line 8080 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 740:
#line 2894 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->mp_next = this_srt_nh; }
#line 8086 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 741:
#line 2895 "cf-parse.y" /* yacc.c:1646  */
    { last_srt_nh->mp_next = this_srt_nh; }
#line 8092 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 742:
#line 2899 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[-1].a);
      this_srt->via_if = (yyvsp[0].iface);
   }
#line 8102 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 743:
#line 2904 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[0].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
#line 8113 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 744:
#line 2910 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTD_MULTIPATH;
   }
#line 8121 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 745:
#line 2913 "cf-parse.y" /* yacc.c:1646  */
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[0].a);
   }
#line 8130 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 746:
#line 2918 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8136 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 747:
#line 2919 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8142 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 748:
#line 2920 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_BLACKHOLE; }
#line 8148 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 749:
#line 2921 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_UNREACHABLE; }
#line 8154 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 750:
#line 2922 "cf-parse.y" /* yacc.c:1646  */
    { this_srt->dest = RTD_PROHIBIT; }
#line 8160 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 751:
#line 2926 "cf-parse.y" /* yacc.c:1646  */
    { static_show(proto_get_named((yyvsp[-1].s), &proto_static)); }
#line 8166 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 819:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { bgp_check_config(BGP_CFG); }
#line 8172 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 820:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { ospf_proto_finish(); }
#line 8178 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 822:
#line 2934 "cf-parse.y" /* yacc.c:1646  */
    { RIP_CFG->passwords = get_passwords(); }
#line 8184 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 831:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
#line 8190 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 832:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
#line 8196 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 833:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
#line 8202 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 834:
#line 2937 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
#line 8208 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 835:
#line 2938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
#line 8214 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 836:
#line 2938 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = NULL; }
#line 8220 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 837:
#line 2939 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
#line 8226 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 838:
#line 2940 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
#line 8232 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 839:
#line 2941 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
#line 8238 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 840:
#line 2942 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
#line 8244 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 841:
#line 2943 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
#line 8250 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 842:
#line 2944 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
#line 8256 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 843:
#line 2945 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
#line 8262 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 844:
#line 2946 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
#line 8268 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 845:
#line 2947 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
#line 8274 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 846:
#line 2948 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
#line 8280 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 847:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
#line 8286 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 848:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
#line 8292 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 849:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
#line 8298 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 850:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
#line 8304 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 851:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
#line 8310 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 852:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
#line 8316 "cf-parse.tab.c" /* yacc.c:1646  */
    break;

  case 853:
#line 2949 "cf-parse.y" /* yacc.c:1646  */
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
#line 8322 "cf-parse.tab.c" /* yacc.c:1646  */
    break;


#line 8326 "cf-parse.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 2951 "cf-parse.y" /* yacc.c:1906  */

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

